(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('react'), require('prop-types')) :
  typeof define === 'function' && define.amd ? define(['react', 'prop-types'], factory) :
  (global.ReactDurationInputMask = factory(global.React,global.PropTypes));
}(this, (function (React,PropTypes) { 'use strict';

  var React__default = 'default' in React ? React['default'] : React;
  PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;

  function _classCallCheck(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
      throw new TypeError("Cannot call a class as a function");
    }
  }

  function _defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  function _createClass(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
  }

  function _defineProperty(obj, key, value) {
    if (key in obj) {
      Object.defineProperty(obj, key, {
        value: value,
        enumerable: true,
        configurable: true,
        writable: true
      });
    } else {
      obj[key] = value;
    }

    return obj;
  }

  function _extends() {
    _extends = Object.assign || function (target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i];

        for (var key in source) {
          if (Object.prototype.hasOwnProperty.call(source, key)) {
            target[key] = source[key];
          }
        }
      }

      return target;
    };

    return _extends.apply(this, arguments);
  }

  function ownKeys(object, enumerableOnly) {
    var keys = Object.keys(object);

    if (Object.getOwnPropertySymbols) {
      var symbols = Object.getOwnPropertySymbols(object);
      if (enumerableOnly) symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
      keys.push.apply(keys, symbols);
    }

    return keys;
  }

  function _objectSpread2(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i] != null ? arguments[i] : {};

      if (i % 2) {
        ownKeys(source, true).forEach(function (key) {
          _defineProperty(target, key, source[key]);
        });
      } else if (Object.getOwnPropertyDescriptors) {
        Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
      } else {
        ownKeys(source).forEach(function (key) {
          Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
        });
      }
    }

    return target;
  }

  function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
      throw new TypeError("Super expression must either be null or a function");
    }

    subClass.prototype = Object.create(superClass && superClass.prototype, {
      constructor: {
        value: subClass,
        writable: true,
        configurable: true
      }
    });
    if (superClass) _setPrototypeOf(subClass, superClass);
  }

  function _getPrototypeOf(o) {
    _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
      return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _getPrototypeOf(o);
  }

  function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
      o.__proto__ = p;
      return o;
    };

    return _setPrototypeOf(o, p);
  }

  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  function _construct(Parent, args, Class) {
    if (isNativeReflectConstruct()) {
      _construct = Reflect.construct;
    } else {
      _construct = function _construct(Parent, args, Class) {
        var a = [null];
        a.push.apply(a, args);
        var Constructor = Function.bind.apply(Parent, a);
        var instance = new Constructor();
        if (Class) _setPrototypeOf(instance, Class.prototype);
        return instance;
      };
    }

    return _construct.apply(null, arguments);
  }

  function _isNativeFunction(fn) {
    return Function.toString.call(fn).indexOf("[native code]") !== -1;
  }

  function _wrapNativeSuper(Class) {
    var _cache = typeof Map === "function" ? new Map() : undefined;

    _wrapNativeSuper = function _wrapNativeSuper(Class) {
      if (Class === null || !_isNativeFunction(Class)) return Class;

      if (typeof Class !== "function") {
        throw new TypeError("Super expression must either be null or a function");
      }

      if (typeof _cache !== "undefined") {
        if (_cache.has(Class)) return _cache.get(Class);

        _cache.set(Class, Wrapper);
      }

      function Wrapper() {
        return _construct(Class, arguments, _getPrototypeOf(this).constructor);
      }

      Wrapper.prototype = Object.create(Class.prototype, {
        constructor: {
          value: Wrapper,
          enumerable: false,
          writable: true,
          configurable: true
        }
      });
      return _setPrototypeOf(Wrapper, Class);
    };

    return _wrapNativeSuper(Class);
  }

  function _assertThisInitialized(self) {
    if (self === void 0) {
      throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }

    return self;
  }

  function _possibleConstructorReturn(self, call) {
    if (call && (typeof call === "object" || typeof call === "function")) {
      return call;
    }

    return _assertThisInitialized(self);
  }

  function _toConsumableArray(arr) {
    return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
  }

  function _arrayWithoutHoles(arr) {
    if (Array.isArray(arr)) {
      for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

      return arr2;
    }
  }

  function _iterableToArray(iter) {
    if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
  }

  function _nonIterableSpread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance");
  }

  function _wrapRegExp(re, groups) {
    _wrapRegExp = function (re, groups) {
      return new BabelRegExp(re, groups);
    };

    var _RegExp = _wrapNativeSuper(RegExp);

    var _super = RegExp.prototype;

    var _groups = new WeakMap();

    function BabelRegExp(re, groups) {
      var _this = _RegExp.call(this, re);

      _groups.set(_this, groups);

      return _this;
    }

    _inherits(BabelRegExp, _RegExp);

    BabelRegExp.prototype.exec = function (str) {
      var result = _super.exec.call(this, str);

      if (result) result.groups = buildGroups(result, this);
      return result;
    };

    BabelRegExp.prototype[Symbol.replace] = function (str, substitution) {
      if (typeof substitution === "string") {
        var groups = _groups.get(this);

        return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) {
          return "$" + groups[name];
        }));
      } else if (typeof substitution === "function") {
        var _this = this;

        return _super[Symbol.replace].call(this, str, function () {
          var args = [];
          args.push.apply(args, arguments);

          if (typeof args[args.length - 1] !== "object") {
            args.push(buildGroups(args, _this));
          }

          return substitution.apply(this, args);
        });
      } else {
        return _super[Symbol.replace].call(this, str, substitution);
      }
    };

    function buildGroups(result, re) {
      var g = _groups.get(re);

      return Object.keys(g).reduce(function (groups, name) {
        groups[name] = result[g[name]];
        return groups;
      }, Object.create(null));
    }

    return _wrapRegExp.apply(this, arguments);
  }

  /* eslint no-invalid-this: 1 */

  var ERROR_MESSAGE = 'Function.prototype.bind called on incompatible ';
  var slice = Array.prototype.slice;
  var toStr = Object.prototype.toString;
  var funcType = '[object Function]';

  var implementation = function bind(that) {
      var target = this;
      if (typeof target !== 'function' || toStr.call(target) !== funcType) {
          throw new TypeError(ERROR_MESSAGE + target);
      }
      var args = slice.call(arguments, 1);

      var bound;
      var binder = function () {
          if (this instanceof bound) {
              var result = target.apply(
                  this,
                  args.concat(slice.call(arguments))
              );
              if (Object(result) === result) {
                  return result;
              }
              return this;
          } else {
              return target.apply(
                  that,
                  args.concat(slice.call(arguments))
              );
          }
      };

      var boundLength = Math.max(0, target.length - args.length);
      var boundArgs = [];
      for (var i = 0; i < boundLength; i++) {
          boundArgs.push('$' + i);
      }

      bound = Function('binder', 'return function (' + boundArgs.join(',') + '){ return binder.apply(this,arguments); }')(binder);

      if (target.prototype) {
          var Empty = function Empty() {};
          Empty.prototype = target.prototype;
          bound.prototype = new Empty();
          Empty.prototype = null;
      }

      return bound;
  };

  var functionBind = Function.prototype.bind || implementation;

  var toStr$1 = Object.prototype.toString;

  var isArguments = function isArguments(value) {
  	var str = toStr$1.call(value);
  	var isArgs = str === '[object Arguments]';
  	if (!isArgs) {
  		isArgs = str !== '[object Array]' &&
  			value !== null &&
  			typeof value === 'object' &&
  			typeof value.length === 'number' &&
  			value.length >= 0 &&
  			toStr$1.call(value.callee) === '[object Function]';
  	}
  	return isArgs;
  };

  var keysShim;
  if (!Object.keys) {
  	// modified from https://github.com/es-shims/es5-shim
  	var has = Object.prototype.hasOwnProperty;
  	var toStr$2 = Object.prototype.toString;
  	var isArgs = isArguments; // eslint-disable-line global-require
  	var isEnumerable = Object.prototype.propertyIsEnumerable;
  	var hasDontEnumBug = !isEnumerable.call({ toString: null }, 'toString');
  	var hasProtoEnumBug = isEnumerable.call(function () {}, 'prototype');
  	var dontEnums = [
  		'toString',
  		'toLocaleString',
  		'valueOf',
  		'hasOwnProperty',
  		'isPrototypeOf',
  		'propertyIsEnumerable',
  		'constructor'
  	];
  	var equalsConstructorPrototype = function (o) {
  		var ctor = o.constructor;
  		return ctor && ctor.prototype === o;
  	};
  	var excludedKeys = {
  		$applicationCache: true,
  		$console: true,
  		$external: true,
  		$frame: true,
  		$frameElement: true,
  		$frames: true,
  		$innerHeight: true,
  		$innerWidth: true,
  		$onmozfullscreenchange: true,
  		$onmozfullscreenerror: true,
  		$outerHeight: true,
  		$outerWidth: true,
  		$pageXOffset: true,
  		$pageYOffset: true,
  		$parent: true,
  		$scrollLeft: true,
  		$scrollTop: true,
  		$scrollX: true,
  		$scrollY: true,
  		$self: true,
  		$webkitIndexedDB: true,
  		$webkitStorageInfo: true,
  		$window: true
  	};
  	var hasAutomationEqualityBug = (function () {
  		/* global window */
  		if (typeof window === 'undefined') { return false; }
  		for (var k in window) {
  			try {
  				if (!excludedKeys['$' + k] && has.call(window, k) && window[k] !== null && typeof window[k] === 'object') {
  					try {
  						equalsConstructorPrototype(window[k]);
  					} catch (e) {
  						return true;
  					}
  				}
  			} catch (e) {
  				return true;
  			}
  		}
  		return false;
  	}());
  	var equalsConstructorPrototypeIfNotBuggy = function (o) {
  		/* global window */
  		if (typeof window === 'undefined' || !hasAutomationEqualityBug) {
  			return equalsConstructorPrototype(o);
  		}
  		try {
  			return equalsConstructorPrototype(o);
  		} catch (e) {
  			return false;
  		}
  	};

  	keysShim = function keys(object) {
  		var isObject = object !== null && typeof object === 'object';
  		var isFunction = toStr$2.call(object) === '[object Function]';
  		var isArguments$$1 = isArgs(object);
  		var isString = isObject && toStr$2.call(object) === '[object String]';
  		var theKeys = [];

  		if (!isObject && !isFunction && !isArguments$$1) {
  			throw new TypeError('Object.keys called on a non-object');
  		}

  		var skipProto = hasProtoEnumBug && isFunction;
  		if (isString && object.length > 0 && !has.call(object, 0)) {
  			for (var i = 0; i < object.length; ++i) {
  				theKeys.push(String(i));
  			}
  		}

  		if (isArguments$$1 && object.length > 0) {
  			for (var j = 0; j < object.length; ++j) {
  				theKeys.push(String(j));
  			}
  		} else {
  			for (var name in object) {
  				if (!(skipProto && name === 'prototype') && has.call(object, name)) {
  					theKeys.push(String(name));
  				}
  			}
  		}

  		if (hasDontEnumBug) {
  			var skipConstructor = equalsConstructorPrototypeIfNotBuggy(object);

  			for (var k = 0; k < dontEnums.length; ++k) {
  				if (!(skipConstructor && dontEnums[k] === 'constructor') && has.call(object, dontEnums[k])) {
  					theKeys.push(dontEnums[k]);
  				}
  			}
  		}
  		return theKeys;
  	};
  }
  var implementation$1 = keysShim;

  var slice$1 = Array.prototype.slice;


  var origKeys = Object.keys;
  var keysShim$1 = origKeys ? function keys(o) { return origKeys(o); } : implementation$1;

  var originalKeys = Object.keys;

  keysShim$1.shim = function shimObjectKeys() {
  	if (Object.keys) {
  		var keysWorksWithArguments = (function () {
  			// Safari 5.0 bug
  			var args = Object.keys(arguments);
  			return args && args.length === arguments.length;
  		}(1, 2));
  		if (!keysWorksWithArguments) {
  			Object.keys = function keys(object) { // eslint-disable-line func-name-matching
  				if (isArguments(object)) {
  					return originalKeys(slice$1.call(object));
  				}
  				return originalKeys(object);
  			};
  		}
  	} else {
  		Object.keys = keysShim$1;
  	}
  	return Object.keys || keysShim$1;
  };

  var objectKeys = keysShim$1;

  var hasSymbols = typeof Symbol === 'function' && typeof Symbol('foo') === 'symbol';

  var toStr$3 = Object.prototype.toString;
  var concat = Array.prototype.concat;
  var origDefineProperty = Object.defineProperty;

  var isFunction = function (fn) {
  	return typeof fn === 'function' && toStr$3.call(fn) === '[object Function]';
  };

  var arePropertyDescriptorsSupported = function () {
  	var obj = {};
  	try {
  		origDefineProperty(obj, 'x', { enumerable: false, value: obj });
  		// eslint-disable-next-line no-unused-vars, no-restricted-syntax
  		for (var _ in obj) { // jscs:ignore disallowUnusedVariables
  			return false;
  		}
  		return obj.x === obj;
  	} catch (e) { /* this is IE 8. */
  		return false;
  	}
  };
  var supportsDescriptors = origDefineProperty && arePropertyDescriptorsSupported();

  var defineProperty = function (object, name, value, predicate) {
  	if (name in object && (!isFunction(predicate) || !predicate())) {
  		return;
  	}
  	if (supportsDescriptors) {
  		origDefineProperty(object, name, {
  			configurable: true,
  			enumerable: false,
  			value: value,
  			writable: true
  		});
  	} else {
  		object[name] = value;
  	}
  };

  var defineProperties = function (object, map) {
  	var predicates = arguments.length > 2 ? arguments[2] : {};
  	var props = objectKeys(map);
  	if (hasSymbols) {
  		props = concat.call(props, Object.getOwnPropertySymbols(map));
  	}
  	for (var i = 0; i < props.length; i += 1) {
  		defineProperty(object, props[i], map[props[i]], predicates[props[i]]);
  	}
  };

  defineProperties.supportsDescriptors = !!supportsDescriptors;

  var defineProperties_1 = defineProperties;

  var has$1 = functionBind.call(Function.call, Object.prototype.hasOwnProperty);

  var $assign = Object.assign;

  var assign = function assign(target, source) {
  	if ($assign) {
  		return $assign(target, source);
  	}

  	for (var key in source) {
  		if (has$1(source, key)) {
  			target[key] = source[key];
  		}
  	}
  	return target;
  };

  /* globals
  	Set,
  	Map,
  	WeakSet,
  	WeakMap,

  	Promise,

  	Symbol,
  	Proxy,

  	Atomics,
  	SharedArrayBuffer,

  	ArrayBuffer,
  	DataView,
  	Uint8Array,
  	Float32Array,
  	Float64Array,
  	Int8Array,
  	Int16Array,
  	Int32Array,
  	Uint8ClampedArray,
  	Uint16Array,
  	Uint32Array,
  */

  var undefined$1; // eslint-disable-line no-shadow-restricted-names

  var ThrowTypeError = Object.getOwnPropertyDescriptor
  	? (function () { return Object.getOwnPropertyDescriptor(arguments, 'callee').get; }())
  	: function () { throw new TypeError(); };

  var hasSymbols$1 = typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol';

  var getProto = Object.getPrototypeOf || function (x) { return x.__proto__; }; // eslint-disable-line no-proto
  var generatorFunction = undefined$1;
  var asyncFunction = undefined$1;
  var asyncGenFunction = undefined$1;

  var TypedArray = typeof Uint8Array === 'undefined' ? undefined$1 : getProto(Uint8Array);

  var INTRINSICS = {
  	'$ %Array%': Array,
  	'$ %ArrayBuffer%': typeof ArrayBuffer === 'undefined' ? undefined$1 : ArrayBuffer,
  	'$ %ArrayBufferPrototype%': typeof ArrayBuffer === 'undefined' ? undefined$1 : ArrayBuffer.prototype,
  	'$ %ArrayIteratorPrototype%': hasSymbols$1 ? getProto([][Symbol.iterator]()) : undefined$1,
  	'$ %ArrayPrototype%': Array.prototype,
  	'$ %ArrayProto_entries%': Array.prototype.entries,
  	'$ %ArrayProto_forEach%': Array.prototype.forEach,
  	'$ %ArrayProto_keys%': Array.prototype.keys,
  	'$ %ArrayProto_values%': Array.prototype.values,
  	'$ %AsyncFromSyncIteratorPrototype%': undefined$1,
  	'$ %AsyncFunction%': asyncFunction,
  	'$ %AsyncFunctionPrototype%': undefined$1,
  	'$ %AsyncGenerator%': undefined$1,
  	'$ %AsyncGeneratorFunction%': asyncGenFunction,
  	'$ %AsyncGeneratorPrototype%': undefined$1,
  	'$ %AsyncIteratorPrototype%': undefined$1,
  	'$ %Atomics%': typeof Atomics === 'undefined' ? undefined$1 : Atomics,
  	'$ %Boolean%': Boolean,
  	'$ %BooleanPrototype%': Boolean.prototype,
  	'$ %DataView%': typeof DataView === 'undefined' ? undefined$1 : DataView,
  	'$ %DataViewPrototype%': typeof DataView === 'undefined' ? undefined$1 : DataView.prototype,
  	'$ %Date%': Date,
  	'$ %DatePrototype%': Date.prototype,
  	'$ %decodeURI%': decodeURI,
  	'$ %decodeURIComponent%': decodeURIComponent,
  	'$ %encodeURI%': encodeURI,
  	'$ %encodeURIComponent%': encodeURIComponent,
  	'$ %Error%': Error,
  	'$ %ErrorPrototype%': Error.prototype,
  	'$ %eval%': eval, // eslint-disable-line no-eval
  	'$ %EvalError%': EvalError,
  	'$ %EvalErrorPrototype%': EvalError.prototype,
  	'$ %Float32Array%': typeof Float32Array === 'undefined' ? undefined$1 : Float32Array,
  	'$ %Float32ArrayPrototype%': typeof Float32Array === 'undefined' ? undefined$1 : Float32Array.prototype,
  	'$ %Float64Array%': typeof Float64Array === 'undefined' ? undefined$1 : Float64Array,
  	'$ %Float64ArrayPrototype%': typeof Float64Array === 'undefined' ? undefined$1 : Float64Array.prototype,
  	'$ %Function%': Function,
  	'$ %FunctionPrototype%': Function.prototype,
  	'$ %Generator%': undefined$1,
  	'$ %GeneratorFunction%': generatorFunction,
  	'$ %GeneratorPrototype%': undefined$1,
  	'$ %Int8Array%': typeof Int8Array === 'undefined' ? undefined$1 : Int8Array,
  	'$ %Int8ArrayPrototype%': typeof Int8Array === 'undefined' ? undefined$1 : Int8Array.prototype,
  	'$ %Int16Array%': typeof Int16Array === 'undefined' ? undefined$1 : Int16Array,
  	'$ %Int16ArrayPrototype%': typeof Int16Array === 'undefined' ? undefined$1 : Int8Array.prototype,
  	'$ %Int32Array%': typeof Int32Array === 'undefined' ? undefined$1 : Int32Array,
  	'$ %Int32ArrayPrototype%': typeof Int32Array === 'undefined' ? undefined$1 : Int32Array.prototype,
  	'$ %isFinite%': isFinite,
  	'$ %isNaN%': isNaN,
  	'$ %IteratorPrototype%': hasSymbols$1 ? getProto(getProto([][Symbol.iterator]())) : undefined$1,
  	'$ %JSON%': JSON,
  	'$ %JSONParse%': JSON.parse,
  	'$ %Map%': typeof Map === 'undefined' ? undefined$1 : Map,
  	'$ %MapIteratorPrototype%': typeof Map === 'undefined' || !hasSymbols$1 ? undefined$1 : getProto(new Map()[Symbol.iterator]()),
  	'$ %MapPrototype%': typeof Map === 'undefined' ? undefined$1 : Map.prototype,
  	'$ %Math%': Math,
  	'$ %Number%': Number,
  	'$ %NumberPrototype%': Number.prototype,
  	'$ %Object%': Object,
  	'$ %ObjectPrototype%': Object.prototype,
  	'$ %ObjProto_toString%': Object.prototype.toString,
  	'$ %ObjProto_valueOf%': Object.prototype.valueOf,
  	'$ %parseFloat%': parseFloat,
  	'$ %parseInt%': parseInt,
  	'$ %Promise%': typeof Promise === 'undefined' ? undefined$1 : Promise,
  	'$ %PromisePrototype%': typeof Promise === 'undefined' ? undefined$1 : Promise.prototype,
  	'$ %PromiseProto_then%': typeof Promise === 'undefined' ? undefined$1 : Promise.prototype.then,
  	'$ %Promise_all%': typeof Promise === 'undefined' ? undefined$1 : Promise.all,
  	'$ %Promise_reject%': typeof Promise === 'undefined' ? undefined$1 : Promise.reject,
  	'$ %Promise_resolve%': typeof Promise === 'undefined' ? undefined$1 : Promise.resolve,
  	'$ %Proxy%': typeof Proxy === 'undefined' ? undefined$1 : Proxy,
  	'$ %RangeError%': RangeError,
  	'$ %RangeErrorPrototype%': RangeError.prototype,
  	'$ %ReferenceError%': ReferenceError,
  	'$ %ReferenceErrorPrototype%': ReferenceError.prototype,
  	'$ %Reflect%': typeof Reflect === 'undefined' ? undefined$1 : Reflect,
  	'$ %RegExp%': RegExp,
  	'$ %RegExpPrototype%': RegExp.prototype,
  	'$ %Set%': typeof Set === 'undefined' ? undefined$1 : Set,
  	'$ %SetIteratorPrototype%': typeof Set === 'undefined' || !hasSymbols$1 ? undefined$1 : getProto(new Set()[Symbol.iterator]()),
  	'$ %SetPrototype%': typeof Set === 'undefined' ? undefined$1 : Set.prototype,
  	'$ %SharedArrayBuffer%': typeof SharedArrayBuffer === 'undefined' ? undefined$1 : SharedArrayBuffer,
  	'$ %SharedArrayBufferPrototype%': typeof SharedArrayBuffer === 'undefined' ? undefined$1 : SharedArrayBuffer.prototype,
  	'$ %String%': String,
  	'$ %StringIteratorPrototype%': hasSymbols$1 ? getProto(''[Symbol.iterator]()) : undefined$1,
  	'$ %StringPrototype%': String.prototype,
  	'$ %Symbol%': hasSymbols$1 ? Symbol : undefined$1,
  	'$ %SymbolPrototype%': hasSymbols$1 ? Symbol.prototype : undefined$1,
  	'$ %SyntaxError%': SyntaxError,
  	'$ %SyntaxErrorPrototype%': SyntaxError.prototype,
  	'$ %ThrowTypeError%': ThrowTypeError,
  	'$ %TypedArray%': TypedArray,
  	'$ %TypedArrayPrototype%': TypedArray ? TypedArray.prototype : undefined$1,
  	'$ %TypeError%': TypeError,
  	'$ %TypeErrorPrototype%': TypeError.prototype,
  	'$ %Uint8Array%': typeof Uint8Array === 'undefined' ? undefined$1 : Uint8Array,
  	'$ %Uint8ArrayPrototype%': typeof Uint8Array === 'undefined' ? undefined$1 : Uint8Array.prototype,
  	'$ %Uint8ClampedArray%': typeof Uint8ClampedArray === 'undefined' ? undefined$1 : Uint8ClampedArray,
  	'$ %Uint8ClampedArrayPrototype%': typeof Uint8ClampedArray === 'undefined' ? undefined$1 : Uint8ClampedArray.prototype,
  	'$ %Uint16Array%': typeof Uint16Array === 'undefined' ? undefined$1 : Uint16Array,
  	'$ %Uint16ArrayPrototype%': typeof Uint16Array === 'undefined' ? undefined$1 : Uint16Array.prototype,
  	'$ %Uint32Array%': typeof Uint32Array === 'undefined' ? undefined$1 : Uint32Array,
  	'$ %Uint32ArrayPrototype%': typeof Uint32Array === 'undefined' ? undefined$1 : Uint32Array.prototype,
  	'$ %URIError%': URIError,
  	'$ %URIErrorPrototype%': URIError.prototype,
  	'$ %WeakMap%': typeof WeakMap === 'undefined' ? undefined$1 : WeakMap,
  	'$ %WeakMapPrototype%': typeof WeakMap === 'undefined' ? undefined$1 : WeakMap.prototype,
  	'$ %WeakSet%': typeof WeakSet === 'undefined' ? undefined$1 : WeakSet,
  	'$ %WeakSetPrototype%': typeof WeakSet === 'undefined' ? undefined$1 : WeakSet.prototype
  };

  var GetIntrinsic = function GetIntrinsic(name, allowMissing) {
  	if (arguments.length > 1 && typeof allowMissing !== 'boolean') {
  		throw new TypeError('"allowMissing" argument must be a boolean');
  	}

  	var key = '$ ' + name;
  	if (!(key in INTRINSICS)) {
  		throw new SyntaxError('intrinsic ' + name + ' does not exist!');
  	}

  	// istanbul ignore if // hopefully this is impossible to test :-)
  	if (typeof INTRINSICS[key] === 'undefined' && !allowMissing) {
  		throw new TypeError('intrinsic ' + name + ' exists, but is not available. Please file an issue!');
  	}
  	return INTRINSICS[key];
  };

  var src = functionBind.call(Function.call, Object.prototype.hasOwnProperty);

  var $TypeError = GetIntrinsic('%TypeError%');
  var $SyntaxError = GetIntrinsic('%SyntaxError%');



  var predicates = {
    // https://ecma-international.org/ecma-262/6.0/#sec-property-descriptor-specification-type
    'Property Descriptor': function isPropertyDescriptor(ES, Desc) {
      if (ES.Type(Desc) !== 'Object') {
        return false;
      }
      var allowed = {
        '[[Configurable]]': true,
        '[[Enumerable]]': true,
        '[[Get]]': true,
        '[[Set]]': true,
        '[[Value]]': true,
        '[[Writable]]': true
      };

      for (var key in Desc) { // eslint-disable-line
        if (src(Desc, key) && !allowed[key]) {
          return false;
        }
      }

      var isData = src(Desc, '[[Value]]');
      var IsAccessor = src(Desc, '[[Get]]') || src(Desc, '[[Set]]');
      if (isData && IsAccessor) {
        throw new $TypeError('Property Descriptors may not be both accessor and data descriptors');
      }
      return true;
    }
  };

  var assertRecord = function assertRecord(ES, recordType, argumentName, value) {
    var predicate = predicates[recordType];
    if (typeof predicate !== 'function') {
      throw new $SyntaxError('unknown record type: ' + recordType);
    }
    if (!predicate(ES, value)) {
      throw new $TypeError(argumentName + ' must be a ' + recordType);
    }
    console.log(predicate(ES, value), value);
  };

  var _isNaN = Number.isNaN || function isNaN(a) {
  	return a !== a;
  };

  var $isNaN = Number.isNaN || function (a) { return a !== a; };

  var _isFinite = Number.isFinite || function (x) { return typeof x === 'number' && !$isNaN(x) && x !== Infinity && x !== -Infinity; };

  var sign = function sign(number) {
  	return number >= 0 ? 1 : -1;
  };

  var mod = function mod(number, modulo) {
  	var remain = number % modulo;
  	return Math.floor(remain >= 0 ? remain : remain + modulo);
  };

  var fnToStr = Function.prototype.toString;

  var constructorRegex = /^\s*class\b/;
  var isES6ClassFn = function isES6ClassFunction(value) {
  	try {
  		var fnStr = fnToStr.call(value);
  		return constructorRegex.test(fnStr);
  	} catch (e) {
  		return false; // not a function
  	}
  };

  var tryFunctionObject = function tryFunctionToStr(value) {
  	try {
  		if (isES6ClassFn(value)) { return false; }
  		fnToStr.call(value);
  		return true;
  	} catch (e) {
  		return false;
  	}
  };
  var toStr$4 = Object.prototype.toString;
  var fnClass = '[object Function]';
  var genClass = '[object GeneratorFunction]';
  var hasToStringTag = typeof Symbol === 'function' && typeof Symbol.toStringTag === 'symbol';

  var isCallable = function isCallable(value) {
  	if (!value) { return false; }
  	if (typeof value !== 'function' && typeof value !== 'object') { return false; }
  	if (typeof value === 'function' && !value.prototype) { return true; }
  	if (hasToStringTag) { return tryFunctionObject(value); }
  	if (isES6ClassFn(value)) { return false; }
  	var strClass = toStr$4.call(value);
  	return strClass === fnClass || strClass === genClass;
  };

  var isPrimitive = function isPrimitive(value) {
  	return value === null || (typeof value !== 'function' && typeof value !== 'object');
  };

  var toStr$5 = Object.prototype.toString;





  // http://ecma-international.org/ecma-262/5.1/#sec-8.12.8
  var ES5internalSlots = {
  	'[[DefaultValue]]': function (O) {
  		var actualHint;
  		if (arguments.length > 1) {
  			actualHint = arguments[1];
  		} else {
  			actualHint = toStr$5.call(O) === '[object Date]' ? String : Number;
  		}

  		if (actualHint === String || actualHint === Number) {
  			var methods = actualHint === String ? ['toString', 'valueOf'] : ['valueOf', 'toString'];
  			var value, i;
  			for (i = 0; i < methods.length; ++i) {
  				if (isCallable(O[methods[i]])) {
  					value = O[methods[i]]();
  					if (isPrimitive(value)) {
  						return value;
  					}
  				}
  			}
  			throw new TypeError('No default value');
  		}
  		throw new TypeError('invalid [[DefaultValue]] hint supplied');
  	}
  };

  // http://ecma-international.org/ecma-262/5.1/#sec-9.1
  var es5 = function ToPrimitive(input) {
  	if (isPrimitive(input)) {
  		return input;
  	}
  	if (arguments.length > 1) {
  		return ES5internalSlots['[[DefaultValue]]'](input, arguments[1]);
  	}
  	return ES5internalSlots['[[DefaultValue]]'](input);
  };

  var $Object = GetIntrinsic('%Object%');
  var $TypeError$1 = GetIntrinsic('%TypeError%');
  var $String = GetIntrinsic('%String%');













  // https://es5.github.io/#x9
  var ES5 = {
  	ToPrimitive: es5,

  	ToBoolean: function ToBoolean(value) {
  		return !!value;
  	},
  	ToNumber: function ToNumber(value) {
  		return +value; // eslint-disable-line no-implicit-coercion
  	},
  	ToInteger: function ToInteger(value) {
  		var number = this.ToNumber(value);
  		if (_isNaN(number)) { return 0; }
  		if (number === 0 || !_isFinite(number)) { return number; }
  		return sign(number) * Math.floor(Math.abs(number));
  	},
  	ToInt32: function ToInt32(x) {
  		return this.ToNumber(x) >> 0;
  	},
  	ToUint32: function ToUint32(x) {
  		return this.ToNumber(x) >>> 0;
  	},
  	ToUint16: function ToUint16(value) {
  		var number = this.ToNumber(value);
  		if (_isNaN(number) || number === 0 || !_isFinite(number)) { return 0; }
  		var posInt = sign(number) * Math.floor(Math.abs(number));
  		return mod(posInt, 0x10000);
  	},
  	ToString: function ToString(value) {
  		return $String(value);
  	},
  	ToObject: function ToObject(value) {
  		this.CheckObjectCoercible(value);
  		return $Object(value);
  	},
  	CheckObjectCoercible: function CheckObjectCoercible(value, optMessage) {
  		/* jshint eqnull:true */
  		if (value == null) {
  			throw new $TypeError$1(optMessage || 'Cannot call method on ' + value);
  		}
  		return value;
  	},
  	IsCallable: isCallable,
  	SameValue: function SameValue(x, y) {
  		if (x === y) { // 0 === -0, but they are not identical.
  			if (x === 0) { return 1 / x === 1 / y; }
  			return true;
  		}
  		return _isNaN(x) && _isNaN(y);
  	},

  	// https://www.ecma-international.org/ecma-262/5.1/#sec-8
  	Type: function Type(x) {
  		if (x === null) {
  			return 'Null';
  		}
  		if (typeof x === 'undefined') {
  			return 'Undefined';
  		}
  		if (typeof x === 'function' || typeof x === 'object') {
  			return 'Object';
  		}
  		if (typeof x === 'number') {
  			return 'Number';
  		}
  		if (typeof x === 'boolean') {
  			return 'Boolean';
  		}
  		if (typeof x === 'string') {
  			return 'String';
  		}
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-property-descriptor-specification-type
  	IsPropertyDescriptor: function IsPropertyDescriptor(Desc) {
  		if (this.Type(Desc) !== 'Object') {
  			return false;
  		}
  		var allowed = {
  			'[[Configurable]]': true,
  			'[[Enumerable]]': true,
  			'[[Get]]': true,
  			'[[Set]]': true,
  			'[[Value]]': true,
  			'[[Writable]]': true
  		};

  		for (var key in Desc) { // eslint-disable-line
  			if (src(Desc, key) && !allowed[key]) {
  				return false;
  			}
  		}

  		var isData = src(Desc, '[[Value]]');
  		var IsAccessor = src(Desc, '[[Get]]') || src(Desc, '[[Set]]');
  		if (isData && IsAccessor) {
  			throw new $TypeError$1('Property Descriptors may not be both accessor and data descriptors');
  		}
  		return true;
  	},

  	// https://ecma-international.org/ecma-262/5.1/#sec-8.10.1
  	IsAccessorDescriptor: function IsAccessorDescriptor(Desc) {
  		if (typeof Desc === 'undefined') {
  			return false;
  		}

  		assertRecord(this, 'Property Descriptor', 'Desc', Desc);

  		if (!src(Desc, '[[Get]]') && !src(Desc, '[[Set]]')) {
  			return false;
  		}

  		return true;
  	},

  	// https://ecma-international.org/ecma-262/5.1/#sec-8.10.2
  	IsDataDescriptor: function IsDataDescriptor(Desc) {
  		if (typeof Desc === 'undefined') {
  			return false;
  		}

  		assertRecord(this, 'Property Descriptor', 'Desc', Desc);

  		if (!src(Desc, '[[Value]]') && !src(Desc, '[[Writable]]')) {
  			return false;
  		}

  		return true;
  	},

  	// https://ecma-international.org/ecma-262/5.1/#sec-8.10.3
  	IsGenericDescriptor: function IsGenericDescriptor(Desc) {
  		if (typeof Desc === 'undefined') {
  			return false;
  		}

  		assertRecord(this, 'Property Descriptor', 'Desc', Desc);

  		if (!this.IsAccessorDescriptor(Desc) && !this.IsDataDescriptor(Desc)) {
  			return true;
  		}

  		return false;
  	},

  	// https://ecma-international.org/ecma-262/5.1/#sec-8.10.4
  	FromPropertyDescriptor: function FromPropertyDescriptor(Desc) {
  		if (typeof Desc === 'undefined') {
  			return Desc;
  		}

  		assertRecord(this, 'Property Descriptor', 'Desc', Desc);

  		if (this.IsDataDescriptor(Desc)) {
  			return {
  				value: Desc['[[Value]]'],
  				writable: !!Desc['[[Writable]]'],
  				enumerable: !!Desc['[[Enumerable]]'],
  				configurable: !!Desc['[[Configurable]]']
  			};
  		} else if (this.IsAccessorDescriptor(Desc)) {
  			return {
  				get: Desc['[[Get]]'],
  				set: Desc['[[Set]]'],
  				enumerable: !!Desc['[[Enumerable]]'],
  				configurable: !!Desc['[[Configurable]]']
  			};
  		} else {
  			throw new $TypeError$1('FromPropertyDescriptor must be called with a fully populated Property Descriptor');
  		}
  	},

  	// https://ecma-international.org/ecma-262/5.1/#sec-8.10.5
  	ToPropertyDescriptor: function ToPropertyDescriptor(Obj) {
  		if (this.Type(Obj) !== 'Object') {
  			throw new $TypeError$1('ToPropertyDescriptor requires an object');
  		}

  		var desc = {};
  		if (src(Obj, 'enumerable')) {
  			desc['[[Enumerable]]'] = this.ToBoolean(Obj.enumerable);
  		}
  		if (src(Obj, 'configurable')) {
  			desc['[[Configurable]]'] = this.ToBoolean(Obj.configurable);
  		}
  		if (src(Obj, 'value')) {
  			desc['[[Value]]'] = Obj.value;
  		}
  		if (src(Obj, 'writable')) {
  			desc['[[Writable]]'] = this.ToBoolean(Obj.writable);
  		}
  		if (src(Obj, 'get')) {
  			var getter = Obj.get;
  			if (typeof getter !== 'undefined' && !this.IsCallable(getter)) {
  				throw new TypeError('getter must be a function');
  			}
  			desc['[[Get]]'] = getter;
  		}
  		if (src(Obj, 'set')) {
  			var setter = Obj.set;
  			if (typeof setter !== 'undefined' && !this.IsCallable(setter)) {
  				throw new $TypeError$1('setter must be a function');
  			}
  			desc['[[Set]]'] = setter;
  		}

  		if ((src(desc, '[[Get]]') || src(desc, '[[Set]]')) && (src(desc, '[[Value]]') || src(desc, '[[Writable]]'))) {
  			throw new $TypeError$1('Invalid property descriptor. Cannot both specify accessors and a value or writable attribute');
  		}
  		return desc;
  	}
  };

  var es5$1 = ES5;

  var getDay = Date.prototype.getDay;
  var tryDateObject = function tryDateObject(value) {
  	try {
  		getDay.call(value);
  		return true;
  	} catch (e) {
  		return false;
  	}
  };

  var toStr$6 = Object.prototype.toString;
  var dateClass = '[object Date]';
  var hasToStringTag$1 = typeof Symbol === 'function' && typeof Symbol.toStringTag === 'symbol';

  var isDateObject = function isDateObject(value) {
  	if (typeof value !== 'object' || value === null) { return false; }
  	return hasToStringTag$1 ? tryDateObject(value) : toStr$6.call(value) === dateClass;
  };

  var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

  function createCommonjsModule(fn, module) {
  	return module = { exports: {} }, fn(module, module.exports), module.exports;
  }

  /* eslint complexity: [2, 17], max-statements: [2, 33] */
  var shams = function hasSymbols() {
  	if (typeof Symbol !== 'function' || typeof Object.getOwnPropertySymbols !== 'function') { return false; }
  	if (typeof Symbol.iterator === 'symbol') { return true; }

  	var obj = {};
  	var sym = Symbol('test');
  	var symObj = Object(sym);
  	if (typeof sym === 'string') { return false; }

  	if (Object.prototype.toString.call(sym) !== '[object Symbol]') { return false; }
  	if (Object.prototype.toString.call(symObj) !== '[object Symbol]') { return false; }

  	// temp disabled per https://github.com/ljharb/object.assign/issues/17
  	// if (sym instanceof Symbol) { return false; }
  	// temp disabled per https://github.com/WebReflection/get-own-property-symbols/issues/4
  	// if (!(symObj instanceof Symbol)) { return false; }

  	// if (typeof Symbol.prototype.toString !== 'function') { return false; }
  	// if (String(sym) !== Symbol.prototype.toString.call(sym)) { return false; }

  	var symVal = 42;
  	obj[sym] = symVal;
  	for (sym in obj) { return false; } // eslint-disable-line no-restricted-syntax
  	if (typeof Object.keys === 'function' && Object.keys(obj).length !== 0) { return false; }

  	if (typeof Object.getOwnPropertyNames === 'function' && Object.getOwnPropertyNames(obj).length !== 0) { return false; }

  	var syms = Object.getOwnPropertySymbols(obj);
  	if (syms.length !== 1 || syms[0] !== sym) { return false; }

  	if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) { return false; }

  	if (typeof Object.getOwnPropertyDescriptor === 'function') {
  		var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
  		if (descriptor.value !== symVal || descriptor.enumerable !== true) { return false; }
  	}

  	return true;
  };

  var origSymbol = commonjsGlobal.Symbol;


  var hasSymbols$2 = function hasNativeSymbols() {
  	if (typeof origSymbol !== 'function') { return false; }
  	if (typeof Symbol !== 'function') { return false; }
  	if (typeof origSymbol('foo') !== 'symbol') { return false; }
  	if (typeof Symbol('bar') !== 'symbol') { return false; }

  	return shams();
  };

  var isSymbol = createCommonjsModule(function (module) {

  var toStr = Object.prototype.toString;
  var hasSymbols = hasSymbols$2();

  if (hasSymbols) {
  	var symToStr = Symbol.prototype.toString;
  	var symStringRegex = /^Symbol\(.*\)$/;
  	var isSymbolObject = function isRealSymbolObject(value) {
  		if (typeof value.valueOf() !== 'symbol') {
  			return false;
  		}
  		return symStringRegex.test(symToStr.call(value));
  	};

  	module.exports = function isSymbol(value) {
  		if (typeof value === 'symbol') {
  			return true;
  		}
  		if (toStr.call(value) !== '[object Symbol]') {
  			return false;
  		}
  		try {
  			return isSymbolObject(value);
  		} catch (e) {
  			return false;
  		}
  	};
  } else {

  	module.exports = function isSymbol(value) {
  		// this environment does not support Symbols.
  		return false;
  	};
  }
  });

  var hasSymbols$3 = typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol';






  var ordinaryToPrimitive = function OrdinaryToPrimitive(O, hint) {
  	if (typeof O === 'undefined' || O === null) {
  		throw new TypeError('Cannot call method on ' + O);
  	}
  	if (typeof hint !== 'string' || (hint !== 'number' && hint !== 'string')) {
  		throw new TypeError('hint must be "string" or "number"');
  	}
  	var methodNames = hint === 'string' ? ['toString', 'valueOf'] : ['valueOf', 'toString'];
  	var method, result, i;
  	for (i = 0; i < methodNames.length; ++i) {
  		method = O[methodNames[i]];
  		if (isCallable(method)) {
  			result = method.call(O);
  			if (isPrimitive(result)) {
  				return result;
  			}
  		}
  	}
  	throw new TypeError('No default value');
  };

  var GetMethod = function GetMethod(O, P) {
  	var func = O[P];
  	if (func !== null && typeof func !== 'undefined') {
  		if (!isCallable(func)) {
  			throw new TypeError(func + ' returned for property ' + P + ' of object ' + O + ' is not a function');
  		}
  		return func;
  	}
  	return void 0;
  };

  // http://www.ecma-international.org/ecma-262/6.0/#sec-toprimitive
  var es2015 = function ToPrimitive(input) {
  	if (isPrimitive(input)) {
  		return input;
  	}
  	var hint = 'default';
  	if (arguments.length > 1) {
  		if (arguments[1] === String) {
  			hint = 'string';
  		} else if (arguments[1] === Number) {
  			hint = 'number';
  		}
  	}

  	var exoticToPrim;
  	if (hasSymbols$3) {
  		if (Symbol.toPrimitive) {
  			exoticToPrim = GetMethod(input, Symbol.toPrimitive);
  		} else if (isSymbol(input)) {
  			exoticToPrim = Symbol.prototype.valueOf;
  		}
  	}
  	if (typeof exoticToPrim !== 'undefined') {
  		var result = exoticToPrim.call(input, hint);
  		if (isPrimitive(result)) {
  			return result;
  		}
  		throw new TypeError('unable to convert exotic object to primitive');
  	}
  	if (hint === 'default' && (isDateObject(input) || isSymbol(input))) {
  		hint = 'string';
  	}
  	return ordinaryToPrimitive(input, hint === 'default' ? 'number' : hint);
  };

  var es6 = es2015;

  var isPrimitive$1 = function isPrimitive(value) {
  	return value === null || (typeof value !== 'function' && typeof value !== 'object');
  };

  var regexExec = RegExp.prototype.exec;
  var gOPD = Object.getOwnPropertyDescriptor;

  var tryRegexExecCall = function tryRegexExec(value) {
  	try {
  		var lastIndex = value.lastIndex;
  		value.lastIndex = 0;

  		regexExec.call(value);
  		return true;
  	} catch (e) {
  		return false;
  	} finally {
  		value.lastIndex = lastIndex;
  	}
  };
  var toStr$7 = Object.prototype.toString;
  var regexClass = '[object RegExp]';
  var hasToStringTag$2 = typeof Symbol === 'function' && typeof Symbol.toStringTag === 'symbol';

  var isRegex = function isRegex(value) {
  	if (!value || typeof value !== 'object') {
  		return false;
  	}
  	if (!hasToStringTag$2) {
  		return toStr$7.call(value) === regexClass;
  	}

  	var descriptor = gOPD(value, 'lastIndex');
  	var hasLastIndexDataProperty = descriptor && src(descriptor, 'value');
  	if (!hasLastIndexDataProperty) {
  		return false;
  	}

  	return tryRegexExecCall(value);
  };

  var $TypeError$2 = GetIntrinsic('%TypeError%');
  var $SyntaxError$1 = GetIntrinsic('%SyntaxError%');
  var $Array = GetIntrinsic('%Array%');
  var $String$1 = GetIntrinsic('%String%');
  var $Object$1 = GetIntrinsic('%Object%');
  var $Number = GetIntrinsic('%Number%');
  var $Symbol = GetIntrinsic('%Symbol%', true);
  var $RegExp = GetIntrinsic('%RegExp%');

  var hasSymbols$4 = !!$Symbol;




  var MAX_SAFE_INTEGER = $Number.MAX_SAFE_INTEGER || Math.pow(2, 53) - 1;





  var parseInteger = parseInt;

  var arraySlice = functionBind.call(Function.call, $Array.prototype.slice);
  var strSlice = functionBind.call(Function.call, $String$1.prototype.slice);
  var isBinary = functionBind.call(Function.call, $RegExp.prototype.test, /^0b[01]+$/i);
  var isOctal = functionBind.call(Function.call, $RegExp.prototype.test, /^0o[0-7]+$/i);
  var regexExec$1 = functionBind.call(Function.call, $RegExp.prototype.exec);
  var nonWS = ['\u0085', '\u200b', '\ufffe'].join('');
  var nonWSregex = new $RegExp('[' + nonWS + ']', 'g');
  var hasNonWS = functionBind.call(Function.call, $RegExp.prototype.test, nonWSregex);
  var invalidHexLiteral = /^[-+]0x[0-9a-f]+$/i;
  var isInvalidHexLiteral = functionBind.call(Function.call, $RegExp.prototype.test, invalidHexLiteral);
  var $charCodeAt = functionBind.call(Function.call, $String$1.prototype.charCodeAt);

  var toStr$8 = functionBind.call(Function.call, Object.prototype.toString);

  var $NumberValueOf = functionBind.call(Function.call, GetIntrinsic('%NumberPrototype%').valueOf);
  var $BooleanValueOf = functionBind.call(Function.call, GetIntrinsic('%BooleanPrototype%').valueOf);
  var $StringValueOf = functionBind.call(Function.call, GetIntrinsic('%StringPrototype%').valueOf);
  var $DateValueOf = functionBind.call(Function.call, GetIntrinsic('%DatePrototype%').valueOf);

  var $floor = Math.floor;
  var $abs = Math.abs;

  var $ObjectCreate = Object.create;
  var $gOPD = $Object$1.getOwnPropertyDescriptor;

  var $isExtensible = $Object$1.isExtensible;

  var $defineProperty = $Object$1.defineProperty;

  // whitespace from: http://es5.github.io/#x15.5.4.20
  // implementation from https://github.com/es-shims/es5-shim/blob/v3.4.0/es5-shim.js#L1304-L1324
  var ws = [
  	'\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u180E\u2000\u2001\u2002\u2003',
  	'\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028',
  	'\u2029\uFEFF'
  ].join('');
  var trimRegex = new RegExp('(^[' + ws + ']+)|([' + ws + ']+$)', 'g');
  var replace = functionBind.call(Function.call, $String$1.prototype.replace);
  var trim = function (value) {
  	return replace(value, trimRegex, '');
  };





  // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-abstract-operations
  var ES6 = assign(assign({}, es5$1), {

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-call-f-v-args
  	Call: function Call(F, V) {
  		var args = arguments.length > 2 ? arguments[2] : [];
  		if (!this.IsCallable(F)) {
  			throw new $TypeError$2(F + ' is not a function');
  		}
  		return F.apply(V, args);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toprimitive
  	ToPrimitive: es6,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toboolean
  	// ToBoolean: ES5.ToBoolean,

  	// https://ecma-international.org/ecma-262/6.0/#sec-tonumber
  	ToNumber: function ToNumber(argument) {
  		var value = isPrimitive$1(argument) ? argument : es6(argument, $Number);
  		if (typeof value === 'symbol') {
  			throw new $TypeError$2('Cannot convert a Symbol value to a number');
  		}
  		if (typeof value === 'string') {
  			if (isBinary(value)) {
  				return this.ToNumber(parseInteger(strSlice(value, 2), 2));
  			} else if (isOctal(value)) {
  				return this.ToNumber(parseInteger(strSlice(value, 2), 8));
  			} else if (hasNonWS(value) || isInvalidHexLiteral(value)) {
  				return NaN;
  			} else {
  				var trimmed = trim(value);
  				if (trimmed !== value) {
  					return this.ToNumber(trimmed);
  				}
  			}
  		}
  		return $Number(value);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-tointeger
  	// ToInteger: ES5.ToNumber,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toint32
  	// ToInt32: ES5.ToInt32,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-touint32
  	// ToUint32: ES5.ToUint32,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toint16
  	ToInt16: function ToInt16(argument) {
  		var int16bit = this.ToUint16(argument);
  		return int16bit >= 0x8000 ? int16bit - 0x10000 : int16bit;
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-touint16
  	// ToUint16: ES5.ToUint16,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toint8
  	ToInt8: function ToInt8(argument) {
  		var int8bit = this.ToUint8(argument);
  		return int8bit >= 0x80 ? int8bit - 0x100 : int8bit;
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-touint8
  	ToUint8: function ToUint8(argument) {
  		var number = this.ToNumber(argument);
  		if (_isNaN(number) || number === 0 || !_isFinite(number)) { return 0; }
  		var posInt = sign(number) * $floor($abs(number));
  		return mod(posInt, 0x100);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-touint8clamp
  	ToUint8Clamp: function ToUint8Clamp(argument) {
  		var number = this.ToNumber(argument);
  		if (_isNaN(number) || number <= 0) { return 0; }
  		if (number >= 0xFF) { return 0xFF; }
  		var f = $floor(argument);
  		if (f + 0.5 < number) { return f + 1; }
  		if (number < f + 0.5) { return f; }
  		if (f % 2 !== 0) { return f + 1; }
  		return f;
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-tostring
  	ToString: function ToString(argument) {
  		if (typeof argument === 'symbol') {
  			throw new $TypeError$2('Cannot convert a Symbol value to a string');
  		}
  		return $String$1(argument);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-toobject
  	ToObject: function ToObject(value) {
  		this.RequireObjectCoercible(value);
  		return $Object$1(value);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-topropertykey
  	ToPropertyKey: function ToPropertyKey(argument) {
  		var key = this.ToPrimitive(argument, $String$1);
  		return typeof key === 'symbol' ? key : this.ToString(key);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-tolength
  	ToLength: function ToLength(argument) {
  		var len = this.ToInteger(argument);
  		if (len <= 0) { return 0; } // includes converting -0 to +0
  		if (len > MAX_SAFE_INTEGER) { return MAX_SAFE_INTEGER; }
  		return len;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-canonicalnumericindexstring
  	CanonicalNumericIndexString: function CanonicalNumericIndexString(argument) {
  		if (toStr$8(argument) !== '[object String]') {
  			throw new $TypeError$2('must be a string');
  		}
  		if (argument === '-0') { return -0; }
  		var n = this.ToNumber(argument);
  		if (this.SameValue(this.ToString(n), argument)) { return n; }
  		return void 0;
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-requireobjectcoercible
  	RequireObjectCoercible: es5$1.CheckObjectCoercible,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-isarray
  	IsArray: $Array.isArray || function IsArray(argument) {
  		return toStr$8(argument) === '[object Array]';
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-iscallable
  	// IsCallable: ES5.IsCallable,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-isconstructor
  	IsConstructor: function IsConstructor(argument) {
  		return typeof argument === 'function' && !!argument.prototype; // unfortunately there's no way to truly check this without try/catch `new argument`
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-isextensible-o
  	IsExtensible: Object.preventExtensions
  		? function IsExtensible(obj) {
  			if (isPrimitive$1(obj)) {
  				return false;
  			}
  			return $isExtensible(obj);
  		}
  		: function isExtensible(obj) { return true; }, // eslint-disable-line no-unused-vars

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-isinteger
  	IsInteger: function IsInteger(argument) {
  		if (typeof argument !== 'number' || _isNaN(argument) || !_isFinite(argument)) {
  			return false;
  		}
  		var abs = $abs(argument);
  		return $floor(abs) === abs;
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-ispropertykey
  	IsPropertyKey: function IsPropertyKey(argument) {
  		return typeof argument === 'string' || typeof argument === 'symbol';
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-isregexp
  	IsRegExp: function IsRegExp(argument) {
  		if (!argument || typeof argument !== 'object') {
  			return false;
  		}
  		if (hasSymbols$4) {
  			var isRegExp = argument[$Symbol.match];
  			if (typeof isRegExp !== 'undefined') {
  				return es5$1.ToBoolean(isRegExp);
  			}
  		}
  		return isRegex(argument);
  	},

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-samevalue
  	// SameValue: ES5.SameValue,

  	// https://people.mozilla.org/~jorendorff/es6-draft.html#sec-samevaluezero
  	SameValueZero: function SameValueZero(x, y) {
  		return (x === y) || (_isNaN(x) && _isNaN(y));
  	},

  	/**
  	 * 7.3.2 GetV (V, P)
  	 * 1. Assert: IsPropertyKey(P) is true.
  	 * 2. Let O be ToObject(V).
  	 * 3. ReturnIfAbrupt(O).
  	 * 4. Return O.[[Get]](P, V).
  	 */
  	GetV: function GetV(V, P) {
  		// 7.3.2.1
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}

  		// 7.3.2.2-3
  		var O = this.ToObject(V);

  		// 7.3.2.4
  		return O[P];
  	},

  	/**
  	 * 7.3.9 - https://ecma-international.org/ecma-262/6.0/#sec-getmethod
  	 * 1. Assert: IsPropertyKey(P) is true.
  	 * 2. Let func be GetV(O, P).
  	 * 3. ReturnIfAbrupt(func).
  	 * 4. If func is either undefined or null, return undefined.
  	 * 5. If IsCallable(func) is false, throw a TypeError exception.
  	 * 6. Return func.
  	 */
  	GetMethod: function GetMethod(O, P) {
  		// 7.3.9.1
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}

  		// 7.3.9.2
  		var func = this.GetV(O, P);

  		// 7.3.9.4
  		if (func == null) {
  			return void 0;
  		}

  		// 7.3.9.5
  		if (!this.IsCallable(func)) {
  			throw new $TypeError$2(P + 'is not a function');
  		}

  		// 7.3.9.6
  		return func;
  	},

  	/**
  	 * 7.3.1 Get (O, P) - https://ecma-international.org/ecma-262/6.0/#sec-get-o-p
  	 * 1. Assert: Type(O) is Object.
  	 * 2. Assert: IsPropertyKey(P) is true.
  	 * 3. Return O.[[Get]](P, O).
  	 */
  	Get: function Get(O, P) {
  		// 7.3.1.1
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}
  		// 7.3.1.2
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}
  		// 7.3.1.3
  		return O[P];
  	},

  	Type: function Type(x) {
  		if (typeof x === 'symbol') {
  			return 'Symbol';
  		}
  		return es5$1.Type(x);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-speciesconstructor
  	SpeciesConstructor: function SpeciesConstructor(O, defaultConstructor) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}
  		var C = O.constructor;
  		if (typeof C === 'undefined') {
  			return defaultConstructor;
  		}
  		if (this.Type(C) !== 'Object') {
  			throw new $TypeError$2('O.constructor is not an Object');
  		}
  		var S = hasSymbols$4 && $Symbol.species ? C[$Symbol.species] : void 0;
  		if (S == null) {
  			return defaultConstructor;
  		}
  		if (this.IsConstructor(S)) {
  			return S;
  		}
  		throw new $TypeError$2('no constructor found');
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-completepropertydescriptor
  	CompletePropertyDescriptor: function CompletePropertyDescriptor(Desc) {
  		assertRecord(this, 'Property Descriptor', 'Desc', Desc);

  		if (this.IsGenericDescriptor(Desc) || this.IsDataDescriptor(Desc)) {
  			if (!src(Desc, '[[Value]]')) {
  				Desc['[[Value]]'] = void 0;
  			}
  			if (!src(Desc, '[[Writable]]')) {
  				Desc['[[Writable]]'] = false;
  			}
  		} else {
  			if (!src(Desc, '[[Get]]')) {
  				Desc['[[Get]]'] = void 0;
  			}
  			if (!src(Desc, '[[Set]]')) {
  				Desc['[[Set]]'] = void 0;
  			}
  		}
  		if (!src(Desc, '[[Enumerable]]')) {
  			Desc['[[Enumerable]]'] = false;
  		}
  		if (!src(Desc, '[[Configurable]]')) {
  			Desc['[[Configurable]]'] = false;
  		}
  		return Desc;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-set-o-p-v-throw
  	Set: function Set(O, P, V, Throw) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('O must be an Object');
  		}
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('P must be a Property Key');
  		}
  		if (this.Type(Throw) !== 'Boolean') {
  			throw new $TypeError$2('Throw must be a Boolean');
  		}
  		if (Throw) {
  			O[P] = V;
  			return true;
  		} else {
  			try {
  				O[P] = V;
  			} catch (e) {
  				return false;
  			}
  		}
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-hasownproperty
  	HasOwnProperty: function HasOwnProperty(O, P) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('O must be an Object');
  		}
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('P must be a Property Key');
  		}
  		return src(O, P);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-hasproperty
  	HasProperty: function HasProperty(O, P) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('O must be an Object');
  		}
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('P must be a Property Key');
  		}
  		return P in O;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-isconcatspreadable
  	IsConcatSpreadable: function IsConcatSpreadable(O) {
  		if (this.Type(O) !== 'Object') {
  			return false;
  		}
  		if (hasSymbols$4 && typeof $Symbol.isConcatSpreadable === 'symbol') {
  			var spreadable = this.Get(O, Symbol.isConcatSpreadable);
  			if (typeof spreadable !== 'undefined') {
  				return this.ToBoolean(spreadable);
  			}
  		}
  		return this.IsArray(O);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-invoke
  	Invoke: function Invoke(O, P) {
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('P must be a Property Key');
  		}
  		var argumentsList = arraySlice(arguments, 2);
  		var func = this.GetV(O, P);
  		return this.Call(func, O, argumentsList);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-getiterator
  	GetIterator: function GetIterator(obj, method) {
  		if (!hasSymbols$4) {
  			throw new SyntaxError('ES.GetIterator depends on native iterator support.');
  		}

  		var actualMethod = method;
  		if (arguments.length < 2) {
  			actualMethod = this.GetMethod(obj, $Symbol.iterator);
  		}
  		var iterator = this.Call(actualMethod, obj);
  		if (this.Type(iterator) !== 'Object') {
  			throw new $TypeError$2('iterator must return an object');
  		}

  		return iterator;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-iteratornext
  	IteratorNext: function IteratorNext(iterator, value) {
  		var result = this.Invoke(iterator, 'next', arguments.length < 2 ? [] : [value]);
  		if (this.Type(result) !== 'Object') {
  			throw new $TypeError$2('iterator next must return an object');
  		}
  		return result;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-iteratorcomplete
  	IteratorComplete: function IteratorComplete(iterResult) {
  		if (this.Type(iterResult) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(iterResult) is not Object');
  		}
  		return this.ToBoolean(this.Get(iterResult, 'done'));
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-iteratorvalue
  	IteratorValue: function IteratorValue(iterResult) {
  		if (this.Type(iterResult) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(iterResult) is not Object');
  		}
  		return this.Get(iterResult, 'value');
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-iteratorstep
  	IteratorStep: function IteratorStep(iterator) {
  		var result = this.IteratorNext(iterator);
  		var done = this.IteratorComplete(result);
  		return done === true ? false : result;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-iteratorclose
  	IteratorClose: function IteratorClose(iterator, completion) {
  		if (this.Type(iterator) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(iterator) is not Object');
  		}
  		if (!this.IsCallable(completion)) {
  			throw new $TypeError$2('Assertion failed: completion is not a thunk for a Completion Record');
  		}
  		var completionThunk = completion;

  		var iteratorReturn = this.GetMethod(iterator, 'return');

  		if (typeof iteratorReturn === 'undefined') {
  			return completionThunk();
  		}

  		var completionRecord;
  		try {
  			var innerResult = this.Call(iteratorReturn, iterator, []);
  		} catch (e) {
  			// if we hit here, then "e" is the innerResult completion that needs re-throwing

  			// if the completion is of type "throw", this will throw.
  			completionRecord = completionThunk();
  			completionThunk = null; // ensure it's not called twice.

  			// if not, then return the innerResult completion
  			throw e;
  		}
  		completionRecord = completionThunk(); // if innerResult worked, then throw if the completion does
  		completionThunk = null; // ensure it's not called twice.

  		if (this.Type(innerResult) !== 'Object') {
  			throw new $TypeError$2('iterator .return must return an object');
  		}

  		return completionRecord;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-createiterresultobject
  	CreateIterResultObject: function CreateIterResultObject(value, done) {
  		if (this.Type(done) !== 'Boolean') {
  			throw new $TypeError$2('Assertion failed: Type(done) is not Boolean');
  		}
  		return {
  			value: value,
  			done: done
  		};
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-regexpexec
  	RegExpExec: function RegExpExec(R, S) {
  		if (this.Type(R) !== 'Object') {
  			throw new $TypeError$2('R must be an Object');
  		}
  		if (this.Type(S) !== 'String') {
  			throw new $TypeError$2('S must be a String');
  		}
  		var exec = this.Get(R, 'exec');
  		if (this.IsCallable(exec)) {
  			var result = this.Call(exec, R, [S]);
  			if (result === null || this.Type(result) === 'Object') {
  				return result;
  			}
  			throw new $TypeError$2('"exec" method must return `null` or an Object');
  		}
  		return regexExec$1(R, S);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-arrayspeciescreate
  	ArraySpeciesCreate: function ArraySpeciesCreate(originalArray, length) {
  		if (!this.IsInteger(length) || length < 0) {
  			throw new $TypeError$2('Assertion failed: length must be an integer >= 0');
  		}
  		var len = length === 0 ? 0 : length;
  		var C;
  		var isArray = this.IsArray(originalArray);
  		if (isArray) {
  			C = this.Get(originalArray, 'constructor');
  			// TODO: figure out how to make a cross-realm normal Array, a same-realm Array
  			// if (this.IsConstructor(C)) {
  			// 	if C is another realm's Array, C = undefined
  			// 	Object.getPrototypeOf(Object.getPrototypeOf(Object.getPrototypeOf(Array))) === null ?
  			// }
  			if (this.Type(C) === 'Object' && hasSymbols$4 && $Symbol.species) {
  				C = this.Get(C, $Symbol.species);
  				if (C === null) {
  					C = void 0;
  				}
  			}
  		}
  		if (typeof C === 'undefined') {
  			return $Array(len);
  		}
  		if (!this.IsConstructor(C)) {
  			throw new $TypeError$2('C must be a constructor');
  		}
  		return new C(len); // this.Construct(C, len);
  	},

  	CreateDataProperty: function CreateDataProperty(O, P, V) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}
  		var oldDesc = $gOPD(O, P);
  		var extensible = oldDesc || (typeof $isExtensible !== 'function' || $isExtensible(O));
  		var immutable = oldDesc && (!oldDesc.writable || !oldDesc.configurable);
  		if (immutable || !extensible) {
  			return false;
  		}
  		var newDesc = {
  			configurable: true,
  			enumerable: true,
  			value: V,
  			writable: true
  		};
  		$defineProperty(O, P, newDesc);
  		return true;
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-createdatapropertyorthrow
  	CreateDataPropertyOrThrow: function CreateDataPropertyOrThrow(O, P, V) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}
  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}
  		var success = this.CreateDataProperty(O, P, V);
  		if (!success) {
  			throw new $TypeError$2('unable to create data property');
  		}
  		return success;
  	},

  	// https://www.ecma-international.org/ecma-262/6.0/#sec-objectcreate
  	ObjectCreate: function ObjectCreate(proto, internalSlotsList) {
  		if (proto !== null && this.Type(proto) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: proto must be null or an object');
  		}
  		var slots = arguments.length < 2 ? [] : internalSlotsList;
  		if (slots.length > 0) {
  			throw new $SyntaxError$1('es-abstract does not yet support internal slots');
  		}

  		if (proto === null && !$ObjectCreate) {
  			throw new $SyntaxError$1('native Object.create support is required to create null objects');
  		}

  		return $ObjectCreate(proto);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-advancestringindex
  	AdvanceStringIndex: function AdvanceStringIndex(S, index, unicode) {
  		if (this.Type(S) !== 'String') {
  			throw new $TypeError$2('S must be a String');
  		}
  		if (!this.IsInteger(index) || index < 0 || index > MAX_SAFE_INTEGER) {
  			throw new $TypeError$2('Assertion failed: length must be an integer >= 0 and <= 2**53');
  		}
  		if (this.Type(unicode) !== 'Boolean') {
  			throw new $TypeError$2('Assertion failed: unicode must be a Boolean');
  		}
  		if (!unicode) {
  			return index + 1;
  		}
  		var length = S.length;
  		if ((index + 1) >= length) {
  			return index + 1;
  		}

  		var first = $charCodeAt(S, index);
  		if (first < 0xD800 || first > 0xDBFF) {
  			return index + 1;
  		}

  		var second = $charCodeAt(S, index + 1);
  		if (second < 0xDC00 || second > 0xDFFF) {
  			return index + 1;
  		}

  		return index + 2;
  	},

  	// https://www.ecma-international.org/ecma-262/6.0/#sec-createmethodproperty
  	CreateMethodProperty: function CreateMethodProperty(O, P, V) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}

  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}

  		var newDesc = {
  			configurable: true,
  			enumerable: false,
  			value: V,
  			writable: true
  		};
  		return !!$defineProperty(O, P, newDesc);
  	},

  	// https://www.ecma-international.org/ecma-262/6.0/#sec-definepropertyorthrow
  	DefinePropertyOrThrow: function DefinePropertyOrThrow(O, P, desc) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}

  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}

  		return !!$defineProperty(O, P, desc);
  	},

  	// https://www.ecma-international.org/ecma-262/6.0/#sec-deletepropertyorthrow
  	DeletePropertyOrThrow: function DeletePropertyOrThrow(O, P) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}

  		if (!this.IsPropertyKey(P)) {
  			throw new $TypeError$2('Assertion failed: IsPropertyKey(P) is not true');
  		}

  		var success = delete O[P];
  		if (!success) {
  			throw new TypeError('Attempt to delete property failed.');
  		}
  		return success;
  	},

  	// https://www.ecma-international.org/ecma-262/6.0/#sec-enumerableownnames
  	EnumerableOwnNames: function EnumerableOwnNames(O) {
  		if (this.Type(O) !== 'Object') {
  			throw new $TypeError$2('Assertion failed: Type(O) is not Object');
  		}

  		return objectKeys(O);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-number-prototype-object
  	thisNumberValue: function thisNumberValue(value) {
  		if (this.Type(value) === 'Number') {
  			return value;
  		}

  		return $NumberValueOf(value);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-boolean-prototype-object
  	thisBooleanValue: function thisBooleanValue(value) {
  		if (this.Type(value) === 'Boolean') {
  			return value;
  		}

  		return $BooleanValueOf(value);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-string-prototype-object
  	thisStringValue: function thisStringValue(value) {
  		if (this.Type(value) === 'String') {
  			return value;
  		}

  		return $StringValueOf(value);
  	},

  	// https://ecma-international.org/ecma-262/6.0/#sec-properties-of-the-date-prototype-object
  	thisTimeValue: function thisTimeValue(value) {
  		return $DateValueOf(value);
  	}
  });

  delete ES6.CheckObjectCoercible; // renamed in ES6 to RequireObjectCoercible

  var es2015$1 = ES6;

  var ES2016 = assign(assign({}, es2015$1), {
  	// https://github.com/tc39/ecma262/pull/60
  	SameValueNonNumber: function SameValueNonNumber(x, y) {
  		if (typeof x === 'number' || typeof x !== typeof y) {
  			throw new TypeError('SameValueNonNumber requires two non-number values of the same type.');
  		}
  		return this.SameValue(x, y);
  	}
  });

  var es2016 = ES2016;

  var forEach = function forEach(array, callback) {
  	for (var i = 0; i < array.length; i += 1) {
  		callback(array[i], i, array);
  	}
  };

  var $TypeError$3 = GetIntrinsic('%TypeError%');
  var $isEnumerable = functionBind.call(Function.call, GetIntrinsic('%ObjectPrototype%').propertyIsEnumerable);
  var $pushApply = functionBind.call(Function.apply, GetIntrinsic('%ArrayPrototype%').push);

  var ES2017 = assign(assign({}, es2016), {
  	ToIndex: function ToIndex(value) {
  		if (typeof value === 'undefined') {
  			return 0;
  		}
  		var integerIndex = this.ToInteger(value);
  		if (integerIndex < 0) {
  			throw new RangeError('index must be >= 0');
  		}
  		var index = this.ToLength(integerIndex);
  		if (!this.SameValueZero(integerIndex, index)) {
  			throw new RangeError('index must be >= 0 and < 2 ** 53 - 1');
  		}
  		return index;
  	},

  	// https://www.ecma-international.org/ecma-262/8.0/#sec-enumerableownproperties
  	EnumerableOwnProperties: function EnumerableOwnProperties(O, kind) {
  		var keys = es2016.EnumerableOwnNames(O);
  		if (kind === 'key') {
  			return keys;
  		}
  		if (kind === 'value' || kind === 'key+value') {
  			var results = [];
  			forEach(keys, function (key) {
  				if ($isEnumerable(O, key)) {
  					$pushApply(results, [
  						kind === 'value' ? O[key] : [key, O[key]]
  					]);
  				}
  			});
  			return results;
  		}
  		throw new $TypeError$3('Assertion failed: "kind" is not "key", "value", or "key+value": ' + kind);
  	}
  });

  delete ES2017.EnumerableOwnNames; // replaced with EnumerableOwnProperties

  var es2017 = ES2017;

  var $String$2 = GetIntrinsic('%String%');
  var $Object$2 = GetIntrinsic('%Object%');

  var $SymbolProto = GetIntrinsic('%SymbolPrototype%', true);
  var $SymbolValueOf = $SymbolProto ? functionBind.call(Function.call, $SymbolProto.valueOf) : null;
  var $StringProto = GetIntrinsic('%StringPrototype%');
  var $charAt = functionBind.call(Function.call, $StringProto.charAt);

  var $PromiseResolveOrig = GetIntrinsic('%Promise_resolve%', true);
  var $PromiseResolve = $PromiseResolveOrig ? functionBind.call(Function.call, $PromiseResolveOrig) : null;

  var $isEnumerable$1 = functionBind.call(Function.call, GetIntrinsic('%ObjectPrototype%').propertyIsEnumerable);
  var $pushApply$1 = functionBind.call(Function.apply, GetIntrinsic('%ArrayPrototype%').push);
  var $gOPS = $SymbolValueOf ? $Object$2.getOwnPropertySymbols : null;

  var OwnPropertyKeys = function OwnPropertyKeys(ES, source) {
  	var ownKeys = objectKeys(source);
  	if ($gOPS) {
  		$pushApply$1(ownKeys, $gOPS(source));
  	}
  	return ownKeys;
  };

  var ES2018 = assign(assign({}, es2017), {
  	EnumerableOwnPropertyNames: es2017.EnumerableOwnProperties,

  	// https://ecma-international.org/ecma-262/9.0/#sec-thissymbolvalue
  	thisSymbolValue: function thisSymbolValue(value) {
  		if (!$SymbolValueOf) {
  			throw new SyntaxError('Symbols are not supported; thisSymbolValue requires that `value` be a Symbol or a Symbol object');
  		}
  		if (this.Type(value) === 'Symbol') {
  			return value;
  		}
  		return $SymbolValueOf(value);
  	},

  	// https://www.ecma-international.org/ecma-262/9.0/#sec-isstringprefix
  	IsStringPrefix: function IsStringPrefix(p, q) {
  		if (this.Type(p) !== 'String') {
  			throw new TypeError('Assertion failed: "p" must be a String');
  		}

  		if (this.Type(q) !== 'String') {
  			throw new TypeError('Assertion failed: "q" must be a String');
  		}

  		if (p === q || p === '') {
  			return true;
  		}

  		var pLength = p.length;
  		var qLength = q.length;
  		if (pLength >= qLength) {
  			return false;
  		}

  		// assert: pLength < qLength

  		for (var i = 0; i < pLength; i += 1) {
  			if ($charAt(p, i) !== $charAt(q, i)) {
  				return false;
  			}
  		}
  		return true;
  	},

  	// https://www.ecma-international.org/ecma-262/9.0/#sec-tostring-applied-to-the-number-type
  	NumberToString: function NumberToString(m) {
  		if (this.Type(m) !== 'Number') {
  			throw new TypeError('Assertion failed: "m" must be a String');
  		}

  		return $String$2(m);
  	},

  	// https://www.ecma-international.org/ecma-262/9.0/#sec-copydataproperties
  	CopyDataProperties: function CopyDataProperties(target, source, excludedItems) {
  		if (this.Type(target) !== 'Object') {
  			throw new TypeError('Assertion failed: "target" must be an Object');
  		}

  		if (!this.IsArray(excludedItems)) {
  			throw new TypeError('Assertion failed: "excludedItems" must be a List of Property Keys');
  		}
  		for (var i = 0; i < excludedItems.length; i += 1) {
  			if (!this.IsPropertyKey(excludedItems[i])) {
  				throw new TypeError('Assertion failed: "excludedItems" must be a List of Property Keys');
  			}
  		}

  		if (typeof source === 'undefined' || source === null) {
  			return target;
  		}

  		var ES = this;

  		var fromObj = ES.ToObject(source);

  		var sourceKeys = OwnPropertyKeys(ES, fromObj);
  		forEach(sourceKeys, function (nextKey) {
  			var excluded = false;

  			forEach(excludedItems, function (e) {
  				if (ES.SameValue(e, nextKey) === true) {
  					excluded = true;
  				}
  			});

  			var enumerable = $isEnumerable$1(fromObj, nextKey) || (
  				// this is to handle string keys being non-enumerable in older engines
  				typeof source === 'string'
  				&& nextKey >= 0
  				&& ES.IsInteger(ES.ToNumber(nextKey))
  			);
  			if (excluded === false && enumerable) {
  				var propValue = ES.Get(fromObj, nextKey);
  				ES.CreateDataProperty(target, nextKey, propValue);
  			}
  		});

  		return target;
  	},

  	// https://ecma-international.org/ecma-262/9.0/#sec-promise-resolve
  	PromiseResolve: function PromiseResolve(C, x) {
  		if (!$PromiseResolve) {
  			throw new SyntaxError('This environment does not support Promises.');
  		}
  		return $PromiseResolve(C, x);
  	}
  });

  delete ES2018.EnumerableOwnProperties; // replaced with EnumerableOwnPropertyNames

  delete ES2018.IsPropertyDescriptor; // not an actual abstract operation

  var es2018 = ES2018;

  var ES = {
  	ES5: es5$1,
  	ES6: es2015$1,
  	ES2015: es2015$1,
  	ES7: es2016,
  	ES2016: es2016,
  	ES2017: es2017,
  	ES2018: es2018
  };
  assign(ES, es5$1);
  delete ES.CheckObjectCoercible; // renamed in ES6 to RequireObjectCoercible
  assign(ES, es2015$1);

  var esAbstract = ES;

  var toObject = Object;
  var TypeErr = TypeError;

  var implementation$2 = function flags() {
  	if (this != null && this !== toObject(this)) {
  		throw new TypeErr('RegExp.prototype.flags getter called on non-object');
  	}
  	var result = '';
  	if (this.global) {
  		result += 'g';
  	}
  	if (this.ignoreCase) {
  		result += 'i';
  	}
  	if (this.multiline) {
  		result += 'm';
  	}
  	if (this.dotAll) {
  		result += 's';
  	}
  	if (this.unicode) {
  		result += 'u';
  	}
  	if (this.sticky) {
  		result += 'y';
  	}
  	return result;
  };

  var supportsDescriptors$1 = defineProperties_1.supportsDescriptors;
  var gOPD$1 = Object.getOwnPropertyDescriptor;
  var TypeErr$1 = TypeError;

  var polyfill = function getPolyfill() {
  	if (!supportsDescriptors$1) {
  		throw new TypeErr$1('RegExp.prototype.flags requires a true ES5 environment that supports property descriptors');
  	}
  	if (/a/mig.flags === 'gim') {
  		var descriptor = gOPD$1(RegExp.prototype, 'flags');
  		if (descriptor && typeof descriptor.get === 'function' && typeof (/a/).dotAll === 'boolean') {
  			return descriptor.get;
  		}
  	}
  	return implementation$2;
  };

  var supportsDescriptors$2 = defineProperties_1.supportsDescriptors;

  var gOPD$2 = Object.getOwnPropertyDescriptor;
  var defineProperty$1 = Object.defineProperty;
  var TypeErr$2 = TypeError;
  var getProto$1 = Object.getPrototypeOf;
  var regex = /a/;

  var shim = function shimFlags() {
  	if (!supportsDescriptors$2 || !getProto$1) {
  		throw new TypeErr$2('RegExp.prototype.flags requires a true ES5 environment that supports property descriptors');
  	}
  	var polyfill$$1 = polyfill();
  	var proto = getProto$1(regex);
  	var descriptor = gOPD$2(proto, 'flags');
  	if (!descriptor || descriptor.get !== polyfill$$1) {
  		defineProperty$1(proto, 'flags', {
  			configurable: true,
  			enumerable: false,
  			get: polyfill$$1
  		});
  	}
  	return polyfill$$1;
  };

  var flagsBound = Function.call.bind(implementation$2);

  defineProperties_1(flagsBound, {
  	getPolyfill: polyfill,
  	implementation: implementation$2,
  	shim: shim
  });

  var regexp_prototype_flags = flagsBound;

  var hidden = function getHiddenKeyManager() {
  	var symbolCache = {};
  	var makeKey = function key(prop) {
  		if (symbolCache['$' + prop]) {
  			return symbolCache['$' + prop];
  		}
  		if (typeof Symbol === 'function') {
  			symbolCache['$' + prop] = Symbol(prop);
  			return symbolCache['$' + prop];
  		}
  		return '___ ' + prop + ' ___';
  	};
  	return {
  		get: function get(obj, prop) {
  			return obj[makeKey(prop)];
  		},
  		has: function has(obj, prop) {
  			return makeKey(prop) in obj;
  		},
  		set: function set(obj, prop, value) {
  			var key = makeKey(prop);
  			if (defineProperties_1.supportsDescriptors) {
  				Object.defineProperty(obj, key, {
  					configurable: false,
  					enumerable: false,
  					value: value,
  					writable: true
  				});
  			} else {
  				obj[key] = value;
  			}
  		}
  	};
  };

  var hasSymbols$5 = hasSymbols$2();

  var hidden$1 = hidden();
  var undefined$2; // eslint-disable-line no-shadow-restricted-names

  var RegExpStringIterator = function RegExpStringIterator(R, S, global, fullUnicode) {
  	if (esAbstract.Type(S) !== 'String') {
  		throw new TypeError('S must be a string');
  	}
  	if (esAbstract.Type(global) !== 'Boolean') {
  		throw new TypeError('global must be a boolean');
  	}
  	if (esAbstract.Type(fullUnicode) !== 'Boolean') {
  		throw new TypeError('fullUnicode must be a boolean');
  	}
  	hidden$1.set(this, '[[IteratingRegExp]]', R);
  	hidden$1.set(this, '[[IteratedString]]', S);
  	hidden$1.set(this, '[[Global]]', global);
  	hidden$1.set(this, '[[Unicode]]', fullUnicode);
  	hidden$1.set(this, '[[Done]]', false);
  };

  var IteratorPrototype = GetIntrinsic('%IteratorPrototype%', true);
  if (IteratorPrototype) {
  	RegExpStringIterator.prototype = esAbstract.ObjectCreate(IteratorPrototype);
  }

  defineProperties_1(RegExpStringIterator.prototype, {
  	next: function next() {
  		var O = this;
  		if (esAbstract.Type(O) !== 'Object') {
  			throw new TypeError('receiver must be an object');
  		}
  		if (
  			!(O instanceof RegExpStringIterator)
  			|| !hidden$1.has(O, '[[IteratingRegExp]]')
  			|| !hidden$1.has(O, '[[IteratedString]]')
  			|| !hidden$1.has(O, '[[Global]]')
  			|| !hidden$1.has(O, '[[Unicode]]')
  			|| !hidden$1.has(O, '[[Done]]')
  		) {
  			throw new TypeError('"this" value must be a RegExpStringIterator instance');
  		}
  		if (hidden$1.get(O, '[[Done]]')) {
  			return esAbstract.CreateIterResultObject(undefined$2, true);
  		}
  		var R = hidden$1.get(O, '[[IteratingRegExp]]');
  		var S = hidden$1.get(O, '[[IteratedString]]');
  		var global = hidden$1.get(O, '[[Global]]');
  		var fullUnicode = hidden$1.get(O, '[[Unicode]]');
  		var match = esAbstract.RegExpExec(R, S);
  		if (match === null) {
  			hidden$1.set(O, '[[Done]]', true);
  			return esAbstract.CreateIterResultObject(undefined$2, true);
  		}
  		if (global) {
  			var matchStr = esAbstract.ToString(esAbstract.Get(match, '0'));
  			if (matchStr === '') {
  				var thisIndex = esAbstract.ToLength(esAbstract.Get(R, 'lastIndex'));
  				var nextIndex = esAbstract.AdvanceStringIndex(S, thisIndex, fullUnicode);
  				esAbstract.Set(R, 'lastIndex', nextIndex, true);
  			}
  			return esAbstract.CreateIterResultObject(match, false);
  		}
  		hidden$1.set(O, '[[Done]]', true);
  		return esAbstract.CreateIterResultObject(match, false);
  	}
  });
  if (hasSymbols$5) {
  	var defineP = Object.defineProperty;
  	if (Symbol.toStringTag) {
  		if (defineP) {
  			defineP(RegExpStringIterator.prototype, Symbol.toStringTag, {
  				configurable: true,
  				enumerable: false,
  				value: 'RegExp String Iterator',
  				writable: false
  			});
  		} else {
  			RegExpStringIterator.prototype[Symbol.toStringTag] = 'RegExp String Iterator';
  		}
  	}

  	if (!IteratorPrototype && Symbol.iterator) {
  		var func = {};
  		func[Symbol.iterator] = RegExpStringIterator.prototype[Symbol.iterator] || function SymbolIterator() {
  			return this;
  		};
  		var predicate = {};
  		predicate[Symbol.iterator] = function () {
  			return RegExpStringIterator.prototype[Symbol.iterator] !== func[Symbol.iterator];
  		};
  		defineProperties_1(RegExpStringIterator.prototype, func, predicate);
  	}
  }

  var RegExpStringIterator_1 = RegExpStringIterator;

  var OrigRegExp = RegExp;

  var CreateRegExpStringIterator = function CreateRegExpStringIterator(R, S, global, fullUnicode) {
  	if (esAbstract.Type(S) !== 'String') {
  		throw new TypeError('"S" value must be a String');
  	}
  	if (esAbstract.Type(global) !== 'Boolean') {
  		throw new TypeError('"global" value must be a Boolean');
  	}
  	if (esAbstract.Type(fullUnicode) !== 'Boolean') {
  		throw new TypeError('"fullUnicode" value must be a Boolean');
  	}

  	var iterator = new RegExpStringIterator_1(R, S, global, fullUnicode);
  	return iterator;
  };

  var constructRegexWithFlags = function constructRegex(C, R) {
  	var matcher;
  	var flags = esAbstract.Get(R, 'flags');
  	if (typeof flags === 'string') {
  		matcher = new C(R, flags);
  	} else if (C === OrigRegExp) {
  		// workaround for older engines that lack RegExp.prototype.flags
  		flags = regexp_prototype_flags(R);
  		matcher = new C(R.source, flags);
  	} else {
  		flags = regexp_prototype_flags(R);
  		matcher = new C(R, flags);
  	}
  	return { flags: flags, matcher: matcher };
  };

  var regexMatchAll = function SymbolMatchAll(string) {
  	var R = this;
  	if (esAbstract.Type(R) !== 'Object') {
  		throw new TypeError('"this" value must be an Object');
  	}
  	var S = esAbstract.ToString(string);
  	var C = esAbstract.SpeciesConstructor(R, OrigRegExp);

  	var tmp = constructRegexWithFlags(C, R);
  	// var flags = ES.ToString(ES.Get(R, 'flags'));
  	var flags = tmp.flags;
  	// var matcher = ES.Construct(C, [R, flags]);
  	var matcher = tmp.matcher;

  	var lastIndex = esAbstract.ToLength(esAbstract.Get(R, 'lastIndex'));
  	esAbstract.Set(matcher, 'lastIndex', lastIndex, true);
  	var global = flags.indexOf('g') > -1;
  	var fullUnicode = flags.indexOf('u') > -1;
  	return CreateRegExpStringIterator(matcher, S, global, fullUnicode);
  };

  var defineP$1 = Object.defineProperty;
  var gOPD$3 = Object.getOwnPropertyDescriptor;

  if (defineP$1 && gOPD$3) {
  	var desc = gOPD$3(regexMatchAll, 'name');
  	if (desc && desc.configurable) {
  		defineP$1(regexMatchAll, 'name', { value: '[Symbol.matchAll]' });
  	}
  }

  var regexpMatchall = regexMatchAll;

  var hasSymbols$6 = hasSymbols$2();



  var implementation$3 = function matchAll(regexp) {
  	var O = esAbstract.RequireObjectCoercible(this);

  	if (typeof regexp !== 'undefined' && regexp !== null) {
  		var matcher;
  		if (hasSymbols$6 && typeof Symbol.matchAll === 'symbol') {
  			matcher = esAbstract.GetMethod(regexp, Symbol.matchAll);
  		} else if (esAbstract.IsRegExp(regexp)) {
  			// fallback for pre-Symbol.matchAll environments
  			matcher = regexpMatchall;
  		}
  		if (typeof matcher !== 'undefined') {
  			return esAbstract.Call(matcher, regexp, [O]);
  		}
  	}

  	var S = esAbstract.ToString(O);
  	// var rx = ES.RegExpCreate(regexp, 'g');
  	var rx = new RegExp(regexp, 'g');
  	if (hasSymbols$6 && typeof Symbol.matchAll === 'symbol') {
  		return esAbstract.Invoke(rx, Symbol.matchAll, [S]);
  	}
  	// fallback for pre-Symbol.matchAll environments
  	return esAbstract.Call(regexpMatchall, rx, [S]);
  };

  var polyfill$1 = function getPolyfill() {
  	return String.prototype.matchAll || implementation$3;
  };

  var hasSymbols$7 = hasSymbols$2();



  var defineP$2 = Object.defineProperty;
  var gOPD$4 = Object.getOwnPropertyDescriptor;

  var shim$1 = function shimMatchAll() {
  	var polyfill = polyfill$1();
  	defineProperties_1(
  		String.prototype,
  		{ matchAll: polyfill },
  		{ matchAll: function () { return String.prototype.matchAll !== polyfill; } }
  	);
  	if (hasSymbols$7) {
  		// eslint-disable-next-line no-restricted-properties
  		var symbol = Symbol.matchAll || (Symbol['for'] ? Symbol['for']('Symbol.matchAll') : Symbol('Symbol.matchAll'));
  		defineProperties_1(
  			Symbol,
  			{ matchAll: symbol },
  			{ matchAll: function () { return Symbol.matchAll !== symbol; } }
  		);

  		if (defineP$2 && gOPD$4) {
  			var desc = gOPD$4(Symbol, symbol);
  			if (!desc || desc.configurable) {
  				defineP$2(Symbol, symbol, {
  					configurable: false,
  					enumerable: false,
  					value: symbol,
  					writable: false
  				});
  			}
  		}

  		var func = {};
  		func[symbol] = RegExp.prototype[symbol] || regexpMatchall;
  		var predicate = {};
  		predicate[symbol] = function () { return RegExp.prototype[symbol] !== regexpMatchall; };
  		defineProperties_1(RegExp.prototype, func, predicate);
  	}
  	return polyfill;
  };

  var boundMatchAll = functionBind.call(Function.call, implementation$3);

  defineProperties_1(boundMatchAll, {
  	getPolyfill: polyfill$1,
  	implementation: implementation$3,
  	shim: shim$1
  });

  var string_prototype_matchall = boundMatchAll;

  var reduceTargetKeys = function reduceTargetKeys(target, keys, predicate) {
    return Object.keys(target).reduce(predicate, {});
  };

  var omit = function omit() {
    var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var keys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    return reduceTargetKeys(target, keys, function (acc, key) {
      return keys.some(function (omitKey) {
        return omitKey === key;
      }) ? acc : _objectSpread2({}, acc, _defineProperty({}, key, target[key]));
    });
  };
  var isFunction$1 = function isFunction(fn) {
    return Object.prototype.toString.call(fn) === '[object Function]';
  };
  var isNumber = function isNumber(n) {
    return Object.prototype.toString.call(n) === '[object Number]';
  };

  (function trimStartPolyfill(w) {
    var _this = this;

    var String = w.String;

    (function (_ref) {
      var proto = _ref.prototype;

      // eslint-disable-next-line no-param-reassign
      proto.trimStart = proto.trimStart || proto.trimLeft || function () {
        return _this.replace(/^\s+/, '');
      };
    })(String);
  })(window);

  string_prototype_matchall.shim();
  var propTypes = {
    autoFocus: PropTypes.bool,
    component: PropTypes.node,
    defaultValue: PropTypes.oneOfType([PropTypes.number, PropTypes.string]),
    maskDelay: PropTypes.number,
    handleBlur: PropTypes.func,
    handleChange: PropTypes.func,
    onKeyDown: PropTypes.func,
    onKeyUp: PropTypes.func,
    value: PropTypes.oneOfType([PropTypes.number, PropTypes.string])
  };

  var DurationInputMask =
  /*#__PURE__*/
  function (_PureComponent) {
    _inherits(DurationInputMask, _PureComponent);

    function DurationInputMask(props) {
      var _this;

      _classCallCheck(this, DurationInputMask);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(DurationInputMask).call(this));

      _defineProperty(_assertThisInitialized(_this), "minute", 60);

      _defineProperty(_assertThisInitialized(_this), "hour", 60 * _this.minute);

      _defineProperty(_assertThisInitialized(_this), "day", 24 * _this.hour);

      _defineProperty(_assertThisInitialized(_this), "timer", null);

      _defineProperty(_assertThisInitialized(_this), "handleBlur", function () {
        if (_this.timer) {
          clearTimeout(_this.timer);
        }

        var value = _this.state.value;
        var handleBlur = _this.props.handleBlur;

        var nextValue = _this.mask(value);

        _this.setState({
          value: nextValue
        }, function () {
          if (isFunction$1(handleBlur)) {
            handleBlur(_this.convertToInteger(value), nextValue, value);
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), "handleChange", function (event) {
        var _this$props = _this.props,
            handleChange = _this$props.handleChange,
            maskDelay = _this$props.maskDelay;
        var _event$target$value = event.target.value,
            value = _event$target$value === void 0 ? '' : _event$target$value;

        var nextValue = _this.mask(value);

        var hasOnChangeFunction = isFunction$1(handleChange);
        var hasMaskDelay = isNumber(maskDelay) && maskDelay >= 0;

        if (_this.timer) {
          clearTimeout(_this.timer);
        } // Mask immediately


        if (maskDelay === 0) {
          value = nextValue;
        }

        _this.setState({
          value: value
        }, function () {
          if (hasOnChangeFunction && !hasMaskDelay) {
            handleChange(_this.convertToInteger(value), nextValue, value);
          }

          if (hasMaskDelay) {
            _this.timer = setTimeout(function () {
              return _this.handleMaskDelay(value, nextValue, hasOnChangeFunction);
            }, maskDelay);
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), "handleMaskDelay", function (value, nextValue, hasOnChangeFunction) {
        var handleChange = _this.props.handleChange;

        _this.setState({
          value: nextValue
        }, function () {
          if (hasOnChangeFunction) {
            handleChange(_this.convertToInteger(value), nextValue, value);
          }
        });
      });

      _defineProperty(_assertThisInitialized(_this), "onKeyDown", function (event) {
        var onKeyDown = _this.props.onKeyDown;

        if (isFunction$1(onKeyDown)) {
          onKeyDown(event);
        }
      });

      _defineProperty(_assertThisInitialized(_this), "onKeyUp", function (event) {
        var onKeyUp = _this.props.onKeyUp;

        if (isFunction$1(onKeyUp)) {
          onKeyUp(event);
        }
      });

      _this.state = {
        value: _this.mask(props.value, props)
      };
      _this.ref = null;
      return _this;
    }

    _createClass(DurationInputMask, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        var autoFocus = this.props.autoFocus;

        if (autoFocus && this.ref) {
          this.ref.focus();
        }

        this.timer = null;
      }
    }, {
      key: "componentDidUpdate",
      value: function componentDidUpdate(prevProps) {
        var value = this.props.value;

        if (prevProps.value !== value) {
          this.setState({
            value: this.mask(value)
          });
        }
      }
    }, {
      key: "convertToInteger",
      value: function convertToInteger() {
        var value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

        if (typeof value === 'number' || /^[0-9 ]+$/.test(value)) {
          return parseInt(value || 0, 10);
        }

        var match = value.matchAll(_wrapRegExp(/(\d*)(\w)/gi, {
          value: 1,
          unit: 2
        }));
        var volumes = {
          m: this.minute,
          h: this.hour,
          d: this.day,
          s: 1
        }; // Ensure subsequent matches of same unit are filtered out, e.g. ['2d', '1d'] => ['2d']

        var uniqueMatches = _toConsumableArray(match).reduce(function (prev, item, index) {
          if (Object.keys(prev).find(function (prevKey) {
            return prev[prevKey][2] === item[2];
          })) {
            return prev;
          }

          return _objectSpread2({}, prev, _defineProperty({}, index, item));
        }, {});

        return Object.keys(uniqueMatches).reduce(function (prev, key) {
          var unit = uniqueMatches[key][2];
          return unit.length && volumes[unit] ? prev + volumes[unit] * uniqueMatches[key][1] : prev;
        }, 0);
      }
    }, {
      key: "mask",
      value: function mask(value) {
        var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.props;
        var defaultValue = props.defaultValue;
        var intValue = this.convertToInteger(value);
        var hours = intValue % this.day;
        var minutes = intValue % this.hour;
        var seconds = intValue % this.minute;
        var duration = {
          d: intValue >= this.day ? Math.floor(intValue / this.day) : 0,
          h: hours > 0 ? Math.floor(hours / this.hour) : 0,
          m: minutes > 0 ? Math.floor(minutes / this.minute) : 0,
          s: seconds
        };
        var nextValue = Object.keys(duration).reduce(function (prev, key) {
          var durationValue = duration[key];
          return durationValue ? "".concat(prev, " ").concat(durationValue).concat(key) : prev;
        }, '').trimStart();
        return nextValue || defaultValue;
      }
    }, {
      key: "render",
      value: function render() {
        var _this2 = this;

        var value = this.state.value;
        var ComponentProp = this.props.component;
        return React__default.createElement(ComponentProp, _extends({}, omit(this.props, Object.keys(propTypes)), {
          onBlur: this.handleBlur,
          onChange: this.handleChange,
          onKeyDown: this.onKeyDown,
          onKeyUp: this.onKeyUp,
          ref: function ref(_ref) {
            _this2.ref = _ref;
          },
          value: value
        }));
      }
    }]);

    return DurationInputMask;
  }(React.PureComponent);

  _defineProperty(DurationInputMask, "defaultProps", {
    autoFocus: false,
    component: 'input',
    defaultValue: '',
    maskDelay: null,
    handleBlur: null,
    handleChange: null,
    onKeyDown: null,
    onKeyUp: null,
    value: ''
  });

  return DurationInputMask;

})));
