import React from 'react';
import ReactDOM from 'react-dom';
import { Route } from 'react-router-dom';
import { Provider } from 'react-redux';
import { ConnectedRouter } from 'connected-react-router';
import { IntlProvider } from 'react-intl';
import { store, history } from 'stores/configureStore';
import { AppProvider } from './context';
import AppContainer from './app/AppContainer';
import { messages, language } from '../../locales';


ReactDOM.render(
    <IntlProvider locale={language} messages={messages}>
        <Provider store={store}>
            <AppProvider>
                <ConnectedRouter history={history}>
                    <Route exact path="*" component={AppContainer} />
                </ConnectedRouter>
            </AppProvider>
        </Provider>
    </IntlProvider>
    , document.getElementById('app'),
);
