import KeyMirror from 'keymirror';

export const CUSTOM_LOCAL_STORE_KEYS = KeyMirror({
    REDUX_LOGGER: null,
    SYSTEM_LOGGER: null,
    SHOW_EXTENDS: null,
    APP_DEBUG: null,
});

export const SAGA_ACTIONS = KeyMirror({
    SAGA_GROUPS_LOAD: null,
    SAGA_GROUPS_DELETE: null,
    SAGA_GROUPS_EDIT: null,
    SAGA_GROUPS_BULK_EDIT: null,
    SAGA_GROUPS_DETACH: null,
    SAGA_GROUPS_CREATE: null,
    
    SAGA_TRACKABLES_LOAD: null,
    SAGA_TRACKABLES_COMPANY_LOAD: null,
    SAGA_TRACKABLES_DELETE: null,
    SAGA_TRACKABLES_CREATE: null,
    SAGA_TRACKABLES_BULK_EDIT: null,
    SAGA_TRACKABLES_EDIT_POSITION: null,
    SAGA_TRACKABLES_CREATE_LLL: null,
    SAGA_TRACKABLES_CREATE_LLL_CLOSE: null,
    
    SAGA_ZONES_CREATE_SITE_PAGE: null,
    SAGA_ZONES_CHOOSE_TYPE_ON_CREATE: null,
    SAGA_ZONES_CREATE_RECTANGLE_REGIME: null,
    SAGA_ZONES_CREATE_POLYGON_REGIME: null,
    SAGA_ZONES_EXIT_DRAW_REGIME: null,
    SAGA_ZONES_CREATE_ADMIN_PAGE: null,
    SAGA_ZONES_LOAD: null,
    SAGA_ZONES_PROTOTYPES_LOAD: null,
    SAGA_ZONES_DELETE: null,
    SAGA_ZONES_EDIT_SITE_PAGE: null,
    SAGA_ZONES_BULK_EDIT_SITE_PAGE: null,
    SAGA_ZONES_EDIT_ADMIN_PAGE: null,
    
    SAGA_RELOAD_LAST_CONTEXT: null,
});

export const ACTIONS = KeyMirror({
    CLEAR_STORE: null,
    RELOAD_CONTEXT: null,
    APP_CONTEXT_SET: null,
    APP_CONTEXT_CLEAR: null,

    ALARMS_SET: null,
    ALARMS_CLEAR: null,
    ALARM_ACKNOWLADGE: null,
    ALARM_CLEAR: null,

    USER_LOGIN: null,
    USER_LOGOUT: null,
    UPDATE_CURRENT_USER: null,

    HEATMAP_CHANGE_PARAMS: null,
    HEATMAP_REQUEST_SEND: null,
    HEATMAP_REQUEST_RECEIVE: null,
    HEATMAP_CLEAR: null,

    ENTITIES_LOADED: null,

    // ADMIN_PAGE: 'admin_page',
    ADMIN_PAGE_CLEAR: null,
    ADMIN_PAGE_SAVE_LAST_PATH: null,
    ADMIN_PAGE_CHANGE_SELECTED_ITEMS: null,
    ADMIN_PAGE_SELECT_ITEMS: null,
    ADMIN_PAGE_UNSELECT_ITEMS: null,
    ADMIN_PAGE_CLEAR_SELECTED_ITEMS: null,

    LOGGER_PAGE_CLEAR: null,
    LOGGER_PAGE_CHANGE_LAST_PATH: null,
    LOGGER_GET_ACTIONS_FROM_DB: null,
    LOGGER_GET_MESSAGE_PROCESSOR_MAP: null,
    LOGGER_PAGE_GET_LOGGER_STATUS: null,
    LOGGER_PAGE_UPDATE_VALUE: null,
    LOGGER_PAGE_UPDATE_KEY: null,

    COMPANIES_SET: null,
    COMPANIES_CLEAR: null,
    COMPANY_UPDATE: null,
    COMPANY_CREATE: null,
    COMPANY_DELETE: null,

    PROJECTS_SET: null,
    PROJECTS_CLEAR: null,
    PROJECTS_UPDATE: null,
    PROJECTS_CREATE: null,
    PROJECTS_DELETE: null,
    PROJECT_SELECT: null,

    TRACKABLES_SET: null,
    TRACKABLES_CLEAR: null,
    TRACKABLE_UPDATE: null,
    TRACKABLE_CREATE: null,
    TRACKABLE_DELETE: null,

    TRACKABLE_TEMPLATES_SET: null,

    ALARMS_PLAYBACK_CLEAR: null,
    TRACKABLES_ASSOCIATION_PLAYBACK_SET: null,
    TRACKABLES_ASSOCIATION_SET: null,
    TRACKABLES_ASSOCIATION_CLEAR: null,
    TRACKABLES_ASSOCIATION_CREATE: null,
    TRACKABLES_ASSOCIATION_CLOSE: null,

    GROUPS_SET: null,
    GROUPS_CLEAR: null,
    GROUP_CREATE: null,
    GROUP_UPDATE: null,
    GROUP_DELETE: null,
    
    USERS_SET: null,
    USERS_CLEAR: null,
    USERS_UPDATE: null,
    USERS_CREATE: null,
    USERS_DELETE: null,
    USERS_CURRENT_PROJECT_SET: null,
    USERS_CURRENT_PROJECT_CLEAR: null,
    USERS_UPDATE_PROJECT_ACCESS: null,

    USERS_ACCESS_CONTROL_SET: null,
    USERS_ACCESS_CONTROL_CLEAR: null,
    USERS_ACCESS_CONTROL_UPDATE: null,
    
    HELPER_LINK_SET: null,
    SITE_MONITOR_LINK_SET: null,

    ZONES_SET: null,
    ZONES_PROTOTYPES_SET: null,
    ZONES_PROTOTYPES_CLEAR: null,
    ZONES_INCLUDE_REMOVED_SET: null,
    ZONES_CLEAR: null,
    ZONE_UPDATE: null,
    ZONE_CREATE: null,
    ZONE_DELETE: null,

    ZONE_EDIT_COORDINATES_MODE_ACTIVE: null,
    ZONE_EDIT_COORDINATES_MODE_INACTIVE: null,
    ZONE_EDIT_COORDINATES_SET_ERROR: null,
    ZONE_EDIT_COORDINATES_ADD_VERTEX: null,
    ZONE_EDIT_COORDINATES_REMOVE_VERTEX: null,

    LOCATIONS_SET: null,
    LOCATIONS_CLEAR: null,
    LOCATION_CREATE: null,
    LOCATION_UPDATE: null,
    LOCATION_DELETE: null,

    SUBLOCATIONS_SET: null,
    SUBLOCATIONS_CLEAR: null,
    SUBLOCATION_CREATE: null,
    SUBLOCATION_UPDATE: null,
    SUBLOCATION_DELETE: null,

    FLOORPLANS_SET: null,
    FLOORPLANS_CLEAR: null,
    FLOORPLAN_CREATE: null,
    FLOORPLAN_UPDATE: null,
    FLOORPLAN_DELETE: null,
    
    NOTIFICATION_TYPES_LIST_SET: null,
    
    NOTIFICATIONS_SET: null,
    NOTIFICATIONS_CLEAR: null,
    NOTIFICATION_CREATE: null,
    NOTIFICATION_UPDATE: null,
    NOTIFICATION_DELETE: null,

    SUBSCRIBERS_SET: null,
    SUBSCRIBERS_CLEAR: null,
    SUBSCRIBER_CREATE: null,
    SUBSCRIBER_UPDATE: null,
    SUBSCRIBER_DELETE: null,

    SYSTEM_SUBSCRIBERS_SET: null,
    SHM_SUBSCRIPTION_UPDATE: null,

    NODES_SET: null,
    NODES_CLEAR: null,
    NODE_CREATE: null,
    NODE_UPDATE: null,
    NODE_DELETE: null,
    NODE_ASSIGN: null,
    NODE_RELEASE: null,
    NODE_CREATE_ERROR: null,

    MESSAGE_ERROR: null,
    MESSAGE_SENT: null,
    MESSAGE_SAVE: null,
    MESSAGE_SELECT_ITEMS: null,
    MESSAGE_CLEAR: null,

    RIGHT_SIDE_BAR_LIST_UNRESPONSIVE: null,
    RIGHT_SIDE_BAR_SEARCHED_TRACKABLES: null,
    
    // SITE_VIEW: 'site_view'
    SITE_VIEW_CHANGE_PARAMS: null,
    SITE_VIEW_SELECT_LOCATION: null,
    SITE_VIEW_SELECT_SUBLOCATION: null,
    SITE_VIEW_SELECT_FLOORPLAN: null,
    SITE_VIEW_CLEAR: null,
    SITE_VIEW_CLEAR_MODE: null,
    SITE_VIEW_SELECT_TAB: null,
    SITE_VIEW_SELECTED_LEAFLET_ELEMENT: null,
    SET_LAST_MODE: null,
    CLEAR_LAST_MODE: null,

    SITE_VIEW_CHANGE_SELECTED_ITEMS: null,
    SITE_VIEW_LAYER_FILTER: null,
    SITE_VIEW_ADD_CREATED_GEOMETRY: null,
    SITE_VIEW_ADD_CREATED_GEOMETRY_RESTRICTION: null,
    SITE_VIEW_ADD_CREATED_GEOMETRY_TYPE: null,
    SITE_VIEW_ROTATE_CREATED_GEOMETRY: null,
    SITE_VIEW_SET_ZONE_WIDTH: null,
    SITE_VIEW_CLEAR_CREATED_MODE: null,
    SITE_VIEW_SELECT_ITEMS: null,
    SITE_VIEW_UNSELECT_ITEMS: null,
    SITE_VIEW_LEAFLET_SET_PARAMS: null,
    SITE_VIEW_SET_INITIAL_GROUPS_FILTER: null,
    SITE_VIEW_SET_GROUPS_FILTER: null,
    SITE_VIEW_CHANGE_OPENING_SIDE_BAR: null,
    SITE_VIEW_CHANGE_OPENING_FILTER: null,
    SITE_VIEW_CHANGE_FILTER: null,
    SITE_VIEW_CHANGE_GROUP_FILTER: null,
    SITE_VIEW_CHANGE_UNRESPONSIVE_FILTER: null,
    SITE_VIEW_FILTER_UNSELECT_TRACKABLES: null,
    SITE_VIEW_FILTER_SELECT_TRACKABLES: null,
    SITE_VIEW_SET_FILTERS: null,
    SITE_VIEW_CHANGE_NODE_TYPE_FILTER: null,
    SITE_VIEW_SET_CLUSTER_TRUCKABLES: null,
    SITE_VIEW_SET_CLUSTER_POP_UP: null,

    WIN_ANCHORS_SET: null,
    WIN_ANCHORS_CLEAR: null,
    WIN_ANCHORS_CHECK_STATE: null,

    // DASHBOARD
    DASHBOARD_CHANGE_WIDGETS: null,
    DASHBOARD_ALARMS_SET: null,
    DASHBOARD_ALARMS_ERROR: null,
    DASHBOARD_ALARMS_LOADING: null,

    PLAYBACK_SELECT_TRACKABLES_CHANGE: null,

    SPAGHETTI_DIAGRAM_CHANGE_VIEW_MODE: null,
    SELECT_IDLE_TIME_MARKER: null,
    FILTERED_SPAGHETTI_DIAGRAM_TRAILS: null,
    CLEAR_SPAGHETTI_DIAGRAM: null,
    
    CLEAR_NEAR_MISS_REPORT: null,
    NEAR_MISS_REPORT_CHANGE_DISPLAY_TIME_FRAME: null,
    OPEN_NEAR_MISS_EVENT_MARKER_POPUP: null,

    SET_PWS_REPORT: null,
    SET_PWS_TABLE_DATA: null,
    CLEAR_PWS_REPORT: null,
    SET_PWS_REPORT_ERROR: null,
    SET_PWS_REPORT_FILTER_TRACKABLES: null,
    SET_PWS_REPORT_LOADING_TRACKABLES: null,
    
    SET_ATTENDANCE_REPORT: null,
    SET_ATTENDANCE_REPORT_DATE: null,
    SET_ATTENDANCE_REPORT_LIST: null,
    LOADING_ATTENDANCE_REPORT_LIST: null,
    LOADING_ATTENDANCE_REPORT: null,
    CLEAR_ATTENDANCE_REPORT: null,
    SET_ATTENDANCE_REPORT_ERROR: null,
    
    SET_ALARMS_REPORT: null,
    SET_ALARMS_REPORT_DATE: null,
    SET_ALARMS_REPORT_LIST: null,
    LOADING_ALARMS_REPORT_LIST: null,
    LOADING_ALARMS_REPORT: null,
    CLEAR_ALARMS_REPORT: null,
    SET_ALARMS_REPORT_ERROR: null,
    
    SET_ZONE_ACTIVITY_REPORT: null,
    SET_ZONE_ACTIVITY_REPORT_DATE: null,
    SET_ZONE_ACTIVITY_REPORT_LIST: null,
    LOADING_ZONE_ACTIVITY_REPORT_LIST: null,
    LOADING_ZONE_ACTIVITY_REPORT: null,
    CLEAR_ZONE_ACTIVITY_REPORT: null,
    SET_ZONE_ACTIVITY_REPORT_ERROR: null,
    
    SET_DISTANCE_REPORT: null,
    SET_DISTANCE_REPORT_DATE: null,
    SET_DISTANCE_REPORT_LIST: null,
    LOADING_DISTANCE_REPORT_LIST: null,
    LOADING_DISTANCE_REPORT: null,
    CLEAR_DISTANCE_REPORT: null,
    SET_DISTANCE_REPORT_ERROR: null,

    // timeSelect
    TIME_SELECT_DAILY_REPORT: null,
    TIME_SELECT_PWS_REPORT: null,
    TIME_SELECT_SAFETY_REPORT: null,
    TIME_SELECT_ZONE_ACTIVITY_REPORT: null,
    TIME_SELECT_TRACKABLE_DISTANCE_REPORT: null,
    TIME_SELECT_TRACKABLE_COUNT_REPORT: null,
    TIME_SELECT_IDLE_TIME_REPORT: null,
    
    ADVANCED_SELECT_SAFETY_REPORT: null,
    ADVANCED_SELECT_ZONE_ACTIVITY_REPORT: null,
    ADVANCED_SELECT_TRACKABLE_DISTANCE_REPORT: null,
    ADVANCED_SELECT_TRACKABLE_COUNT_REPORT: null,
    ADVANCED_SELECT_IDLE_TIME_REPORT: null,
    ADVANCED_SELECT_PWS_REPORT: null,
    ADVANCED_SELECT_ATTENDANCE_REPORT: null,
    ADVANCED_SELECT_ALARMS_REPORT: null,

    SHM_CHANGE_PARAMS: null,
});

export const MODAL_ACTIONS = KeyMirror({
    MODAL_OPEN_AUDIT_DOWNLOAD: null,
    MODAL_CLOSE_AUDIT_DOWNLOAD: null,

    SELECT_FLOORPLAN: null,
    UNSELECT_FLOORPLAN: null,

    MODAL_OPEN_GENERAL_ERROR: null,
    MODAL_CLOSE_GENERAL_ERROR: null,
    
    MODAL_OPEN_COMMON_MESSAGE: null,
    MODAL_CLOSE_COMMON_MESSAGE: null,
    
    MODAL_OPEN_ALARM_ACKNOWLEDGE: null,
    MODAL_CLOSE_ALARM_ACKNOWLEDGE: null,
    MODAL_OPEN_ALARM_INFO: null,
    MODAL_CLOSE_ALARM_INFO: null,

    // ASSIGN
    MODAL_OPEN_TAG_ASSIGN: null,
    MODAL_CLOSE_TAG_ASSIGN: null,
    MODAL_OPEN_ASSIGN_LLL_VALIDATE: null,
    MODAL_CLOSE_ASSIGN_LLL_VALIDATE: null,

    MODAL_OPEN_TAG_UNASSIGN: null,
    MODAL_CLOSE_TAG_UNASSIGN: null,

    MODAL_OPEN_TRACKABLE_ASSIGN: null,
    MODAL_CLOSE_TRACKABLE_ASSIGN: null,
    TRACKABLE_CHECKBOX_CLICK: null,
    TRACKABLE_STATIONARY_TAG_SHOW_MAP: null,

    MODAL_OPEN_TRACKABLE_UNASSIGN: null,
    MODAL_CLOSE_TRACKABLE_UNASSIGN: null,

    // GROUP
    MODAL_OPEN_GROUP_DETAILS: null,
    MODAL_CLOSE_GROUP_DETAILS: null,
    MODAL_OPEN_GROUP_EDIT: null,
    MODAL_OPEN_GROUP_COLLISION_VALIDATION: null,
    MODAL_CLOSE_GROUP_COLLISION_VALIDATION: null,
    MODAL_CLOSE_GROUP_EDIT: null,
    MODAL_OPEN_GROUP_DELETE: null,
    MODAL_CLOSE_GROUP_DELETE: null,
    MODAL_OPEN_GROUP_DETACH: null,
    MODAL_CLOSE_GROUP_DETACH: null,
    GROUP_CHECKBOX_CLICK: null,
    REMOVE_GROUP_CLICK: null,
    MODAL_OPEN_BULK_EDIT_GROUPS: null,
    MODAL_CLOSE_BULK_EDIT_GROUPS: null,

    // COMPANY
    MODAL_OPEN_COMPANY_DETAILS: null,
    MODAL_CLOSE_COMPANY_DETAILS: null,

    MODAL_OPEN_COMPANY_EDIT_COMPANY_SCOPE: null,
    MODAL_CLOSE_COMPANY_EDIT_COMPANY_SCOPE: null,

    MODAL_OPEN_COMPANY_EDIT_SYSTEM_SCOPE: null,
    MODAL_CLOSE_COMPANY_EDIT_SYSTEM_SCOPE: null,

    MODAL_OPEN_COMPANY_DELETE: null,
    MODAL_CLOSE_COMPANY_DELETE: null,
    MODAL_OPEN_COMPANY_ADD: null,
    MODAL_CLOSE_COMPANY_ADD: null,

    // PROJECT
    MODAL_OPEN_PROJECT_DETAILS: null,
    MODAL_CLOSE_PROJECT_DETAILS: null,

    MODAL_OPEN_PROJECT_EDIT: null,
    MODAL_CLOSE_PROJECT_EDIT: null,

    MODAL_OPEN_PROJECT_DELETE: null,
    MODAL_CLOSE_PROJECT_DELETE: null,
    MODAL_OPEN_PROJECT_ADD: null,
    MODAL_CLOSE_PROJECT_ADD: null,

    // USER
    MODAL_OPEN_USER_DETAILS: null,
    MODAL_CLOSE_USER_DETAILS: null,
    MODAL_OPEN_USER_DELETE: null,
    MODAL_CLOSE_USER_DELETE: null,


    // zone
    MODAL_OPEN_ZONE_DELETE: null,
    MODAL_OPEN_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_CHOOSE_AREA_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_CHOOSE_TYPE_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_CLOSE_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_SET_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_SELECT_FLOORPLAN_CREATE_ADMIN_PAGE: null,
    MODAL_SAVE_OPTIONS_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_UNSELECT_FLOORPLAN_CREATE_ADMIN_PAGE: null,
    MODAL_SET_COORDINATES_REGIME_CREATE_ADMIN_PAGE: null,
    MODAL_CLEAR_COORDINATES_REGIME_CREATE_ADMIN_PAGE: null,
    MODAL_ADD_VERTEX_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_REMOVE_VERTEX_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_CLEAR_GEOMETRY_ZONE_CREATE_ADMIN_PAGE: null,
    MODAL_OPEN_ZONE_CHOOSE_AREA: null,
    MODAL_CLOSE_ZONE_CHOOSE_AREA: null,
    MODAL_OPEN_ZONE_CHOOSE_TYPE: null,
    MODAL_CLOSE_ZONE_CHOOSE_TYPE: null,
    MODAL_CLOSE_ZONE_DELETE: null,
    MODAL_OPEN_ZONE_DETAILS: null,
    MODAL_CLOSE_ZONE_DETAILS: null,
    MODAL_OPEN_ZONE_DETAILS_SITE_PAGE: null,
    MODAL_CLOSE_ZONE_DETAILS_SITE_PAGE: null,
    MODAL_OPEN_ZONE_EDIT_SITE_PAGE: null,
    MODAL_OPEN_ZONE_EDIT_GEO_SITE_PAGE: null,
    MODAL_CLOSE_ZONE_EDIT_GEO_SITE_PAGE: null,
    MODAL_OPEN_ZONE_VERTICES_LIMIT: null,
    MODAL_CLOSE_ZONE_VERTICES_LIMIT: null,
    MODAL_OPEN_ZONE_EDIT_ADMIN_PAGE: null,
    MODAL_CLOSE_ZONE_EDIT_SITE_PAGE: null,
    MODAL_OPEN_ZONE_EDIT_BULK_ADMIN_PAGE: null,
    MODAL_IN_PROGRESS_ZONE_EDIT_BULK_ADMIN_PAGE: null,
    MODAL_CLOSE_ZONE_EDIT_BULK_SITE_PAGE: null,
    MODAL_CLOSE_ZONE_EDIT_ADMIN_PAGE: null,
    MODAL_OPEN_ZONE_CHOOSE_GEOMETRY: null,
    MODAL_OPEN_ZONE_CHOOSE_CREATION_MODE: null,
    MODAL_CLOSE_ZONE_CHOOSE_CREATION_MODE: null,
    MODAL_OPEN_ZONE_COORDINATES_REGIME: null,
    MODAL_CLOSE_ZONE_COORDINATES_REGIME: null,
    MODAL_CLOSE_ZONE_CHOOSE_GEOMETRY: null,
    MODAL_CLEAR_ZONE_CHOOSE_GEOMETRY: null,
    MODAL_OPEN_ZONE_NOTIFY_NO_CREATION: null,
    MODAL_CLOSE_ZONE_NOTIFY_NO_CREATION: null,
    MODAL_OPEN_ZONE_CONFIGURATION_ADD: null,
    MODAL_CLOSE_ZONE_CONFIGURATION_ADD: null,
    MODAL_SELECT_ZONE_FLOORPLAN_DETAILS: null,
    MODAL_UNSELECT_ZONE_FLOORPLAN_DETAILS: null,
    MODAL_ZONE_POLYGON_START_CREATE: null,
    MODAL_ZONE_POLYGON_STOP_CREATE: null,
    MODAL_ZONE_DIRECTION_START_CREATE: null,
    MODAL_ZONE_DIRECTION_STOP_CREATE: null,

    MODAL_OPEN_ZONE_SELECT_TYPE: null,
    MODAL_CLOSE_ZONE_SELECT_TYPE: null,

    MODAL_SAVE_ZONE_SELECT_TYPE: null,

    MODAL_SELECT_FLOORPLAN_ZONE_EDIT_ADMIN_PAGE: null,
    MODAL_UNSELECT_FLOORPLAN_ZONE_EDIT_ADMIN_PAGE: null,

    MODAL_OPEN_SPECIAL_CASES_DELETE: null,
    MODAL_CLOSE_SPECIAL_CASES_DELETE: null,
    MODAL_OPEN_SPECIAL_CASES_DETAILS: null,
    MODAL_CLOSE_SPECIAL_CASES_DETAILS: null,

    MODAL_OPEN_USER_EDIT_SYSTEM_SCOPE: null,
    MODAL_CLOSE_USER_EDIT_SYSTEM_SCOPE: null,

    MODAL_OPEN_TRACKABLE_DETAILS: null,
    MODAL_CLOSE_TRACKABLE_DETAILS: null,
    MODAL_OPEN_TRACKABLE_EDIT: null,
    MODAL_CLOSE_TRACKABLE_EDIT: null,
    MODAL_BULK_TRACKABLE_EDIT_SUBMITTED: null,
    MODAL_OPEN_BULK_TRACKABLE_EDIT: null,
    MODAL_CLOSE_BULK_TRACKABLE_EDIT: null,
    MODAL_OPEN_BULK_TRACKABLE_EDIT_WARNING: null,
    MODAL_CLOSE_BULK_TRACKABLE_EDIT_WARNING: null,
    MODAL_OPEN_TRACKABLE_DELETE: null,
    MODAL_CLOSE_TRACKABLE_DELETE: null,
    MODAL_OPEN_LOW_LATENCY_LINK_VALIDATION: null,
    MODAL_CLOSE_LOW_LATENCY_LINK_VALIDATION: null,

    MODAL_OPEN_BULK_TRACKABLE_ASSIGN: null,
    MODAL_CLOSE_BULK_TRACKABLE_ASSIGN: null,
    MODAL_CLOSE_BULK_TRACKABLE_HANDLE_ERROR: null,
    MODAL_BULK_TRACKABLE_ASSIGN_ADD_ASSIGN_ITEM: null,
    MODAL_BULK_TRACKABLE_ASSIGN_REMOVE_ASSIGN_ITEM: null,
    MODAL_BULK_TKO_ASSIGN_UPDATE_TKO: null,
    MODAL_BULK_TKO_ASSIGN_UPDATE_MAC: null,
    MODAL_BULK_TRACKABLE_ASSIGN_UPDATE: null,
    MODAL_BULK_TRACKABLE_ASSIGN_SUBMITTED: null,

    MODAL_EDIT_TRACKABLE_SAVE_STATIONARY_POSITION: null, // stationaryPosition
    MODAL_EDIT_TRACKABLE_GET_TRACKABLE_POSITION: null,

    MODAL_OPEN_USER_EDIT: null,
    MODAL_CLOSE_USER_EDIT: null,

    MODAL_OPEN_USER_ACCESS_CONTROL_EDIT: null,
    MODAL_CLOSE_USER_ACCESS_CONTROL_EDIT: null,

    MODAL_OPEN_USER_ACCESS_CONTROL_EDIT_COMPANY_SCOPE: null,
    MODAL_CLOSE_USER_ACCESS_CONTROL_EDIT_COMPANY_SCOPE: null,

    MODAL_OPEN_USER_ACCESS_CONTROL_WARNING: null,
    MODAL_CLOSE_USER_ACCESS_CONTROL_WARNING: null,

    MODAL_OPEN_USER_SESSION_EXPIRATION: null,
    MODAL_CLOSE_USER_SESSION_EXPIRATION: null,

    MODAL_SEND_NOTIFICATION_USER_EDIT: null,
    MODAL_GET_NOTIFICATION_USER_EDIT: null,

    // SUBSCRIBERS
    MODAL_OPEN_SUBSCRIBER_EDIT: null,
    MODAL_CLOSE_SUBSCRIBER_EDIT: null,
    MODAL_OPEN_SUBSCRIBER_DETAILS: null,
    MODAL_CLOSE_SUBSCRIBER_DETAILS: null,
    MODAL_OPEN_SUBSCRIBER_DELETE: null,
    MODAL_CLOSE_SUBSCRIBER_DELETE: null,

    // NOTIFICATIONS
    MODAL_OPEN_NOTIFICATION_EDIT: null,
    MODAL_CLOSE_NOTIFICATION_EDIT: null,
    MODAL_OPEN_SYSTEM_NOTIFICATION_EDIT: null,
    MODAL_CLOSE_SYSTEM_NOTIFICATION_EDIT: null,
    MODAL_OPEN_NOTIFICATION_DETAILS: null,
    MODAL_CLOSE_NOTIFICATION_DETAILS: null,
    MODAL_OPEN_NOTIFICATION_DELETE: null,
    MODAL_CLOSE_NOTIFICATION_DELETE: null,

    // NODES
    MODAL_OPEN_NODE_ASSIGN_RELEASE: null,
    MODAL_CLOSE_NODE_ASSIGN_RELEASE: null,
    MODAL_OPEN_NODE_ADD: null,
    MODAL_CLOSE_NODE_ADD: null,
    MODAL_OPEN_NODE_IMPORT: null,
    MODAL_CLOSE_NODE_IMPORT: null,
    MODAL_OPEN_NODE_DETAILS: null,
    MODAL_CLOSE_NODE_DETAILS: null,
    MODAL_OPEN_NODE_IMPORT_CHECK_ONE: null,
    MODAL_CLOSE_NODE_IMPORT_CHECK_ONE: null,
    MODAL_OPEN_NODE_IMPORT_CHECK_TWO: null,
    MODAL_CLOSE_NODE_IMPORT_CHECK_TWO: null,
    MODAL_NODE_IMPORT_CHECK_ONE_SET_COLUMN: null,
    MODAL_OPEN_NODE_DELETE: null,
    MODAL_CLOSE_NODE_DELETE: null,
    MODAL_READ_CSV_NODE_IMPORT: null,
    MODAL_CLEAR_CSV_NODE_IMPORT: null,

    MODAL_SET_PARSED_DATA: null,

    MODAL_OPEN_MESSAGE_SUCCESS_SEND: null,
    MODAL_CLOSE_MESSAGE_SUCCESS_SEND: null,

    MODAL_OPEN_NODE_IMPORT_SUCCESS: null,
    MODAL_CLOSE_NODE_IMPORT_SUCCESS: null,
    MODAL_OPEN_NODE_IMPORT_ERROR: null,
    MODAL_CLOSE_NODE_IMPORT_ERROR: null,

    HEATMAP_SELECT_TRACKABLES_OPEN: null,
    HEATMAP_SELECT_TRACKABLES_CLOSE: null,
    HEATMAP_SELECT_TRACKABLES_CHANGE: null,

    SITE_ANALYTICS_MODAL_UPDATE_STATE: null,
    AVAILABLE_TRACKABLES: null,
    SITE_ANALYTICS_TRACKABLES_LOADING: null,
    SITE_ANALYTICS_MODAL_CHANGE_SELECTED_TRACKABLES: null,
    SITE_ANALYTICS_MODAL_CLOSE: null,

    PLAYBACK_SELECT_TRACKABLES_CHANGE: null,

    WELCOME_MODAL_OPEN: null,
    WELCOME_MODAL_CLOSE: null,
    
    PROJECTS_SETTINGS_MODAL_OPEN: null,
    PROJECTS_SETTINGS_MODAL_CLOSE: null,
    PROJECTS_SETTINGS_MODAL_BACK_OPEN: null,
    PROJECTS_SETTINGS_MODAL_BACK_CLOSE: null,
    
    PROJECT_DELETION_POPUP_MODAL_OPEN: null,
    PROJECT_DELETION_POPUP_MODAL_CLOSE: null,

    COOKIES_MODAL_OPEN: null,
    COOKIES_MODAL_CLOSE: null,
    COOKIES_MODAL_TRY_TO_CLOSE: null,

    MODAL_OPEN_EDIT_PROFILE: null,
    MODAL_CLOSE_EDIT_PROFILE: null,

    MODAL_OPEN_CHANGE_PASSWORD: null,
    MODAL_CLOSE_CHANGE_PASSWORD: null,

    MODAL_OPEN_FORGOT_PASSWORD: null,
    MODAL_CHANGE_FORGOT_PASSWORD: null,
    MODAL_CLOSE_FORGOT_PASSWORD: null,

    MODAL_OPEN_RECOMMEND_TO_CHANGE_PASSWORD: null,
    MODAL_CLOSE_RECOMMEND_TO_CHANGE_PASSWORD: null,

    // COMMON
    MODAL_OPEN_STATUS_NOTIFICATION_POPUP: null,
    MODAL_CLOSE_STATUS_NOTIFICATION_POPUP: null,

    MODAL_OPEN_DASHBOARD_SETTING: null,
    MODAL_CLOSE_DASHBOARD_SETTING: null,

    SHIFT_EDIT_OPEN: null,
    SHIFT_EDIT_CLOSE: null,
    SHIFT_DELETE_OPEN: null,
    SHIFT_DELETE_CLOSE: null,
    SHIFT_DETAILS_OPEN: null,
    SHIFT_DETAILS_CLOSE: null,

    EDIT_SHIFT_DISABLE: null,
});

export const STORAGE_KEY = KeyMirror({
    PACKAGE_VERSION: 'package_version',
    HOST_NAME: 'host_name',
    BETA_PATH: 'beta_path',

    USER_EMAIL: 'user_email',
    USER_TOKEN: 'user_token',
    USER_ACCESS: 'user_access',
    USER_ON_BEHALF: null,

    COMPANY_UID: 'company_uid',
    CURRENT_COMPANY: null,
    PROJECT_UID: 'project_uid',
    CURRENT_PROJECT: null,

    SYSTEM_COMPANY_UID: 'system_company_uid',

    LAST_PAGE: null, // :userEmail:companyUid/projectUid (+lab - just email)
    LAST_INDEX_OF_LOGGER_TABS: null, // :userEmail:companyUid/projectUid (+lab - just email)
    LAST_LOGGER_PATH: null, // :userEmail:companyUid/projectUid (+lab - just email)

    LAST_INDEX_OF_SITE_VIEW_TABS: null, // :userEmail:projectUid
    LAST_STATE_OF_RIGHT_SIDE_BAR: null, // :userEmail:projectUid
    LAST_STATE_OF_OBJECT_FILTER: null, // :userEmail:projectUid
    LAST_STATE_OF_VIEW_FILTER: null, // :userEmail:projectUid
    LAST_STATE_OF_LEAFLET: null, // :userEmail:projectUid

    LAST_CREATED_HEATMAPS: null, // :userEmail:projectUid
    LAST_PROJECT: null, // :userEmail (only for company admins)

    LAST_DASHBOARD_WIDGETS: null,
    LAST_LOCATION: null,
    LAST_SUBLOCATION: null,
    LAST_FLOORPLAN: null,
    LAST_CONTEXT_OF_SHM: null,
    
    LAST_DIRECTIONAL_ZONE_WIDTH: null,

    FORCE_TO_CHANGE_PASSWORD: null,
    SHOW_UNRESPONSIVE_TRACKABLES: null,
});

export const NAME_OF_FORMS = KeyMirror({
    LOGIN: 'login',

    AUDIT_DOWNLOAD: null,
    ERROR: null,
    COMMON_MESSAGE: null,

    ALARM_ACKNOWLEDGE: null,
    ALARM_INFO: null,

    GROUP_EDIT: null,
    GROUP_BULK_EDIT: null,
    GROUP_DETAILS: null,
    GROUP_COLLISION_VALIDATE: null,
    
    TAG_ASSIGN: null,
    TAG_UN_ASSIGN: null,
    TRACKABLE_ASSIGN: null,
    TRACKABLE_UN_ASSIGN: null,

    COMPANY_DETAILS: null,
    COMPANY_EDIT: null,
    COMPANY_DELETE: null,
    COMPANY_ADD: null,

    COMMON_DELETE: null,

    PROJECT_EDIT: null,
    PROJECTS_SETTINGS: null,
    PROJECTS_SETTINGS_BACK: null,
    PROJECT_DELETE: null,
    PROJECT_DETAILS: null,

    TRACKABLE_EDIT: null,
    TRACKABLE_BULK_EDIT: null,
    TRACKABLE_DELETE: null,
    TRACKABLE_DETAILS: null,
    TRACKABLE_COLLISION_VALIDATE: null,
    TRACKABLE_LOW_LATENCY_LINK_VALIDATE: null,
    TRACKABLE_BULK_EDIT_WARNING: null,
    TRACKABLE_BULK_ASSIGN: null,

    USER_DETAILS: null,
    USER_DELETE: null,
    USER_EDIT: null,
    USER_ROLE_EDIT: null,

    DATE_PICKER: null,

    SUBSCRIPTION_DETAILS: null,
    SUBSCRIPTION_DELETE: null,
    SUBSCRIPTION_EDIT: null,

    NOTIFICATION_DETAILS: null,
    NOTIFICATION_DELETE: null,
    NOTIFICATION_EDIT: null,
    SYSTEM_NOTIFICATION_EDIT: null,

    NODE_RELEASE_ASSIGN: null,
    NODE_ADD: null,
    NODE_ADD_ERROR: null,
    NODE_ADD_SUCCESS: null,
    NODE_IMPORT: null,
    NODE_IMPORT_SUCCESS: null,
    NODE_IMPORT_ERROR: null,
    NODE_DETAILS: null,
    NODE_IMPORT_CHECK_ONE: null,
    NODE_IMPORT_CHECK_TWO: null,
    NODE_DELETE: null,

    MESSAGE_SUCCESS_SEND: null,

    ZONE_DELETE: null,
    ZONE_ADD: null,
    ZONE_CHOOSE_AREA: null,
    ZONE_CHOOSE_TYPE: null,
    ZONE_VERTICES_LIMIT: null,
    ZONE_CONFIGURATION_ADD: null,
    ZONE_DETAILS: null,
    ZONE_DETAILS_SITE_PAGE: null,
    ZONE_EDIT: null,
    ZONE_CREATE: null,
    ZONE_EDIT_SITE_PAGE: null,
    ZONE_EDIT_GEO_SITE_PAGE: null,
    ZONE_EDIT_ADMIN_PAGE: null,
    ZONE_BULK_EDIT_ADMIN_PAGE: null,
    ZONE_NOTIFY_NO_CREATION: null,
    ZONE_SELECT_TYPE: null,

    SPECIAL_CASES_DELETE: null,
    SPECIAL_CASES_DETAILS: null,

    EDIT_PROFILE: null,
    CHANGE_PASSWORD: null,
    FORGOT_PASSWORD: null,

    SITE_VIEW_ANALYTICS: null,
    SHIFT_EDIT: null,
    SHIFT_DELETE: null,
});

export const ALARM_TYPES = {
    NODE_LOW_BATTERY: 1,
    ZONE_VIOLATION: 2,
    MAC_ADDRESS_CONFLICT: 3,
    DEVICE_ABSENT: 4,
    DEVICE_OUT_OF_ZONE: 5,
    EMERGENCY_BUTTON: 6,
    ANCHOR_MOVED: 7,
    BUFFER_VIOLATION: 8,
    PWS_SAFETY: 9,
    UNCERTIFIED_OPERATION: 10,
};

export const ALARM_NAMES = {
    NODE_LOW_BATTERY: 'node_low_battery',
    ZONE_VIOLATION: 'zone_violation',
    MAC_ADDRESS_CONFLICT: 'mac_address_conflict',
    DEVICE_ABSENT: 'device_absent',
    DEVICE_OUT_OF_ZONE: 'device_out_of_zone',
    EMERGENCY_BUTTON: 'emergency_button',
    ANCHOR_MOVED: 'anchor_moved',
    BUFFER_VIOLATION: 'buffer_violation',
    PWS_SAFETY: 'pws_safety',
    UNCERTIFIED_OPERATION: 'uncertified_operation',
};

export const ALARM_ID_NAME = {
    [ALARM_TYPES.NODE_LOW_BATTERY]: ALARM_NAMES.NODE_LOW_BATTERY,
    [ALARM_TYPES.ZONE_VIOLATION]: ALARM_NAMES.ZONE_VIOLATION,
    [ALARM_TYPES.MAC_ADDRESS_CONFLICT]: ALARM_NAMES.MAC_ADDRESS_CONFLICT,
    [ALARM_TYPES.DEVICE_ABSENT]: ALARM_NAMES.DEVICE_ABSENT,
    [ALARM_TYPES.DEVICE_ABSENT]: ALARM_NAMES.DEVICE_ABSENT,
    [ALARM_TYPES.DEVICE_OUT_OF_ZONE]: ALARM_NAMES.DEVICE_OUT_OF_ZONE,
    [ALARM_TYPES.EMERGENCY_BUTTON]: ALARM_NAMES.EMERGENCY_BUTTON,
    [ALARM_TYPES.ANCHOR_MOVED]: ALARM_NAMES.ANCHOR_MOVED,
    [ALARM_TYPES.BUFFER_VIOLATION]: ALARM_NAMES.BUFFER_VIOLATION,
    [ALARM_TYPES.PWS_SAFETY]: ALARM_NAMES.PWS_SAFETY,
    [ALARM_TYPES.UNCERTIFIED_OPERATION]: ALARM_NAMES.UNCERTIFIED_OPERATION,
};

export const ALARM_STATES = {
    SET: 'set',
    CLEAR: 'clear',
};

export const ZONE_SEVERITY = {
    INFORMATION: 0,
    LOW: 1,
    GUARDED: 2,
    ELEVATED: 3,
    HIGH: 4,
    SEVERE: 5,
};

export const ZONE_SEVERITY_COLOR = {
    INFORMATION: '#808080',
    LOW: '#0000FF',
    GUARDED: '#FFFF00',
    ELEVATED: '#FFA500',
    HIGH: '#FF0000',
    SEVERE: '#C30037',
};

export const DASHBOARD = KeyMirror({
    CURRENT_ALARMS_WIDGET: null,
    WIN_STATUS_WIDGET: null,
    CURRENT_SHIFT_WIDGET: null,
    PERSON_ACTIVITY_WIDGET: null,
});

export const TRACKABLE_TYPE = KeyMirror({
    NAV: null,
    ASSET: null,
    MOBILE: null,
});

export const TRACKABLE_CATEGORY = KeyMirror({
    VEHICLE: null,
    PERSON: null,
    ASSET: null,
    UNSPECIFIED: null,
});

export const PWS_PIN = KeyMirror({
    ON: null,
    OFF: null,
    SOLID: null,
    PULSE: null,
});

export const DEFAULT_VALUES = {
    empty_array: Object.freeze([]),
    trackable_default_height: 1,
    trackable_pos_report_frequency: 60,
    trackable_buffer_radius: 5,
    trackable_type: TRACKABLE_TYPE.NAV,
    trackable_category: TRACKABLE_CATEGORY.UNSPECIFIED,
    trackable_update_interval: 1, // 1 sec

    TRACKABLE_COLOR: '#bbb',
    SELECTED_ROW_COLOR: '#FCE699',

    MESSAGE_MAX_LENGTH: 70,

    ANCHOR_MAX_LIVE_INTERVAL: 10 * 60, // 10 min, in sec

    MAP_ZOOM: {
        MIN: 13,
        MAX: 22,
        DEFAULT: 15,
        DEFAULT_MODAl: 15.5,
        DELTA_SCROLL: 0.25,
    },
    MAC_ADDRESS_LENGTH: 12,
    SUCCESS_STATUS: 'success_status',
    UNSUCCESS_STATUS: 'unsuccess_status',
    WARNING_STATUS: 'warning_status',
    
    ZERO_TIME: {
        FULL_YEAR: new Date(0).getFullYear(),
    },
    
    LLL_COVERAGE_SAFE_DISTANCE: 0, // unit m
    LLL_COVERAGE_DISTANCE: 2, // unit m
    LLL_COVERAGE_ALERT_DISTANCE: 4, // unit m
    LLL_DISTANCE_MAX: 25, // unit m
    LLL_DISTANCE_MIN: 0, // unit m
    LLL_DISTANCE_STEP: 0.5, // unit m
    LLL_COVERAGE_ANGLE: 180, // unit degree
    LLL_DELAY: 0, // unit s
    LLL_TRACKABLE_PIN: PWS_PIN.PULSE,
    LLL_HAPTIC: false,
    LLL_BUZZER: false,

    CUSTOM_INFO_LIMIT: 120,
};

export const ERROR_TEXT = {
    CUSTOM_INFO_ERROR: () => `Character count cannot exceed ${DEFAULT_VALUES.CUSTOM_INFO_LIMIT}.`,
};

export const NODE_TYPE = {
    TRACKABLE: 'TO',
    WIN_ANCHOR: 'WIN',
    CONFIGURATION_PENDING: 'CP',
};

export const WIN_ANCHOR_TYPE = KeyMirror({
    ANCHOR: null,
    BRIDGE: null,
});

export const ZONE_TYPE = {
    KEEP_IN: {
        id: 1,
        name: 'keep_in',
        display_name: 'Keep in',
    },
    KEEP_OUT: {
        id: 2,
        name: 'keep_out',
        display_name: 'Keep out',
    },
    INFO: {
        id: 3,
        name: 'information',
        display_name: 'Info',
    },
};

export const CUSTOM_ZONE_TYPE = {
    BOUNDARY_IN: {
        name: 'boundary_in',
        display_name: 'Boundary In',
    },
    BOUNDARY_OUT: {
        name: 'boundary_out',
        display_name: 'Boundary Out',
    },
    STOP_NO_ALERT: {
        name: 'stop_no_alert',
        display_name: 'Stop zone – no audio alert',
    },
    SLOW: {
        name: 'slow_zone',
        display_name: 'Slow zone',
    },
    SPECIAL_CUSTOM: {
        name: 'custom_zone',
        display_name: 'Custom zone',
    },
    MUTE: {
        name: 'mute_zone',
        display_name: 'PIT to PED mute zone',
    },
    WIRE_REQUIRED: {
        name: 'wire_required',
        display_name: 'Wire guidance required',
    },
    HEIGHT_RESTRICTION: {
        name: 'height_restriction',
        display_name: 'Height restriction',
    },
    SPEED_RESTRICTION: {
        name: 'speed_restriction',
        display_name: 'Speed restriction',
    },
    EXIT_RESTRICTION: {
        name: 'exit_restriction',
        display_name: 'Exit restriction',
    },
    MAXIMUM_OCCUPANCY: {
        name: 'maximum_occupancy',
        display_name: 'Maximum occupancy',
    },
    ACTION_REQUIRED_ZONE: {
        name: 'action_required_zone',
        display_name: 'Action required zone',
    },
    CUSTOM_ZONE_A: {
        name: 'custom_zone_a',
        display_name: 'Custom zone A',
    },
    CUSTOM_ZONE_B: {
        name: 'custom_zone_b',
        display_name: 'Custom zone B',
    },
    CUSTOM_ZONE_C: {
        name: 'custom_zone_c',
        display_name: 'Custom zone C',
    },
    CUSTOM_ZONE_D: {
        name: 'custom_zone_d',
        display_name: 'Custom zone D',
    },
    CUSTOM_ZONE_E: {
        name: 'custom_zone_e',
        display_name: 'Custom zone E',
    },
    CUSTOM_ZONE_F: {
        name: 'custom_zone_f',
        display_name: 'Custom zone F',
    },
    CUSTOM_ZONE_G: {
        name: 'custom_zone_g',
        display_name: 'Custom zone G',
    },
};

export const FILTER_UNRESPONSIVE = {
    name: 'Unresponsive',
    ranges: [
        {
            value: 3 * 60 * 1000,
            label: '3min',
        },
        {
            value: 10 * 60 * 1000,
            label: '10min',
        },
        {
            value: 60 * 60 * 1000,
            label: '1hr',
        },
        {
            value: 4 * 60 * 60 * 1000,
            label: '4hrs',
        },
        {
            value: 12 * 60 * 60 * 1000,
            label: '12hrs',
        },
        {
            value: 24 * 60 * 60 * 1000,
            label: '1day',
        },
        {
            value: 7 * 24 * 60 * 60 * 1000,
            label: '7days',
        },
        {
            value: 30 * 24 * 60 * 60 * 1000,
            label: '30days',
        },
    ],
};

export const SITE_MODE = KeyMirror({
    HEATMAP: null,
    PLAYBACK: null,
    EDIT_ZONE: null,
    SPAGHETTI: null,
    NEAR_MISS: null,
});

export const GEOMETRY_RESTRICTION_TYPES = {
    RECTANGLE: 'rectangle',
    DIRECTIONAL: 'directional',
    POLYGON: 'polygon',
};

export const FILTER = {
    NA: 'N/A',
    GROUP: 'GROUP',
    ANCHOR: 'ANCHOR',
    BRIDGE: 'BRIDGE',
    STATIONARY: 'STATIONARY',
    UNRESPONSIVE: 'UNRESPONSIVE',
};

export const SERVER_CONFIG = {
    PATH_TO_COMPANY_NAV_LOGO: '/logo/company-nav-logo',
    PATH_TO_PRODUCT_NAV_LOGO: '/logo/product-nav-logo',
    PATH_TO_COMPANY_LOGO: '/logo/company-logo',
    REMOTE: {
        PATH_TO_IMGS: 'images/',
        PORT: '',
        BASE_NAME_TO_CLIENT_ROUTER: '/app/#/',
    },
    LOCAL: {
        PATH_TO_IMGS: '../../../images/',
        PORT: ':8082',
        BASE_NAME_TO_CLIENT_ROUTER: '/#/',
    },
    CURRENT: self.location.port === '8086' ? 'LOCAL' : 'REMOTE', // self like window, but self need because worker ;)
};

export const ROUTES = {
    ROOT_ROUTE: '/',
    LOADING_ROUTE: '/loading',
    ADMIN_ROUTE: '/admin',
    SITE_ROUTE: '/site',
    LOGGER_ROUTE: '/logger',
    REPORTS_ROUTE: '/reports',
    DASHBOARD_ROUTE: '/dashboard',
    SYSTEM_ROUTE: '/system',
};

export const ADMIN_TABS_ROUTES = {
    COMPANIES: '/admin/companies',
    SUPER_ADMIN_USERS: '/admin/super_users',
    PROJECTS: '/admin/projects',
    NOTIFICATIONS: '/admin/notifications',
    TRACKABLE_OBJECTS: '/admin/trackables',
    GROUPS: '/admin/groups',
    NODES: '/admin/nodes',
    AUDIT_LOG: '/admin/audit',
    USERS_PROJECT_SCOPE: '/admin/project_users',
    ZONES: '/admin/zones',
    SHIFTS: '/admin/shifts',
};

export const SYSTEM_TABS_NAMES = KeyMirror({
    ANCHORS: null,
    SERVER: null,
});

export const SYSTEM_TAB_BUTTONS = KeyMirror({
    SITE_MONITOR: null,
});

export const SYSTEM_TABS_ROUTES = {
    ANCHORS: '/system/anchors',
    SERVER: '/system/server',
};

export const ADMIN_TABS_NAME = KeyMirror({
    COMPANIES: null,
    SUPER_ADMIN_USERS: null,
    PROJECTS: null,
    NOTIFICATIONS: null,
    TRACKABLE_OBJECTS: null,
    GROUPS: null,
    NODES: null,
    USERS_PROJECT_SCOPE: null,
    ZONES: null,
    SHIFTS: null,
});

export const LOGGER_TABS_NAME = KeyMirror({
    LOGS: null,
    ACTIVITIES: null,
    MESSAGE_PROCESSOR: null,
    DEBUG: null,
    API: null,
    LEVELS: null,
});

export const LOGGER_TABS_ROUTES = {
    LOGS: '/logger/logs',
    ACTIVITIES: '/logger/activities',
    MESSAGE_PROCESSOR: '/logger/message_processor',
    DEBUG: '/logger/debug',
    API: '/logger/api',
    LEVELS: '/logger/levels',
};

export const EMAIL_OF_COMPANY_ADMIN_USER_BY_DEFAULT = 'redpoint_positioning_impersonate@'; // + companyUid

export const TEMPORARY_PASSWORD_PREFIX = 'have_to_change_'; // + 20 symbols

/* eslint-disable no-useless-escape, max-len */
export const EMAIL_REGEXP = /^(([^<>()\[\]\\.,;:\s@']+(\.[^<>()\[\]\\.,;:\s@']+)*)|('.+'))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;

export const TIME = {
    // Duration from last heard node time half a hour
    NODE_STATUS_DURATION: 1800000,
    NODE_STATUS_REQUEST: 60000,

    HEARTBEAT_UPDATE_INTERVAL: 30000,
    SERVER_STATUS_UPDATE_INTERVAL: 10000,
};

export const DURATION_SORT_RANGES = {
    LESS_A_MIN: 1,
    LESS_5_MIN: 2,
    MORE_5_MIN: 3,
    MORE_30_MIN: 4,
    MORE_HOURE: 5,
    MORE_6_HOURS: 6,
    MORE_DAY: 7,
    MORE_WEEK: 8,
    NEVER: 9,
};

// switching messaging
export const SEND_NEW_ROUTE = true;

export const ROUTING_REPORT_TYPE = KeyMirror({
    ALARMS: null,
    TRAVEL_DISTANCE: null,
    ZONE_ACTIVITY: null,
    PWS: null,
    ATTENDANCE: null,
});

export const REPORT_PATH = {
    REPORTS: '/reports',
    ALARMS: '/reports/alarms',
    TRAVEL_DISTANCE: '/reports/travel_distance',
    ZONE_ACTIVITY: '/reports/zone_activity',
    PWS: '/reports/pws',
    ATTENDANCE: '/reports/attendance',
};

export const SERVER_REPORT_TYPES = {
    TRACKABLE_DISTANCE_REPORT: 'distance_report',
    ALARMS_REPORT: 'alarms_report',
    PWS_REPORT: 'pws_report',
    ZONE_ACTIVITY_REPORT: 'zone_activity_report',
    ATTENDANCE: 'attendance_report',
};

export const CLIENT_REPORT_TYPES = {
    ALARMS_REPORT: 'alarms_report',
    PWS_REPORT: 'pws_report',
    TRACKABLE_DISTANCE_REPORT: 'distance_report',
    ZONE_ACTIVITY_REPORT: 'zone_activity_report',
    ATTENDANCE: 'attendance_report',
};

export const ZONE_APPLY_TO = {
    ALL: 'ALL',
    LIST: 'LIST',
};

export const SHM_CONTEXT = KeyMirror({
    SYSTEM_MONITOR_WIN_ANCHORS: null,
    SYSTEM_MONITOR_SERVER: null,
    SYSTEM_NOTIFICATIONS: null,
});

export const NOTIFICATION_TYPE = KeyMirror({
    ALARM: null,
    SYSTEM: null,
});

export const UNAVAILABLE = 'Unavailable';

export const ZONE_MODE = {
    ALWAYS_ACTIVE: 'ALWAYS_ACTIVE',
    DEACTIVATED: 'DEACTIVATED',
    ON_SCHEDULE: 'ON_SCHEDULE',
};

export const TIMINGS = {
    SEND_POSITION_INTERVAL: 500, // (in ms)
    SEND_NOTIFY_INTERVAL: 1750, // (in ms)
    THROTTLE_TIME: 250, // (in ms)
};

export const T2T_TYPE = {
    MONITOR: 'monitor',
    ANNOUNCER: 'announcer',
    DISABLED: 'disabled',
};

export const ZONES_CONSTANTS = {
    MAX_VERTICES: 12,
    MIN_VERTICES: 3,
    LINE_VERTICES: 2,
};

export const OBJECT_TYPES = {
    TRACKABLE: 'Trackable',
    GROUP: 'Group',
};

export const BOOTSTRAP_TABLE_SORT = {
    ASC: 'asc', // should be lowercase
    DESC: 'desc', // should be lowercase
};

export const ERROR_MESSAGES = {
    TOKEN_EXPIRED: 'Token expired',
    ACCOUNT_DISABLED_PREFIX: 'The user is disabled',
    ACCOUNT_LOCKED_PREFIX: 'Account is locked for',
};

export const HTTP_STATUS = {
    OK: 200,
    BAD_REQUEST: 400,
    UNAUTHORIZED_ERROR: 401,
    TOO_MANY_REQUESTS: 429,
    LOCKED: 423,
    UNPROCESSABLE: 422,
};

export const SITE_VIEW_RIGHT_SIDE_BAR = {
    ALARMS_TAB_ID: 0,
    ZONES_TAB_ID: 1,
    TRACKABLES_TAB_ID: 2,
    EVENTS_TAB_ID: 3,
};

export const MAX_MAP_BOUNDS_LATLNG_OBJECT = {
    _southWest: { lat: 0.2, lng: 0.2 },
    _northEast: { lat: -0.2, lng: -0.2 },
};

export const POS_UPDATE_INTERVAL = {
    MIN: 5,
    MAX: 91 * 60 * 60,
};

export const TRACKABLE_STATUSES = KeyMirror({
    ACTIVE: null,
    IDLE: null,
    UNRESPONSIVE: null,
    UNASSIGNED: null,
});

export const TIME_IN_MINUTES = {
    HALF_HOUR: 30,
    HOUR: 60,
    TWO_HOURS: 120,
    FOUR_HOURS: 240,
    EIGHT_HOURS: 480,
    SIXTEEN_HOURS: 960,
    ONE_DAY: 24 * 60,
    WEEK: 7 * 24 * 60,
    MONTH: 30 * 24 * 60,
    THREE_MONTHS: 90 * 24 * 60,
    HALF_YEAR: 180 * 24 * 60,
    YEAR: 365 * 24 * 60,
};

export const EXPIRATION_TIMEOUT_LIST = [
    0,
    TIME_IN_MINUTES.ONE_DAY,
    TIME_IN_MINUTES.WEEK,
    TIME_IN_MINUTES.MONTH,
    TIME_IN_MINUTES.THREE_MONTHS,
    TIME_IN_MINUTES.HALF_YEAR,
    TIME_IN_MINUTES.YEAR,
];

export const SESSION_TIMEOUT_LIST = [
    0,
    TIME_IN_MINUTES.HALF_HOUR,
    TIME_IN_MINUTES.HOUR,
    TIME_IN_MINUTES.TWO_HOURS,
    TIME_IN_MINUTES.FOUR_HOURS,
    TIME_IN_MINUTES.EIGHT_HOURS,
    TIME_IN_MINUTES.SIXTEEN_HOURS,
    TIME_IN_MINUTES.ONE_DAY,
];
