import React, { Fragment } from 'react';
import { FormattedMessage } from 'react-intl';
import { DASHBOARD } from 'common/constants';

export const ZONE_NOTIFY_NO_CREATION_MODAL = {
    FORM: {
        CONFIRMATION: <FormattedMessage id="zone_notify_no_creation_modal.form.confirmation" />,
        TITLE: <FormattedMessage id="zone_notify_no_creation_modal.form.title" />,
    },
};

export const RIGHT_SIDE_BAR_TABLES = {
    TITLES: {
        ALARMS_FUNC: intl => intl.formatMessage({ id: 'alarms' }),
        ZONES_FUNC: intl => intl.formatMessage({ id: 'zones' }),
        TRACKABLES_FUNC: intl => intl.formatMessage({ id: 'trackables' }),
        NEAR_MISS_FUNC: intl => intl.formatMessage({ id: 'events' }),
    },
};

export const SITE_ALARMS_TABLE = {
    TEXT: {
        ENTER_KEEP_OUT_FUNC: intl => intl.formatMessage({ id: 'site_alarms_table.text.enter_keep_out' }),
        LEAVE_KEEP_IN_FUNC: intl => intl.formatMessage({ id: 'site_alarms_table.text.leave_keep_in' }),
        ZONE_FUNC: intl => intl.formatMessage({ id: 'zone' }),
    },
};

export const ALARMS_INFO_MODAL = {
    FORM: {
        DATE: <FormattedMessage id="alarms_info_modal.form.date" />,
        DESCRIPTION: <FormattedMessage id="alarms_info_modal.form.description" />,
    },
};

export const ALARMS_ACKNOWLEDGE_MODAL = {
    BUTTON_ACK: <FormattedMessage id="alarms_acknowledge_modal.button_ack" />,
    WARNING: <FormattedMessage id="alarms_acknowledge_modal.warning" />,
    HEADER_FUNC: name => <FormattedMessage id="alarms_acknowledge_modal.header" values={{ name }} />,
    HEADER_MULTI_FUNC: name => <FormattedMessage id="alarms_acknowledge_modal.header_multi" values={{ name }} />,
};

export const SITE_ZONES_TABLE = {
    TEXT: {
        TYPE_FUNC: intl => intl.formatMessage({ id: 'type' }),
        SEVERITY_FUNC: intl => intl.formatMessage({ id: 'site_zones_table.text.severity' }),
        STATUS_FUNC: intl => intl.formatMessage({ id: 'status' }),
        STATUS_INACTIVE_FUNC: intl => intl.formatMessage({ id: 'site_zones_table.text.status_inactive' }),
    },
};

export const SITE_TRACKABLES_TABLE = {
    HEADER: <FormattedMessage id="site_trackables_table.text.groups" />,
    TEXT: {
        GROUPS_FUNC: intl => intl.formatMessage({ id: 'site_trackables_table.text.groups' }),
        MAC_FUNC: intl => intl.formatMessage({ id: 'site_trackables_table.text.mac' }),
        BUFFER_FUNC: intl => intl.formatMessage({ id: 'site_trackables_table.text.buffer' }),
        SPECIAL_CASE_FUNC: intl => intl.formatMessage({ id: 'site_trackables_table.text.special_case' }),
        YES_FUNC: intl => intl.formatMessage({ id: 'yes' }),
        NO_FUNC: intl => intl.formatMessage({ id: 'no' }),
        SHOW_UNRESPONSIVE: intl => intl.formatMessage({ id: 'site_trackables_table.text.show_unresponsive' }),
    },
};

export const RIGHT_SIDE_BAR_MESSAGING = {
    TITLES: {
        PLACEHOLDER_FUNC: intl => intl.formatMessage({ id: 'right_side_bar_messaging.titles.placeholder' }),
    },
    SEND: <FormattedMessage id="right_side_bar_messaging.send" />,
    BUTTONS: {
        ALL_FUNC: intl => intl.formatMessage({ id: 'right_side_bar_messaging.buttons.all' }),
        TRACKABLE_START: intl => intl.formatMessage({ id: 'right_side_bar_messaging.buttons.trackable_start' }),
        GROUP_START: intl => intl.formatMessage({ id: 'right_side_bar_messaging.buttons.group_start' }),
    },
};

export const SITE_ANALYTICS_LABELS = {
    BUTTON: <FormattedMessage id="site_analytics_labels.button" />,
    'LAST_0.5_HOURS': <FormattedMessage id="site_analytics_labels.last_0.5_hours" />,
    LAST_2_HOURS: <FormattedMessage id="site_analytics_labels.last_2_hours" />,
    LAST_4_HOURS: <FormattedMessage id="site_analytics_labels.last_4_hours" />,
    LAST_8_HOURS: <FormattedMessage id="site_analytics_labels.last_8_hours" />,
    LAST_24_HOURS: <FormattedMessage id="site_analytics_labels.last_24_hours" />,
    CUSTOM_INTERVAL: <FormattedMessage id="site_analytics_labels.custom_interval" />,
    NO_RECENT_HEAT_MAP: <FormattedMessage id="site_analytics_labels.no_recent_heat_map" />,
    RECENT_HEATMAPS: intl => intl.formatMessage({ id: 'site_view_heatmap_setting.interval.recent_heatmaps' }),
    IDLE_TIME: intl => intl.formatMessage({ id: 'site_analytics_labels.idle_time' }),
    LOCATION: intl => intl.formatMessage({ id: 'site_analytics_labels.location' }),
    TRACE_FILTER: <FormattedMessage id="site_analytics_labels.trace_filter" />,
    TRACKABLES_SUMMARY: <FormattedMessage id="site_analytics_labels.trackables_summary" />,
    TRACKABLE_NAME: <FormattedMessage id="site_analytics_labels.trackable_name" />,
    TOTAL_DISTANCE: <FormattedMessage id="site_analytics_labels.total_distance" />,
    TOTAL_IDLE_TIME: <FormattedMessage id="site_analytics_labels.total_idle_time" />,
    PERIOD: <FormattedMessage id="site_analytics_labels.period" />,
    SELECT_DATE: intl => intl.formatMessage({ id: 'site_analytics_labels.select_date' }),
    TIME: intl => intl.formatMessage({ id: 'time' }),
    DISTANCE: intl => intl.formatMessage({ id: 'site_analytics_labels.distance' }),
};

export const SITE_ANALYTICS_MODAL = {
    TITLE: <FormattedMessage id="site_analytics_labels.title" />,

    ERROR_MESSAGE: (intl, num) => intl.formatMessage({ id: 'site_analytics_labels.error_message' }, { num }),
    FROM_SHOULD_BE_LESS_THEN_TO: intl => intl.formatMessage({ id: 'site_analytics_labels.from_less_to' }),
    TO_SHOULD_BE_LESS_THEN_NOW: intl => intl.formatMessage({ id: 'site_analytics_labels.to_les_now' }),
    FROM_SHOULD_BE_LESS_THEN_NOW: intl => intl.formatMessage({ id: 'site_analytics_labels.from_less_now' }),
    SPAGHETTI: <FormattedMessage id="site_analytics_labels.spaghetti" />,
    HEATMAP: <FormattedMessage id="site_analytics_labels.heatmap" />,
    PLAYBACK: <FormattedMessage id="site_analytics_labels.playback" />,
    NEAR_MISS: <FormattedMessage id="site_analytics_labels.near_miss" />,
    WEIGHT: <FormattedMessage id="site_analytics_labels.weight" />,
};

export const SITE_VIEW_LEAFLET = {
    TITLES: {
        FIT_FUNC: intl => intl.formatMessage({ id: 'site_view_leaflet.titles.fit' }),
        FULL_SCREEN: intl => intl.formatMessage({ id: 'site_view_leaflet.titles.full_screen' }),
        ZOOM_IN: intl => intl.formatMessage({ id: 'site_view_leaflet.titles.zoom_in' }),
        ZOOM_OUT: intl => intl.formatMessage({ id: 'site_view_leaflet.titles.zoom_out' }),
    },
};

export const LEAFLET_VIEW_FILTER = {
    FILTERS: {
        TRACKABLE_LABELS_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.trackable_labels' }),
        ZONE_LABELS_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.zone_labels' }),
        ZONES_FUNC: intl => intl.formatMessage({ id: 'zones' }),
        SAFETY_ZONES_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.safety_zones' }),
        SCALING_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.scaling' }),
        INFO_ZONES_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.info_zones' }),
        ACTIVE_ONLY_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.active_only' }),
        INACTIVE_ONLY_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.filters.inactive_only' }),
    },
    TITLES: {
        VIEW_FUNC: intl => intl.formatMessage({ id: 'leaflet_view_filter.titles.view' }), // <FormattedMessage id="site_view_leaflet.titles.view" />
    },
};

export const SITE_VIEW_FILTER = {
    TITLES: {
        GROUPS_FUNC: intl => intl.formatMessage({ id: 'name_of_tabs.groups' }),
        UNRESPONSIVE_FUNC: intl => intl.formatMessage({ id: 'unresponsive' }),
        ANCHORS_FUNC: intl => intl.formatMessage({ id: 'shm_side_bar.system_monitor.win_anchors' }),
        BRIDGES_FUNC: intl => intl.formatMessage({ id: 'site_view_filter.titles.bridges' }),
        FILTER_FUNC: intl => intl.formatMessage({ id: 'site_view_filter.titles.filter' }),
        STATIONARY: intl => intl.formatMessage({ id: 'stationary' }),
    },
};

export const SITE_VIEW_MODE = {
    TITLES: {
        RETURN_FUNC: intl => intl.formatMessage({ id: 'site_view_mode.titles.return' }),
        EXPORT_FUNC: intl => intl.formatMessage({ id: 'reports.safety_alarm_table.export_csv' }),
    },
    NOTIFY_MESSAGE: <FormattedMessage id="site_view_mode.notify_message" />,
    NEAR_MISS_TABLE_HEADER_TIME: <FormattedMessage id="near_miss_table.header.time" />,
};

export const NAME_OF_GEAR_BUTTONS = {
    SIGN_OUT: <FormattedMessage id="name_of_gear_buttons.sign_out" />,
    USER_PROFILE: <FormattedMessage id="name_of_gear_buttons.user_profile" />,
    HELP_BUTTON: <FormattedMessage id="name_of_gear_buttons.help_button" />,
    HELP_BUTTON_TITLE: intl => intl.formatMessage({ id: 'name_of_gear_buttons.help_button' }),
    HELP_USER_GUIDE_PDF: <FormattedMessage id="name_of_gear_buttons.help_user_guide_pdf" />,
    EDIT_PROFILE: <FormattedMessage id="name_of_gear_buttons.edit_profile" />,
    COMPANY: <FormattedMessage id="company" />,
    COMPANY_TITLE: intl => intl.formatMessage({ id: 'company' }),
    EDIT_COMPANY: <FormattedMessage id="name_of_gear_buttons.edit_company" />,
    RETURN_TO_COMPANY_PAGE: <FormattedMessage id="name_of_gear_buttons.return_to_company_page" />,
};

export const NAME_OF_NAV_BUTTONS = {
    ADMINISTRATIONS: <FormattedMessage id="name_of_nav_buttons.administartion" />,
    ADMINISTRATIONS_TITLE: intl => intl.formatMessage({ id: 'name_of_nav_buttons.administartion' }),
    SITE: <FormattedMessage id="name_of_nav_buttons.site.zh" />,
    SITE_TITLE: intl => intl.formatMessage({ id: 'name_of_nav_buttons.site.zh' }),
    REPORTS: <FormattedMessage id="name_of_nav_buttons.reports" />,
    REPORTS_TITLE: intl => intl.formatMessage({ id: 'name_of_nav_buttons.reports' }),
    DASHBOARD: <FormattedMessage id="name_of_nav_buttons.dashboard" />,
    DASHBOARD_TITLE: intl => intl.formatMessage({ id: 'name_of_nav_buttons.dashboard' }),
    SYSTEM: <FormattedMessage id="name_of_nav_buttons.system" />,
    SYSTEM_TITLE: intl => intl.formatMessage({ id: 'name_of_nav_buttons.system' }),
};

export const NAMES_OF_TABS = {
    NOTIFICATIONS: <FormattedMessage id="name_of_tabs.notifications" />,
    COMPANIES: <FormattedMessage id="name_of_tabs.companies" />,
    COMPANIES_TITLE: intl => intl.formatMessage({ id: 'name_of_tabs.companies' }),
    SUPER_ADMIN_USERS: <FormattedMessage id="name_of_tabs.super_admin_users" />,
    SUPER_ADMIN_USERS_TITLE: intl => intl.formatMessage({ id: 'name_of_tabs.super_admin_users' }),
    PROJECTS: <FormattedMessage id="name_of_tabs.projects" />,
    PROJECTS_TITLE: intl => intl.formatMessage({ id: 'name_of_tabs.projects' }),
    TRACKABLE_OBJECTS: <FormattedMessage id="trackables" />,
    VEHICLE_CERTIFICATION: <FormattedMessage id="vehicle_certification" />,
    GROUPS: <FormattedMessage id="name_of_tabs.groups" />,
    NODES: <FormattedMessage id="name_of_tabs.tags" />,
    NODES_TITLE: intl => intl.formatMessage({ id: 'name_of_tabs.tags' }),
    AUDIT_DOWNLOAD: <FormattedMessage id="name_of_tabs.audit_download" />,
    AUDIT_DOWNLOAD_TITLE: intl => intl.formatMessage({ id: 'name_of_tabs.audit_download' }),
    USERS_PROJECT_SCOPE: <FormattedMessage id="name_of_tabs.users" />,
    ZONES: <FormattedMessage id="zones" />,
    SHIFTS: <FormattedMessage id="shifts" />,
    ZONE_MANAGEMENT: <FormattedMessage id="name_of_tabs.vehicle_zone_management" />,
};

export const TRACKABLE_BULK_EDIT = {
    BUTTON_TITLE_FUNC: intl => intl.formatMessage({ id: 'trackable_bulk_edit.button.title' }),
    WARNING: <FormattedMessage id="trackable_bulk_edit.warning.message" />,
    WARNING_TITLE: <FormattedMessage id="trackable_bulk_edit.warning.title" />,
    INFO_TITLE: <FormattedMessage id="trackable_bulk_edit.info.title" />,
    UNDER_TITLE: <FormattedMessage id="trackable_bulk_edit.under.title" />,
    INFO_MESSAGE: (count, total) => <FormattedMessage id="trackable_bulk_edit.info.message" values={{ count, total }} />,
    WARN_MESSAGE: (count, total) => <FormattedMessage id="trackable_bulk_edit.warn.message" values={{ count, total }} />,
    ADVANCED_OPTIONS: <FormattedMessage id="trackable_edit_modal.form.advanced" />,
    PWS_TITLE: <FormattedMessage id="group_edit_modal.form.pws.title" />,
    CUSTOM_INFO: <FormattedMessage id="custom_info" />,
    BUFFER_TOOLTIP: <FormattedMessage id="trackable_bulk_edit.buffer_tooltip" />,
    PWS_TOOLTIP: <FormattedMessage id="trackable_bulk_edit.pws_tooltip" />,
};

export const ZONE_BULK_EDIT = {
    BUTTON_TITLE_FUNC: intl => intl.formatMessage({ id: 'zone_bulk_edit.button.title' }),
    INFO_TITLE: <FormattedMessage id="zone_bulk_edit.info.title" />,
    UNDER_TITLE: <FormattedMessage id="zone_bulk_edit.under.title" />,
};

export const TRACKABLE_MODAL = {
    EDIT: {
        ADD_NEW: <FormattedMessage id="trackable_edit_modal.title.add_trackable" />,
        NOTIFY_MESSAGE: <FormattedMessage id="trackable_edit_modal.form.notify_message" />,
        FORM: {
            NAME_FUNC: intl => intl.formatMessage({ id: 'site_analytics_labels.trackable_name' }),
            GROUPS: <FormattedMessage id="site_trackables_table.text.groups" />,
            BUFFER_RADIUS_FUNC: intl => intl.formatMessage({ id: 'trackable_edit_modal.form.buffer_radius' }),
            BUFFER_ACTIVE: <FormattedMessage id="trackable_edit_modal.form.buffer_active" />,
            BUFFER_EXCEPTIONS: <FormattedMessage id="trackable_edit_modal.form.buffer_exceptions" />,
            DEFAULT_HEIGHT_FUNC: intl => intl.formatMessage({ id: 'trackable_details_modal.form.default_height' }),
            UPDATE_INTERVAL_FUNC: intl => intl.formatMessage({ id: 'trackable_details_modal.form.update_interval' }),
            UPDATE_INTERVAL_HELP_FUNC: intl => intl.formatMessage({ id: 'trackable_edit_modal.form.position_update_interval.help' }),
            TRACKABLE_CATEGORY_FUNC: intl => intl.formatMessage({ id: 'trackable_details_modal.form.trackable_category' }),
            TRACKABLE_CATEGORY_HELP_FUNC: intl => intl.formatMessage({ id: 'trackable_edit_modal.form.trackable_category_help' }),
            MAP: <FormattedMessage id="trackable_edit_modal.form.button.show_map" />,
            POSITION_COORDINATES: <FormattedMessage id="trackable_edit_modal.form.button.position_coordinates" />,
            TAG_ASSOCIATION_FUNC: mac => <FormattedMessage id="trackable_edit_modal.form.tag_association" values={{ mac }} />,
            IS_STATIONARY_TAG_ADDED_FUNC: intl => intl.formatMessage({ id: 'trackable_edit_modal.form.is_stationary_tag_added' }),
            ERROR_MUST_BE_POSITIVE: <FormattedMessage id="trackable_edit_modal.form.error_must_be_positive" />,
            ERROR_WRONG_UPDATE_INTERVAL: (min, max) => (<FormattedMessage
                id="trackable_edit_modal.form.error_wrong_update_interval"
                values={{ min, max }}
            />),
            ERROR_SAFE_LESS_WARNING: <FormattedMessage id="trackable_edit_modal.form.error_safe_less_warning" />,
            ERROR_SAFE_LESS_ALERT: <FormattedMessage id="trackable_edit_modal.form.error_safe_less_alert" />,
            ERROR_WARNING_LESS_ALERT: <FormattedMessage id="trackable_edit_modal.form.error_warning_less_alert" />,

            PWS_PARAMS: {
                ALARM_DISABLED: <FormattedMessage id="group_edit_modal.form.group_params.alarm_disabled" />,
                MONITOR: intl => intl.formatMessage({ id: 'group_edit_modal.form.group_params.monitors_for_announcements' }),
                REPORTS_BACK_TO_ANNOUNCER: <FormattedMessage id="group_edit_modal.form.group_params.alarm_back" />,
                ANNOUNCER: intl => intl.formatMessage({ id: 'group_edit_modal.form.group_params.announces_presence' }),
                ANGLE_OF_COVERAGE: intl => intl.formatMessage({ id: 'trackable_details_modal.form.angle' }),
                FULL_RTLS_ONLY: intl => intl.formatMessage({ id: 'group_edit_modal.form.group_params.full_rtls_only' }),
            },
        },
        DESCRIPTION: {
            ROLE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.role' }),
            REPORTS_BACK_TO_ANNOUNCER: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.reports_back_to_announcer' }),
            SAFE_DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.safe_distance' }),
            DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.distance' }),
            ALERT_DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.alert_distance' }),
            ANGLE_OF_COVERAGE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.angle_of_coverage' }),
            // TODO: create a general template with localized values (MIN, MAX)
            LOWER_TEXT_DELAY: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.lower_text_delay' }),
            LOWER_TEXT_SAFE_DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.lower_text_safe_distance' }),
            LOWER_TEXT_DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.lower_text_distance' }),
            LOWER_TEXT_ALERT_DISTANCE: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.lower_text_alert_distance' }),
            DELAY: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.delay' }),
            ALARM_DISABLED: intl => intl.formatMessage({ id: 'group_edit_modal.form.description.alarm_disabled' }),
        },
        WARNING: {
            NAME_DUPLICATES: <FormattedMessage id="trackable_edit_modal.warnings.name_duplicates" />,
            NEED_REBOOT: mac_address => <FormattedMessage id="trackable_edit_modal.warnings.need_reboot" values={{ mac_address }} />,
        },
        ERROR: {
            MUST_BE_NUMBER_REQUIRE: <FormattedMessage id="group_edit_modal.error.must_be_number" />,
            MUST_BE_POSITIVE_NUMBER: <FormattedMessage id="group_edit_modal.error.must_be_positive_number" />,
            MIN_REQUIRE: (min, unit) => <FormattedMessage id="group_edit_modal.error.min_number" values={{ min, unit }} />,
            MAX_REQUIRE: (max, unit) => <FormattedMessage id="group_edit_modal.error.max_number" values={{ max, unit }} />,
            STEP_REQUIRE: (step, unit) => <FormattedMessage id="group_edit_modal.error.step_number" values={{ step, unit }} />,
        },
    },
    DETAILS: {
        FORM: {
            TAG_ASSOCIATION: <FormattedMessage id="trackable_details_modal.form.tag_association" />,
            HARDWARE_VERSION: <FormattedMessage id="trackable_details_modal.form.hardware_version" />,
            BUFFER_RADIUS: <FormattedMessage id="trackable_edit_modal.form.buffer_radius" />,
            BUFFER_STATUS: <FormattedMessage id="trackable_details_modal.form.buffer_status" />,
            DEFAULT_HEIGHT: <FormattedMessage id="trackable_details_modal.form.default_height" />,
            UPDATE_INTERVAL: <FormattedMessage id="trackable_details_modal.form.update_interval" />,
            TRACKABLE_TYPE: <FormattedMessage id="trackable_details_modal.form.trackable_type" />,
            TRACKABLE_CATEGORY: <FormattedMessage id="trackable_details_modal.form.trackable_category" />,
            TRACKABLE_PAIRED_WITH: <FormattedMessage id="trackable_details_modal.form.trackable_paired_with" />,
            ADVANCED: <FormattedMessage id="advanced" />,
            BUFFER_EXCEPTION: <FormattedMessage id="trackable_details_modal.form.buffer_exception" />,

            ANGLE: <FormattedMessage id="trackable_details_modal.form.angle" />,
            ALARM_BACK: <FormattedMessage id="group_edit_modal.form.group_params.alarm_back" />,
            T2T_NO_ALARM: <FormattedMessage id="trackable_details_modal.form.t2t_no_alarm" />,
        },
    },
    BULK_ASSIGN: {
        ADD_ITEM: <FormattedMessage id="add_item" />,
        BUTTON_BULK_ASSIGN_TITLE_FUNC: (intl) => intl.formatMessage({ id: 'trackable_bulk_assign.button.assign_title' }),
        DESCRIPTION: <FormattedMessage id="trackable_bulk_assign.description" />,
        HEADER: <FormattedMessage id="trackable_bulk_assign.header" />,
        NODES: <FormattedMessage id="name_of_tabs.tags" />,
        TRACKABLES: <FormattedMessage id="trackables" />,
        STATUSES: {
            CREATED_ASSOCIATIONS: (count) => <FormattedMessage id="trackable_bulk_assign.statuses.created_associations" values={{ count }} />,
            FAILED_ASSOCIATIONS: (count) => <FormattedMessage id="trackable_bulk_assign.statuses.failed_associations" values={{ count }} />,
        },
    },
    BUFFER: <FormattedMessage id="site_trackables_table.text.buffer" />,
    SAFE_DISTANCE: <FormattedMessage id="trackable_details_modal.form.safe_distance" />,
    DISTANCE: <FormattedMessage id="trackable_details_modal.form.distance" />,
    ALERT_DISTANCE: <FormattedMessage id="trackable_details_modal.form.alert_distance" />,
    DELAY: <FormattedMessage id="trackable_details_modal.form.delay" />,
    ROLE: <FormattedMessage id="role" />,
    PIN: <FormattedMessage id="trackable_details_modal.form.pin" />,
};

export const GROUP_TRACKABLE_COMMON_FIELD = {
    ZONE_CONFIGURATION: <FormattedMessage id="trackable_details_modal.form.zone_configuration" />,
    ZONE_INCLUSIONS: <FormattedMessage id="trackable_details_modal.form.zone_inclusions" />,
    ZONE_EXCLUSIONS: <FormattedMessage id="trackable_details_modal.form.zone_exclusions" />,
    SENSOR_CONFIG_ENABLED: <FormattedMessage id="trackable_details_modal.form.sensor_config_enabled" />,
    SENSOR_CONFIG_DISABLED: <FormattedMessage id="trackable_details_modal.form.sensor_config_disabled" />,
};

export const TRACKABLE_LOW_LATENCY_LINK_VALIDATE = {
    MESSAGES: {
        HAVE_NODE: {
            TITLE: mac_address => <FormattedMessage id="trackable_low_latency_link_validate.messages.have_node.title" values={{ mac_address }} />,
            QUESTION: <FormattedMessage id="trackable_low_latency_link_validate.messages.have_node.question" />,
        },
        HAVE_NO_NODE: {
            TITLE: mac_address => <FormattedMessage id="trackable_low_latency_link_validate.messages.have_no_node.title" values={{ mac_address }} />,
            QUESTION: <FormattedMessage id="trackable_low_latency_link_validate.messages.have_no_node.question" />,
        },
    },
};

export const TRACKABLE_DELETE_MODAL = {
    BATCH: {
        MESSAGE: {
            NO: <FormattedMessage id="trackable_delete_modal.batch.message.no" />,
            ASSIGNED_COMMON: (assigned, total) => <FormattedMessage id="trackable_delete_modal.batch.assigned.common" values={{ assigned, total }} />,
        },
    },
    ASSIGN: {
        MESSAGE_FUNC: (to_name, mac) => <FormattedMessage id="trackable_delete_modal.assign.message" values={{ to_name, mac }} />,
    },
    NO_ASSIGN: {
        MESSAGE_FUNC: to_name => (to_name === false
            ? <FormattedMessage id="trackable_delete_modal.assign.details" />
            : <FormattedMessage id="trackable_delete_modal.no_assign.message" values={{ to_name }} />),
    },
    CONFIRM_MODAL: {
        TITLE_SINGLE_FUNC: (intl, name) => intl.formatMessage({ id: 'trackable_delete_modal.confirm_modal.title_single' }, { name }),
        TITLE_MULTI_FUNC: intl => intl.formatMessage({ id: 'trackable_delete_modal.confirm_modal.title_multi' }),
        MESSAGE_SINGLE_FUNC: intl => intl.formatMessage({ id: 'trackable_delete_modal.confirm_modal.message_single' }),
        MESSAGE_MULTI_FUNC: (intl, name) => intl.formatMessage({ id: 'trackable_delete_modal.confirm_modal.message_multi' }, { name }),
    },
};

export const TRACKABLE_TAG_ASSOCIATION = {
    FORM: {
        ASSIGN_TAG_FUNC: mac => <FormattedMessage id="trackable_tag_association.form.assign_tag" values={{ mac }} />,
        ASSIGN_TRACKABLE_FUNC: name => <FormattedMessage id="trackable_tag_association.assign_trackable" values={{ name }} />,
        UNASSIGN_TRACKABLE_TAG_FUNC: (name, mac) => <FormattedMessage id="trackable_tag_association.unassign_trackable_tag" values={{ name, mac }} />,
        UNASSIGN_TAG_TRACKABLE_FUNC: (name, mac) => <FormattedMessage id="trackable_tag_association.unassign_tag_trackable" values={{ name, mac }} />,
    },
};

export const NODES_TABLE_COMPANY_SCOPE = {
    TITLE: <FormattedMessage id="nodes_tab_company.label.company_tags" />,
    OWNERSHIP: intl => intl.formatMessage({ id: 'nodes_tab_company.table.ownership' }),
    DOUBLE_CLICK: intl => intl.formatMessage({ id: 'nodes_tab_company.table.double_click' }),
};

export const NODE_MODAL = {
    TITLES: {
        CREATE_NEW_TAG: <FormattedMessage id="node_modal.create_new_tag" />,
        IMPORT_TAGS_FROM_CSV: <FormattedMessage id="node_modal.import_tags_from_csv" />,
    },
    NODE_ADD: {
        CHOOSE_FILE: <FormattedMessage id="node_modal.node_add.choose_file" />,
        MAC_ADDRESS_CLAIM: <FormattedMessage id="node_modal.node_add.mac_address_claim" />,
    },
    NODE_IMPORT_CHECK_MODAL: {
        COLUMN: intl => intl.formatMessage({ id: 'node_modal.node_import_check_one_modal.column' }),
        // intl => <FormattedMessage id="node_modal.node_import_check_one_modal.column" />,
        CHECK_IMPORT: <FormattedMessage id="node_modal.node_import_check_one_modal.check_import" />,
        HAS_HEADER: <FormattedMessage id="node_modal.node_import_check_two_modal.has_header" />,
    },
    NODE_SUCCESS_IMPORT_MODAL: {
        TITLE: <FormattedMessage id="node_modal.node_success_import_modal.title" />,
        TAGS_IMPORTED: <FormattedMessage id="node_modal.node_success_import_modal.tags_imported" />,
    },
    NODE_ERROR_IMPORT_MODAL: {
        INVALID_MAC_FUNC: i => <FormattedMessage id="node_modal.node_error_import_modal.invalid_mac" values={{ i }} />,
        DUPLICATE_MAC_FUNC: i => <FormattedMessage id="node_modal.node_error_import_modal.duplicate_mac" values={{ i }} />,
        BUTTON_IMPORT_VALID: <FormattedMessage id="node_modal.node_error_import_modal.button_import_valid" />,
        EXPORT_ERROR_BUTTON: <FormattedMessage id="node_modal.node_error_import_modal.export_error_button" />,
        ERROR_FOUND: <FormattedMessage id="node_modal.node_error_import_modal.error_found" />,
    },
    NODE_ERROR_CREATE_MODAL: {
        EXISTING_MAC: <FormattedMessage id="node_modal.node_error_create_modal.existing_mac" />,
    },
};

export const NODE_DETAILS_MODAL = {
    FORM: {
        PARENT: <FormattedMessage id="node_details_modal.form.parent" />,
        BRIDGE: <FormattedMessage id="node_details_modal.form.bridge" />,
        DEVICE_TYPE: <FormattedMessage id="node_details_modal.form.device_type" />,
        CREATED_AT: <FormattedMessage id="node_details_modal.form.created_at" />,
        UPDATED_AT: <FormattedMessage id="node_details_modal.form.updated_at" />,
        BATTERY: <FormattedMessage id="node_details_modal.form.battery" />,
    },
    TEXT: {
        UNDEFINED_FUNC: intl => intl.formatMessage({ id: 'node_details_modal.text.undefined' }),
        WIN_FUNC: intl => intl.formatMessage({ id: 'node_details_modal.text.win' }),
    },
};

export const NODE_RELEASE_ASSIGN_MODAL = {
    MESSAGE: {
        RELEASE_ASSIGNED_FUNC: (mac, to_name) => <FormattedMessage id="node_release_assign_modal.message.release_assigned" values={{ mac, to_name }} />,
        RELEASE_NOT_ASSIGNED_PROJECT_SCOPE: <FormattedMessage id="node_release_assign_modal.message.release_not_assigned_project_scope" />,
        RELEASE_NOT_ASSIGNED_COMPANY_SCOPE: project_name => <FormattedMessage id="node_release_assign_modal.message.release_not_assigned_company_scope" values={{ project_name }} />,
        ASSIGN_COMPANY_SCOPE: <FormattedMessage id="node_release_assign_modal.message.assign_company_scope" />,
        ASSIGN_PROJECT_SCOPE: <FormattedMessage id="node_release_assign_modal.message.assign_project_scope" />,
        SUCCESSFULLY_RELEASED: <FormattedMessage id="node_release_assign_modal.message.successfully_released" />,
    },
    DETAIL: {
        RELEASE_ASSIGNED: <FormattedMessage id="node_release_assign_modal.detail.release_assigned" />,
    },
    TITLE: {
        RELEASE_FROM_PROJECT_FUNC: project_name => <FormattedMessage id="node_release_assign_modal.title.release_from_project" values={{ project_name }} />,
        RELEASE_TAG_FUNC: mac => <FormattedMessage id="node_release_assign_modal.title.release_tag" values={{ mac }} />,
        CLAIM_TO_PROJECT_FUNC: project_name => <FormattedMessage id="node_release_assign_modal.title.claim_to_project" values={{ project_name }} />,
        ASSIGN_TAG_FUNC: mac => <FormattedMessage id="trackable_tag_association.form.assign_tag" values={{ mac }} />,
    },
};

export const NODE_DELETE_MODAL = {
    TITLE: {
        SINGLE_FUNC: mac => <FormattedMessage id="node_delete_modal.title.assign" values={{ mac }} />,
        MULTI: <FormattedMessage id="node_delete_modal.title.multi_assign" />,
    },
    MESSAGE: {
        SINGLE: {
            NOT_ASSIGN_FUNC: mac => (mac === false
                ? <FormattedMessage id="node_delete_modal.detail.assign" />
                : <FormattedMessage id="node_delete_modal.message.single.not_assign" values={{ mac }} />),
            ASSIGN_FUNC: (mac, to_name) => <FormattedMessage id="node_delete_modal.message.single.assign" values={{ mac, to_name }} />,
            SUCCESSFULLY_DELETED: <FormattedMessage id="node_delete_modal.message.single.successfully_deleted" />,
        },
        MULTI: {
            NOT_ASSIGN: <FormattedMessage id="node_delete_modal.message.multi.not_assign" />,
            SUCCESSFULLY_DELETED_FUNC: nodesMacAddresses => <FormattedMessage id="node_delete_modal.message.multi.successfully_deleted" values={{ nodesMacAddresses }} />,
            ASSIGNED_COMMON: (assigned, total) => <FormattedMessage id="node_delete_modal.batch.assigned.common" values={{ assigned, total }} />,
        },
    },
    NUMBER_OF_TAGS_SELECTED: number => <FormattedMessage id="number_of_tags_selected" values={{ number }} />,
};

export const USERS_TAB = {
    USER_ROLES: {
        PROJECT_USER: intl => intl.formatMessage({ id: 'users_tab.table.user_options.project_user' }),
        PROJECT_MAINTAINER: intl => intl.formatMessage({ id: 'users_tab.table.user_options.project_maintainer' }),
        PROJECT_OPERATIONS_ADMIN: intl => intl.formatMessage({ id: 'users_tab.table.user_options.project_operations_admin' }),
        PROJECT_SYSTEM_ADMIN: intl => intl.formatMessage({ id: 'users_tab.table.user_options.project_system_admin' }),
        COMPANY_ADMIN: intl => intl.formatMessage({ id: 'users_tab.table.user_options.company_admin' }),
    },
    TOTAL_COUNT_FUNC: (totalCount, count) => <FormattedMessage id="users_tab.total_count" values={{ totalCount, count }} />,
};

export const CHANGE_PASSWORD_MODAL = {
    FORM: {
        CURRENT_PASSWORD_FUNC: intl => intl.formatMessage({ id: 'change_password_modal.form.current_password' }),
        NEW_PASSWORD_FUNC: intl => intl.formatMessage({ id: 'change_password_modal.form.new_password' }),
        CONFIRM_PASSWORD_FUNC: intl => intl.formatMessage({ id: 'change_password_modal.form.confirm_password' }),
        CONFIRM_PASSWORD: <FormattedMessage id="change_password_modal.form.confirm_password" />,
    },
    ERROR: {
        REQUIRE_EQUALS_PASSWORD: <FormattedMessage id="change_password_modal.error.require_equals_password" />,
        CURRENT_PASSWORD_NOT_VALID: <FormattedMessage id="change_password_modal.error.current_password_not_valid" />,
        CURRENT_PASSWORD_CANT_BE_SAME_AS_LAST_10: <FormattedMessage id="change_password_modal.error.current_password_cant_be_same_as_last_10" />,
        CURRENT_PASSWORD_NOT_EQUAL_TO_NEW_ONE: <FormattedMessage id="change_password_modal.error.current_password_not_equal_to_new_one" />,
    },
    HEADER: <FormattedMessage id="change_password_modal.header" />,
    HEADER_FORCED: <FormattedMessage id="change_password_modal.header_forced" />,
};

export const AUTH_MODAL = {
    COOKIES_NOT_ENABLED: {
        HEADER: <FormattedMessage id="auth_modal.cookies_not_enabled.header" />,
        TEXT: <FormattedMessage id="auth_modal.cookies_not_enabled.text" />,
        BUTTON_TEXT: <FormattedMessage id="auth_modal.cookies_not_enabled.button_text" />,
    },
    RECOMEND_TO_CHANGE_PASSWORD_MODAL: {
        HEADER: <FormattedMessage id="auth_modal.recomend_to_change_password_modal.header" />,
        TEXT: <FormattedMessage id="auth_modal.recomend_to_change_password_modal.text" />,
    },
    WELCOME_MODAL: {
        HEADER: <FormattedMessage id="auth_modal.welcome_modal.header" />,
        HEADER2: <FormattedMessage id="auth_modal.welcome_modal.header2" />,
    },
    FORGOT_PASSWORD_MODAL: {
        BUTTON_SEND: <FormattedMessage id="auth_modal.form.forgot_password_modal.button_send" />,
        MESSAGE_OK_FUNC: intl => intl.formatMessage({ id: 'auth_modal.form.forgot_password_modal.message_ok' }),
        MESSAGE_FAIL_FUNC: intl => intl.formatMessage({ id: 'auth_modal.form.forgot_password_modal.message_fail' }),
    },
    PROJECT_DELETION_POPUP_MODAL: {
        HEADER: <FormattedMessage id="auth_modal.project_deletion_popup_modal.header" />,
        TEXT: <FormattedMessage id="auth_modal.project_deletion_popup_modal.text" />,
    },
};

export const PROJECT_MODALS = {
    EDIT_MODAL: {
        TITLE: <FormattedMessage id="project_modals.edit_modal.create" />,
        TIME_ZONE_ERROR: <FormattedMessage id="project_modals.edit_modal.error.time_zone" />,
        FORM: {
            MANAGER_FUNC: intl => intl.formatMessage({ id: 'projects_tab.table.header.manager' }),
            TIME_ZONE_FUNC: intl => intl.formatMessage({ id: 'projects_tab.expanded.timezone' }),
        },
    },
    DETAIL_MODAL: {
        FORM: {
            TIME_ZONE: <FormattedMessage id="projects_tab.expanded.timezone" />,
            MANAGER: <FormattedMessage id="projects_tab.table.header.manager" />,
        },
    },
    DELETE_MODAL: {
        CONFIRMATION_FUNC: name => <FormattedMessage id="project_modals.delete_modal.confirmation" values={{ name }} />,
    },
    PROJECT_SETTINGS: {
        HEADER: <FormattedMessage id="project_modals.project_settings.header" />,
        TEXT: <FormattedMessage id="project_modals.project_settings.text" />,
        ERRORS: {
            PROJECT_SHOULD_SPECIFY: intl => intl.formatMessage({ id: 'project_modals.project_settings.errors.project_should_specify' }),
        },
        BACK: {
            HEADER: <FormattedMessage id="project_modals.project_settings.back.header" />,
            TEXT: <FormattedMessage id="project_modals.project_settings.back.text" />,
        },
    },
};

export const FOOTER = {
    COPYRIGHT_FUNC: date => <FormattedMessage id="login.copyright" values={{ date }} />,
    VERSION: <FormattedMessage id="login.copyright.version" />,
};

export const LOGIN = {
    FORGOT_PASSWORD: <FormattedMessage id="login.forgot_password" />,
    BUTTON: <FormattedMessage id="login.button" />,
    ERROR_MESSAGE: <FormattedMessage id="login.error_message" />,
    ACCOUNT_LOCKED: <FormattedMessage id="login.account_locked" />,
    ACCOUNT_DISABLED: <FormattedMessage id="login.account_disabled" />,
};

export const GROUP_EDIT_MODAL = {
    TITLE: <FormattedMessage id="group_edit_modal.title.add_group" />,
    FORM: {
        NAME_FUNC: intl => intl.formatMessage({ id: 'group_details_modal.form.name' }),
        SPECIAL_FUNCTIONS: <FormattedMessage id="group_edit_modal.form.special_functions" />,
        ADVANCED_CUSTOM_PARAMETER: <FormattedMessage id="group_details_modal.form.custom_parameters" />,
        ADVANCED_CUSTOM_PARAMETER_PLACEHOLDER_FUNC: intl => intl.formatMessage({ id: 'group_details_modal.form.custom_parameters' }),
    },
    ERROR: {
        STATIONARY_PWS_CONFLICT: <FormattedMessage id="group_edit_modal.error.stationary_pws_conflict" />,
    },
};

export const GROUP_BULK_EDIT_MODAL = {
    TITLE: <FormattedMessage id="group_bulk_edit_modal.title" />,
    SUB_TITLE: <FormattedMessage id="group_bulk_edit_modal.sub_title" />,
    TRACKABLE_OR_TRACKABLES: <FormattedMessage id="trackable_or_trackables" />,
};

export const GROUP_DETAILS_MODAL = {
    FORM: {
        NAME: <FormattedMessage id="group_details_modal.form.name" />,
        TRACKABLE_COUNT: <FormattedMessage id="trackable_count" />,
        CUSTOM_PARAMETERS: <FormattedMessage id="group_details_modal.form.custom_parameters" />,
    },
};

export const GROUP_DELETE_MODAL = {
    FORM: {
        TITLE: {
            SINGLE_FUNC: name => <FormattedMessage id="group_delete_modal.title.single" values={{ name }} />,
            MULTI: <FormattedMessage id="group_delete_modal.title.multi" />,
        },
    },
    NUMBER_OF_GROUPS_SELECTED: number => <FormattedMessage id="number_of_groups_selected" values={{ number }} />,
};

export const GROUP_DETACH_MODAL = {
    FORM: {
        TITLE: {
            SINGLE_FUNC: (to_name, group_name) => <FormattedMessage id="group_detach_modal.title.single" values={{ to_name, group_name }} />,
            MULTI_FUNC: group_name => <FormattedMessage id="group_detach_modal.title.multi" values={{ group_name }} />,
        },
    },
};

export const COMPANY_EDIT_MODAL = {
    TITLE_ADD_NEW: <FormattedMessage id="company_edit_modal_company_scope.title.add_company" />,
    FORM: {
        LABEL_COMPANY_NAME_FUNC: intl => intl.formatMessage({ id: 'company_edit_modal_company_scope.form.label.company_name' }),
        COMPANY_COLOR: <FormattedMessage id="company_edit_modal_company_scope.form.company_color" />,
        ADDRESS: <FormattedMessage id="company_edit_modal_company_scope.form.address" />,
        ALLOW_AUTO_TAG_ALLOCATION: <FormattedMessage id="company_edit_modal_company_scope.form.allow_tag_allocation" />,
        WEBSITE_FUNC: intl => intl.formatMessage({ id: 'website' }),
    },
};

export const COMPANY_DELETE_MODAL = {
    HEADER_FUNC: name => <FormattedMessage id="company_delete_modal.header" values={{ name }} />,
    SELECTED_COMPANIES: <FormattedMessage id="company_delete_modal.selected_companies" />,
    NUMBER_OF_COMPANIES_SELECTED: number => <FormattedMessage id="number_of_companies_selected" values={{ number }} />,
};

export const NOTIFICATION_DELETE_MODAL = {
    TITLE_FUNC: name => <FormattedMessage id="notification_delete_modal.title" values={{ name }} />,
    TITLE_MULTI: <FormattedMessage id="notification_delete_modal.title_multi" />,
    SYSTEM_TITLE_FUNC: name => <FormattedMessage id="notification_delete_modal.system_title" values={{ name }} />,
    SYSTEM_TITLE_MULTI: <FormattedMessage id="notification_delete_modal.system_title_multi" />,
    NUMBER_OF_NOTIFICATIONS_SELECTED: number => <FormattedMessage id="number_of_notifications_selected" values={{ number }} />,
};

export const NOTIFICATION_MODAL = {
    TITLE: <FormattedMessage id="notification_edit_modal.title.add_notification" />,
    FORM: {
        LABEL: {
            NOTIFICATION_NAME: <FormattedMessage id="notification_details_modal.form.label.notification_name" />,
            NOTIFICATION_NAME_FUNC: intl => intl.formatMessage({ id: 'notification_details_modal.form.label.notification_name' }),
            CREATE_ZONE_SEVERITY_LEVEL_COMMENT_FUNC: intl => intl.formatMessage({ id: 'notification_edit_modal.form.label.create_zone_severity_level_comment' }),
            ZONE_SEVERITY_LEVEL_COMMENT_FUNC: intl => intl.formatMessage({ id: 'notification_details_modal.form.label.zone_severity_level_comment' }),
            NOTIFICATION_TYPE: <FormattedMessage id="notification_details_modal.form.label.notification_type" />,
            NOTIFICATION_METHOD: <FormattedMessage id="notification_details_modal.form.label.notification_method" />,
            SMS_TEXT: <FormattedMessage id="notification_details_modal.form.label.sms_text" />,
        },
    },
};

export const SUBSCRIBER_DELETE_MODAL = {
    TITLE_MULTI: <FormattedMessage id="subscriber_delete_modal.title_multi" />,
    TITLE_FUNC: name => <FormattedMessage id="subscriber_delete_modal.title" values={{ name }} />,
    NUMBER_OF_SUBSCRIBERS_SELECTED: number => <FormattedMessage id="number_of_subscribers_selected" values={{ number }} />,
};

export const SUBSCRIBER_EDIT_MODAL = {
    TITLE: <FormattedMessage id="subscriber_edit_modal.title.add_subscriber" />,
    FORM: {
        LABEL: {
            SUBSCRIBER_NAME_FUNC: intl => intl.formatMessage({ id: 'subscriber_details_modal.form.label.subscriber_name' }),
            PHONE_CODE_FUNC: intl => intl.formatMessage({ id: 'subscriber_edit_modal.form.label.phone_code' }),
        },
    },
    VALIDATION: {
        PHONE_CODE_INVALID_FUNC: intl => intl.formatMessage({ id: 'subscriber_edit_modal.validation.phone_code_invalid' }),
        PHONE_FORMAT_INVALID_FUNC: intl => intl.formatMessage({ id: 'subscriber_edit_modal.validation.phone_format_invalid' }),
        USER_EMAIL_FORMAT_INVALID_FUNC: intl => intl.formatMessage({ id: 'subscriber_edit_modal.validation.user_email_format_invalid' }),
    },
};

export const USER_DELETE_MODAL = {
    TITLE: <FormattedMessage id="user_delete_modal.header.delete_users" />,
    MESSAGE: {
        DELETE_SELECTED_USERS: <FormattedMessage id="user_delete_modal.message.delete_selected_users" />,
        DELETE_USER_FUNC: name => <FormattedMessage id="user_delete_modal.message.delete_user" values={{ name }} />,
        CANNOT_DELETE_CURRENT_USER: <FormattedMessage id="user_delete_modal.message.cannot_delete_current_user" />,
        HAVE_NO_PERMISSIONS: <FormattedMessage id="user_delete_modal.form.message.have_no_permissions" />,
    },
    NUMBER_OF_USERS_SELECTED: number => <FormattedMessage id="number_of_users_selected" values={{ number }} />,
};

export const USER_EDIT_MODAL_SYSTEM_SCOPE = {
    TITLE_ADD_NEW: <FormattedMessage id="user_edit_modal_system_scope.title.add_new_user" />,
    TITLE_EDIT_USER_FUNC: name => <FormattedMessage id="user_edit_modal_system_scope.title.edit_user" values={{ name }} />,
    FORM: {
        USER_TYPE: intl => intl.formatMessage({ id: 'user_type' }),
        USER_TYPE_SUPER_ADMIN: intl => intl.formatMessage({ id: 'user_edit_modal_system_scope.form.user_type.super_admin' }),
        ERROR_EMAIL_INVALID: <FormattedMessage id="user_edit_modal.validation.user_email_invalid" />,
        ERROR_EMAIL_EXIST: <FormattedMessage id="user_edit_modal.validation.user_email_exist" />,
    },
};

export const DASHBOARD_WIDGET_NAME = {
    [DASHBOARD.CURRENT_ALARMS_WIDGET]: <FormattedMessage id="alarms" />,
    [DASHBOARD.WIN_STATUS_WIDGET]: <FormattedMessage id="dashboard.win_status_widget.name" />,
    [DASHBOARD.CURRENT_SHIFT_WIDGET]: <FormattedMessage id="dashboard.current_shift_widget.name" />,
    [DASHBOARD.PERSON_ACTIVITY_WIDGET]: <FormattedMessage id="dashboard.person_activity_widget.name" />,
};

export const DASHBOARD_WIDGETS = {
    ALARM_WIDGET: {
        ALARM_TYPE_TAB_CHART_POPUP_TITLE_FUNC: intl => intl.formatMessage({ id: 'dashboard.alarm_widget.alarm_type_tab.chart.popup.title' }),
        ALARM_TYPE_TAB_TABLE_COUNT_TRACKABLES_COLUMN: <FormattedMessage id="dashboard.alarm_widget.alarm_type_tab.table.count_trackables_column" />,
        ALARM_TYPE_TAB_TABLE_PERCENTAGE_COLUMN: <FormattedMessage id="dashboard.alarm_widget.alarm_type_tab.table.percentage_column" />,
        ALARM_TYPE_TAB_TABLE_TOTAL: <FormattedMessage id="dashboard.alarm_widget.alarm_type_tab.table.total" />,

        ALARM_LIST_TAB: <FormattedMessage id="dashboard.alarm_widget.alarm_list_tab" />,
        ALARM_LIST_TAB_HEADER: <FormattedMessage id="site_view_trackable_popup.current_alarms" />,
        ALARM_LIST_TAB_TABLE_INFO_COLUMN: <FormattedMessage id="dashboard.alarm_widget.alarm_list_tab.table.info_column" />,
        ZONE_VIOLATIONS: <FormattedMessage id="zone_violations" />,
        UNCERTIFIED_OPERATIONS: <FormattedMessage id="uncertified_operations" />,
        EMERGENCY_CALLS: <FormattedMessage id="emergency_calls" />,
        LAST_UPDATED: <FormattedMessage id="last_updated" />,
    },

    WIN_STATUS_WIDGET: {
        ANCHORS_TAB_HEADER_BRIDGE: <FormattedMessage id="dashboard.win_status_widget.anchors_tab.header_bridge" />,
        ANCHORS_TAB_HEADER_ANCHOR: <FormattedMessage id="dashboard.win_status_widget.anchors_tab.header_anchor" />,
        ANCHORS_TAB_TABLE_NODE_NAME_COLUMN: (<Fragment><FormattedMessage id="anchor" />/<FormattedMessage id="db_names.bridge" /></Fragment>),
        ANCHORS_TAB_TABLE_NODE_TYPE_COLUMN: <FormattedMessage id="dashboard.win_status_widget.anchors_tab.table.node_type_column" />,
        ANCHORS_TAB_TABLE_INACTIVITY_COLUMN: <FormattedMessage id="dashboard.win_status_widget.anchors_tab.table.inactivity_column" />,

        TAGS_HEADER_TAGS: <FormattedMessage id="dashboard.win_status_widget.tags_tab.header_tags" />,
        TAGS_HEADER_LOW_BATTERY: <FormattedMessage id="dashboard.win_status_widget.tags_tab.header_low_battery" />,
        TAGS_TAB_TABLE_BATTERY_LEVEL_COLUMN: <FormattedMessage id="site_view_trackable_popup.battery_level" />,
    },

    CURRENT_SHIFT_WIDGET: {
        TIME_ELAPSED: <FormattedMessage id="time_elapsed" />,

        PEOPLE: <FormattedMessage id="people" />,
        VEHICLES: <FormattedMessage id="vehicles" />,
        OTHERS: <FormattedMessage id="others" />,
        ACTIVE: <FormattedMessage id="dashboard.current_shift_widget.active.zh" />,
        EXPECTED: <FormattedMessage id="expected" />,
        ACTUAL: <FormattedMessage id="actual" />,

        NO_ACTIVE_SHIFT: <FormattedMessage id="dashboard.current_shift_widget.no_active_shift" />,
    },

    PERSON_ACTIVITY_WIDGET: {
        CHECK_IN: intl => intl.formatMessage({ id: 'check_in' }),
        ACTIVE_TIME: intl => intl.formatMessage({ id: 'active_time' }),
    },
};

export const REPORTS_SIDE_BAR = {
    TRAVEL_DISTANCE: <FormattedMessage id="travel_distance" />,
    ZONE_ACTIVITY: <FormattedMessage id="zone_activity" />,
    PWS: <FormattedMessage id="pws_report" />,
    ATTENDANCE: <FormattedMessage id="attendance_report" />,
    ALARMS: <FormattedMessage id="alarms" />,
};

export const REPORTS_SELECTOR = {
    INFO_ZONE: <FormattedMessage id="reports.selector.info_zone" />,
    INFO_ZONE_DISCRIPTION: <FormattedMessage id="reports.selector.info_zone.discription" />,
    ACTIVITY_STATISTICS_DISTANCE: <FormattedMessage id="reports.selector.activity_statistics.distance" />,
    ACTIVITY_STATISTICS_DISTANCE_DISCRIPTION: <FormattedMessage id="reports.selector.activity_statistics.distance.discription" />,
    PWS_REPORT: <FormattedMessage id="reports.selector.pws" />,
    PWS_REPORT_DESCRIPTION: <FormattedMessage id="reports.selector.pws.description" />,
    ATTENDANCE_REPORT: <FormattedMessage id="reports.selector.attendance" />,
    ATTENDANCE_DESCRIPTION: <FormattedMessage id="reports.selector.attendance.description" />,
    ALARMS_REPORT: <FormattedMessage id="reports.selector.alarms" />,
    ALARMS_DESCRIPTION: <FormattedMessage id="reports.selector.alarms.description" />,
    SELECT_DAY: intl => intl.formatMessage({ id: 'reports.select_day' }),
};

export const REPORT_TABLE = {
    DATE_RANGE: <FormattedMessage id="date_range" />,
    HEADER_DURATION: <FormattedMessage id="accumulated_duration" />,
    ZONE_NAME: <FormattedMessage id="zone_name" />,
    PWS_TABLE: {
        HEADER_NAME: <FormattedMessage id="reports.pws.table.header.contact_name" />,
        CONTACTS: <FormattedMessage id="contacts" />,
        TOTAL_DURATION: <FormattedMessage id="total_duration" />,
        EXP_HEADER_DISTANCE: <FormattedMessage id="reports.pws.table.header.distance" />,
        EXP_HEADER_DURATION: <FormattedMessage id="reports.pws.table.header.duration" />,
    },
    ZONE_ACTIVITY_TABLE: {
        HEADER_ENTRY_COUNT: <FormattedMessage id="entry_count" />,
    },
    ALARMS_TABLE: {
        HEADER_SEVERITY: <FormattedMessage id="severity" />,
        HEADER_ALARMS_COUNT: <FormattedMessage id="reports.alarms.table.header.alarms_count" />,
        HEADER_ZONE_VIOLATIONS: <FormattedMessage id="zone_violations" />,
        HEADER_UNCERTIFIED_OPERATIONS: <FormattedMessage id="uncertified_operations" />,
        HEADER_EMERGENCY_CALLS: <FormattedMessage id="emergency_calls" />,
    },
    DISTANCE_TABLE: {
        HEADER_TIME_PERIOD: <FormattedMessage id="time_period" />,
        HEADER_DISTANCE: <FormattedMessage id="distance" />,
    },
    ATTENDANCE_TABLE: {
        TOTAL_TRACKABLES: <FormattedMessage id="total_trackables" />,
        HEADER_ON_SITE: <FormattedMessage id="reports.attendance.table.header.on_site" />,
        HEADER_IDLE: <FormattedMessage id="idle" />,
        HEADER_ACTIVE: <FormattedMessage id="active_lower" />,
        HEADER_TIMELINE: <FormattedMessage id="reports.attendance.table.header.timeline" />,
    },
};

export const TIMELINE_ACTIONS = {
    ACTIVE: <FormattedMessage id="active" />,
    IDLE: <FormattedMessage id="idle" />,
    UNRESPONSIVE: <FormattedMessage id="unresponsive" />,
    UNASSIGNED: <FormattedMessage id="unassigned" />,
};

export const USER_EDIT_MODAL = {
    VALIDATION: {
        USER_EMAIL_EXIST: intl => intl.formatMessage({ id: 'user_edit_modal.validation.user_email_exist' }),
        USER_EMAIL_INVALID: intl => intl.formatMessage({ id: 'user_edit_modal.validation.user_email_invalid' }),
        AT_LEAST_CHARACTERS: intl => intl.formatMessage({ id: 'user_edit_modal.validation.at_least_characters' }),
    },
    NOTIFICATION_WAS_SENT: <FormattedMessage id="user_edit_modal.notification_sent" />,
    NOTIFICATION_SEND: <FormattedMessage id="user_edit_modal.notification_send" />,
    TITLE_ADD: <FormattedMessage id="user_edit_modal.title.add_user" />,
};

export const USER_ACCESS_CONTROL_MODAL = {
    TITLE: {
        EDIT: <FormattedMessage id="user_access_control_edit.title" />,
        EDIT_FUNC: role => <FormattedMessage id="user_access_control_edit.title_2" values={{ role }} />,
    },
    ERRORS: {
        COULD_NOT_BE_EMPTY: <FormattedMessage id="user_access_control_edit.error.could_not_be_empty" />,
        ACTUAL_MINUTES_FUNC: value => <FormattedMessage id="user_access_control_edit.error.actual_minutes" values={{ value }} />
    }
}

export const ZONE_EDIT_ADMIN_PAGE_MODAL = {
    NOTIFY_MESSAGE: <FormattedMessage id="zone_edit_site_page_modal.notify_message" />,
};

export const ZONE_DELETE_MODAL = {
    SINGLE_DELETE_MESSAGE_FUNC: name => <FormattedMessage id="zone_delete_modal.single_delete_message" values={{ name }} />,
    BATCH_DELETE_MESSAGE: <FormattedMessage id="zone_delete_modal.batch_delete_message" />,
    NUMBER_OF_ZONES_SELECTED: number => <FormattedMessage id="number_of_zones_selected" values={{ number }} />,
};

export const ZONE_DETAILS_MODAL = {
    DOUBLE_CLICK_EXPAND: intl => intl.formatMessage({ id: 'zone_details_admin_modal.double_click_expand' }),
    DOUBLE_CLICK_COLLAPSE: intl => intl.formatMessage({ id: 'zone_details_admin_modal.double_click_collapse' }),
};

export const TABLES = {
    SEARCH: intl => intl.formatMessage({ id: 'tables.search' }),
    NO_DATA_TO_DISPLAY: <FormattedMessage id="tables.no.data.to.be.displayed" />,
    NO_AVAILABLE_REPORTS: <FormattedMessage id="tables.no.data.to.be.no_available" />,
};

export const ZONE_EDIT_MODAL = {
    LABEL_ROTATION: intl => intl.formatMessage({ id: 'rotation' }),
    ERRORS: {
        GEOMETRY_REQUIRED: <FormattedMessage id="zone_edit_modal.errors.geometry_required" />,
        GEOMETRY_REQUIRED_FUNC: intl => intl.formatMessage({ id: 'zone_edit_modal.errors.geometry_required' }),
        GEOMETRY_INTERSECTS_FUNC: intl => intl.formatMessage({ id: 'zone_edit_modal.errors.geometry_intersects' }),
    },
};

export const ZONE_ADD_CONFIGURATION_MODAL = {
    LABEL_ZONE_TYPE: intl => intl.formatMessage({ id: 'zone_type' }),
    LABEL_ADVANCED_OPTIONS: intl => intl.formatMessage({ id: 'trackable_edit_modal.form.advanced' }),
};

export const TRACKABLES_AND_GROUPS = {
    TITLE: <FormattedMessage id="trackables_and_groups.title" />,
    APPLY_TO: <FormattedMessage id="trackables_and_groups.apply_to" />,
    APPLY_TO_EXCEPT: <FormattedMessage id="trackables_and_groups.apply_to_except" />,
    APPLY_TO_ONLY: <FormattedMessage id="trackables_and_groups.apply_to_only" />,
};

export const SCHEDULE_FORM = {
    ACTIVITY_SCHEDULE: <FormattedMessage id="schedule_form.activity_schedule" />,
    CHECKBOX: <FormattedMessage id="schedule_form.checkbox" />,
};

export const ZONE_ADD_MODAL = {
    FORM_TITLE: <FormattedMessage id="zone_add_modal.form.title" />,
    BUTTON_RECTANGLE: <FormattedMessage id="zone_add_modal.button.rectangle" />,
    BUTTON_FREE_FORM: <FormattedMessage id="zone_add_modal.button.free_form" />,
};

export const SYSTEM_PAGE = {
    ANCHORS: <FormattedMessage id="shm_side_bar.system_monitor.win_anchors" />,
    SERVER: <FormattedMessage id="shm_side_bar.system_monitor.server" />,
    SITE_MONITOR: <FormattedMessage id="site_monitor_tab.site_monitor" />,
};

export const SHM_SERVER = {
    TITLE: <FormattedMessage id="shm_server.title" />,
    TABLE: {
        USED_COLUMN: <FormattedMessage id="shm_server.table.used_column" />,
        CAPACITY_COLUMN: <FormattedMessage id="shm_server.table.capacity_column" />,
        PERCENT_USED_COLUMN: <FormattedMessage id="shm_server.table.percent_used_column" />,
    },
    CATEGORY: {
        DISK_USAGE: intl => intl.formatMessage({ id: 'shm_server.table.disk_usage' }),
        MEMORY_USAGE: intl => intl.formatMessage({ id: 'shm_server.table.memory_usage' }),
        CPU_USAGE: intl => intl.formatMessage({ id: 'shm_server.table.cpu_usage' }),
    },
};

export const SHM_UPTIME_TABLE = {
    TITLE: <FormattedMessage id="shm_uptime_table.title" />,
    TABLE: {
        VERSION_COLUMN: <FormattedMessage id="login.copyright.version" />,
    },
};

export const SHM_ACTIVE_CONNECTION_TABLE = {
    TITLE: <FormattedMessage id="shm_active_connection_table.title" />,
    TABLE: {
        PORT_COLUMN: <FormattedMessage id="shm_active_connection_table.table.port_column" />,
        IP_COLUMN: <FormattedMessage id="shm_active_connection_table.table.ip_column" />,
    },
};

export const TRACKABLE_POP_UP = {
    BATTERY_LEVEL: intl => intl.formatMessage({ id: 'site_view_trackable_popup.battery_level' }),
    TAG_MAC: intl => intl.formatMessage({ id: 'site_trackables_table.text.mac' }),
    REPORTED: intl => intl.formatMessage({ id: 'site_view_trackable_popup.reported' }),
    GROUPS: intl => intl.formatMessage({ id: 'name_of_tabs.groups' }),
    DRIVER: intl => intl.formatMessage({ id: 'site_view_trackable_popup.driver' }),
    DRIVER_NAME: intl => intl.formatMessage({ id: 'site_view_trackable_popup.driver_name' }),
    DIRVER_GROUP: intl => intl.formatMessage({ id: 'site_view_trackable_popup.driver_group' }),
    VEHICLE: intl => intl.formatMessage({ id: 'site_view_trackable_popup.vehicle_name' }),
    VEHICLE_NAME: intl => intl.formatMessage({ id: 'site_view_trackable_popup.vehicle_name' }),
    VEHICLE_GROUP: intl => intl.formatMessage({ id: 'site_view_trackable_popup.vehicle_group' }),
    CURRENT_ALARMS: intl => intl.formatMessage({ id: 'site_view_trackable_popup.current_alarms' }),
    NOT_RESPONDING: intl => intl.formatMessage({ id: 'not_responding' }),
    TRACKABLE_NOT_RESPONDING: intl => intl.formatMessage({ id: 'site_view_trackable_popup.trackable_not_responding' }),
    VDA: {
        DRIVER_ALARMS: intl => intl.formatMessage({ id: 'site_view_vda_popup.driver_alarms' }),
        VEHICLE_ALARMS: intl => intl.formatMessage({ id: 'site_view_vda_popup.vehicle_alarms' }),
    },
    TRACKABLE_OR_TRACKABLES_FUNC: intl => intl.formatMessage({ id: 'trackable_or_trackables' }),
};

export const SITE_VIEW_TABLE = {
    ALARM_ACKNOWLEDGE: intl => intl.formatMessage({ id: 'alarms_acknowledge_modal.button_ack' }),
};

export const SITE_VIEW_UNRESPONSIVE_STATUS_BAR = {
    LABEL_FUNC: numOfHiddenTrackables => <FormattedMessage id="site_view_unresponsive_status_bar.label" values={{ numOfHiddenTrackables }} />,
};

export const RECENT_HEATMAP = {
    NAME: {
        CUSTOM_INTERVAL: intl => intl.formatMessage({ id: 'recent_heatmap_name.custom_interval_heatmap' }),
        LAST_HOURS: (intl, hours) => intl.formatMessage({ id: 'recent_heatmap_name.last_hours_heatmap' }, { hours }),
    },
    ERROR: {
        TITLE: intl => intl.formatMessage({ id: 'error_modal.title' }),
        HEATMAP_ERROR_MESSAGE: intl => intl.formatMessage({ id: 'error_modal.heatmap_error' }),
    },
};

export const COMPONENTS = {
    SELECT_COMPONENT_PLACEHOLDER: intl => intl.formatMessage({ id: 'components.select_component_placeholder' }),
    SELECT_COMPONENT_NO_RESULTS_TEXT: <FormattedMessage id="components.select_component_no_results_text" />,
    
    BUTTONS: {
        ASSIGN: <FormattedMessage id="assign" />,
        CANCEL: <FormattedMessage id="cancel" />,
        CHANGE_PASSWORD: <FormattedMessage id="edit_profile_modal.form.change_password" />,
        CLAIM: <FormattedMessage id="nodes_table_project_scope.button.claim" />,
        CLOSE: <FormattedMessage id="close" />,
        CONTINUE: <FormattedMessage id="continue" />,
        CREATE: <FormattedMessage id="create" />,
        DELETE: <FormattedMessage id="delete" />,
        GO_BACK: <FormattedMessage id="go_back" />,
        IMPORT: <FormattedMessage id="import" />,
        NEXT: <FormattedMessage id="next" />,
        OK: <FormattedMessage id="ok" />,
        RELEASE: <FormattedMessage id="release" />,
        SAVE: <FormattedMessage id="save" />,
        UNASSIGN: <FormattedMessage id="unassign" />,
        FULL_REPORT: <FormattedMessage id="full_report" />,
    },

    FIELDS: {
        USER: {
            EMAIL: <FormattedMessage id="email" />,
            EMAIL_FUNC: intl => intl.formatMessage({ id: 'email' }),
            EMAIL_ADDRESS: <FormattedMessage id="email_address" />,
            EMAIL_ADDRESS_FUNC: intl => intl.formatMessage({ id: 'email_address' }),
            FIRST_NAME_FUNC: intl => intl.formatMessage({ id: 'first_name' }),
            LAST_NAME_FUNC: intl => intl.formatMessage({ id: 'last_name' }),
            PASSWORD_FUNC: intl => intl.formatMessage({ id: 'password' }),
            PHONE: <FormattedMessage id="phone" />,
            PHONE_FUNC: intl => intl.formatMessage({ id: 'phone' }),
            PHONE_NUMBER: <FormattedMessage id="phone_number" />,
            PHONE_NUMBER_FUNC: intl => intl.formatMessage({ id: 'phone_number' }),
            RESET_PASSWORD: <FormattedMessage id="user_edit_modal.reset_password" />,
            SHOW_PASSWORD: <FormattedMessage id="change_password_modal.form.show_password" />,
            SUPER_ADMIN_USER: <FormattedMessage id="super_admin_users_tab.table.header.super_admin_user" />,
            USER_TYPE: <FormattedMessage id="user_type" />,
            ACCOUNT_EXPIRATION_TIMEOUT: <FormattedMessage id="account_expiration_timeout" />,
            SESSION_TIMEOUT: <FormattedMessage id="session_timeout" />
        },
        NODE: {
            ADVANCED: <FormattedMessage id="trackable_edit_modal.form.advanced" />,
            ADVANCED_SENSOR_INTEGRATION_PARAMETER: <FormattedMessage id="trackable_details_modal.form.sensor_integration_parameter" />,
            BATTERY: <FormattedMessage id="battery" />,
            BATTERY_FUNC: intl => intl.formatMessage({ id: 'battery' }),
            CATEGORY: <FormattedMessage id="category" />,
            FIRMWARE_VERSION: <FormattedMessage id="nodes_tab_company.table.header.firmware_version" />,
            GROUP: <FormattedMessage id="trackables_tab.table.header.group" />,
            GROUPS: <FormattedMessage id="name_of_tabs.groups" />,
            GROUPS_FUNC: intl => intl.formatMessage({ id: 'name_of_tabs.groups' }),
            LAST_UPDATED: <FormattedMessage id="last_updated" />,
            LAST_REPORTED: <FormattedMessage id="trackable_details_modal.form.last_reported" />,
            LAST_REPORTED_COLUMN: <FormattedMessage id="shm_win_anchors.table.last_reported_column" />,
            MAC_ADDRESS: <FormattedMessage id="mac_address" />,
            PROJECT_OWNERSHIP: <FormattedMessage id="nodes_tab_company.table.header.project_ownership" />,
            PWS_TITLE: <FormattedMessage id="group_edit_modal.form.pws.title" />,
            STATIONARY: <FormattedMessage id="stationary" />,
            TAG: <FormattedMessage id="trackables_tab.table.header.tag" />,
            TAG_MANAGEMENT: <FormattedMessage id="nodes_table_project_scope.title" />,
            TOTAL_COUNT_FUNC: count => <FormattedMessage id="trackable_readonly_table.total_count" values={{ count }} />,
            TRACKABLE: <FormattedMessage id="trackable" />,
            TRACKABLE_FUNC: intl => intl.formatMessage({ id: 'trackable' }),
        },
        ZONE: {
            ACTIVE_PERIOD: <FormattedMessage id="schedule_form.active_period" />,
            CREATE_NEW_ZONE: <FormattedMessage id="zone_add_modal.title" />,
            SEVERITY: <FormattedMessage id="site_zones_table.text.severity" />,
            SEVERITY_LEVEL: <FormattedMessage id="zones_table.table.header.severity_level" />,
            ZONE_SELECT_TYPE_MODAL_TITLE: <FormattedMessage id="zone_select_type_modal.title" />,
            ZONE_TYPE: <FormattedMessage id="zone_type" />,
        },
        SHIFT: {
            END: <FormattedMessage id="end" />,
            SHIFT: <FormattedMessage id="shift" />,
            START: <FormattedMessage id="start" />,
            WEEKDAYS: <FormattedMessage id="weekdays" />,
        },
        SUBSCRIBER: {
            SUBSCRIBER_NAME: <FormattedMessage id="subscriber_details_modal.form.label.subscriber_name" />,
            SUBSCRIBER_TITLE: <FormattedMessage id="subscriber_table.title" />,
            HEADER_NAME: <FormattedMessage id="subscriber_table.table.header.name" />,
        },
        COMMON: {
            USER_ROLES: <FormattedMessage id="user_roles" />,
            USERS_ACCESS_CONTROL: <FormattedMessage id="user_access_control" />,
            ROLE: <FormattedMessage id="role" />,
            DURATION: <FormattedMessage id="duration" />,
            ACTIONS: <FormattedMessage id="actions" />,
            ACTIVE: <FormattedMessage id="active" />,
            COLOR: <FormattedMessage id="color" />,
            COUNT: <FormattedMessage id="count" />,
            CUSTOM_INFO: <FormattedMessage id="custom_info" />,
            INACTIVE: <FormattedMessage id="inactive" />,
            NAME: <FormattedMessage id="name" />,
            NAME_FUNC: intl => intl.formatMessage({ id: 'name' }),
            NEVER_FUNC: intl => intl.formatMessage({ id: 'date_formatter.never' }),
            NO: <FormattedMessage id="no" />,
            PROJECT: <FormattedMessage id="project" />,
            STATUS: <FormattedMessage id="status" />,
            STATUS_INACTIVE: <FormattedMessage id="site_zones_table.text.status_inactive" />,
            TIME: <FormattedMessage id="time" />,
            TOTAL: <FormattedMessage id="total" />,
            TOTAL_COUNT_FUNC: count => <FormattedMessage id="table_subtitle.total_count" values={{ count }} />,
            TYPE: <FormattedMessage id="type" />,
            UID: <FormattedMessage id="uid" />,
            UNRESPONSIVE: <FormattedMessage id="unresponsive" />,
            VIEW_INFORMATION_FUNC: name => <FormattedMessage id="view_information" values={{ name }} />,
            YES: <FormattedMessage id="yes" />,
        },
        SITE: {
            AREA: <FormattedMessage id="area" />,
            AREA_FUNC: intl => intl.formatMessage({ id: 'area' }),
            DURATION: <FormattedMessage id="duration" />,
            FLOORPLAN: <FormattedMessage id="site_view_control.select_value.floorplan" />,
            FROM: <FormattedMessage id="from" />,
            PLAYBACK_TITLE: <FormattedMessage id="select_trackables_modals.playback_title" />,
            SITE: <FormattedMessage id="site" />,
            SITE_FUNC: intl => intl.formatMessage({ id: 'site' }),
            TO: <FormattedMessage id="to" />,
        },
        ALARM: {
            ALARM_TYPE: <FormattedMessage id="dashboard.alarm_widget.alarm_type_tab" />,
            ZONE_SEVERITY_LEVEL: <FormattedMessage id="dashboard.alarm_widget.alarm_list_tab.table.zone_severity_level_column" />,
        },
        COMPANY: {
            WEBSITE: <FormattedMessage id="website" />,
        },
    },

    VALIDATION: {
        REQUIRED: <FormattedMessage id="required" />,
        REQUIRED_FUNC: intl => intl.formatMessage({ id: 'required' }),
        MAXIMUM_LENGTH_FUNC: number => <FormattedMessage id="maximum_length" values={{ number }} />,
        MIN_LENGTH_FUNC: number => <FormattedMessage id="validation.max_length" values={{ number }} />,
        NAME_EXIST: <FormattedMessage id="subscriber_edit_modal.validation.name_exists" />,
        NAME_EXISTS_FUNC: intl => intl.formatMessage({ id: 'subscriber_edit_modal.validation.name_exists' }),
        NOT_A_NUMBER: <FormattedMessage id="components.not_a_number" />,
    },

    EDIT: intl => intl.formatMessage({ id: 'edit' }), // Edit
    SHOW_DETAILS: intl => intl.formatMessage({ id: 'components.details' }), // Show details
    DELETE: intl => intl.formatMessage({ id: 'delete' }), // Delete
};

export const ASSIGN_LOW_LATENCY_LINK_VALIDATION_MODAL = {
    TITLE: <FormattedMessage id="assign_low_latency_link_validation_modal.title" />,
    TEXT: macAddress => <FormattedMessage id="assign_low_latency_link_validation_modal.text" values={{ macAddress }} />,
};

export const MESSAGE_SUCCESS_SEND = {
    TITLE: <FormattedMessage id="message_success_send.title" />,
    TEXT: (message, recipient, time) => <FormattedMessage id="message_success_send.text" values={{ message, recipient, time }} />,
    TAGS_COUNT: (intl, count) => intl.formatMessage({ id: 'message_success_send.tags_count' }, { count }),
};

export const ZONE_CHOOSE_AREA_ADMIN_PAGE_MODAL = {
    ERRORS: {
        LOCATION: <FormattedMessage id="zone_choose_area_admin_page_modal.errors.location" />,
        SUBLOCATION: <FormattedMessage id="zone_choose_area_admin_page_modal.errors.sublocation" />,
    },
    CHOOSE_SITE: <FormattedMessage id="zone_choose_area_admin_page_modal.choose_site" />,
    CHOOSE_AREA: <FormattedMessage id="zone_choose_area_admin_page_modal.choose_area" />,
};

export const ZONE_VERTICES_LIMIT_MODAL = {
    YES_BUTTON: <FormattedMessage id="zone_vertices_limit_modal.yes_button" />,
    CANCEL_DRAWING_BUTTON: <FormattedMessage id="zone_vertices_limit_modal.cancel_drawing_button" />,
    UNDO_DRAWING_BUTTON: <FormattedMessage id="zone_vertices_limit_modal.undo_drawing_button" />,
    TITLE: <FormattedMessage id="zone_vertices_limit_modal.title" />,
    TEXT: number => <FormattedMessage id="zone_vertices_limit_modal.text" values={{ number }} />,
    QUESTION: <FormattedMessage id="zone_vertices_limit_modal.question" />,
};

// access could be via DB_NAMES[value](intl)
export const DB_NAMES = {
    // Alarm types
    ZONE_VIOLATION: intl => intl.formatMessage({ id: 'db_names.zone_violation' }),
    BUFFER_VIOLATION: intl => intl.formatMessage({ id: 'db_names.buffer_violation' }),
    ANCHOR_MOVED: intl => intl.formatMessage({ id: 'db_names.anchor_moved' }),
    EMERGENCY_BUTTON: intl => intl.formatMessage({ id: 'db_names.emergency_button' }),
    CALL_BUTTON_ALERT: intl => intl.formatMessage({ id: 'db_names.call_button_alert' }),
    UNCERTIFIED_OPERATION: intl => intl.formatMessage({ id: 'db_names.uncertified_operation' }),
    DEVICE_OUT_OF_ZONE: intl => intl.formatMessage({ id: 'db_names.device_out_of_zone' }),
    DEVICE_ABSENT: intl => intl.formatMessage({ id: 'db_names.device_absent' }),
    MAC_ADDRESS_CONFLICT: intl => intl.formatMessage({ id: 'db_names.mac_address_conflict' }),
    NODE_LOW_BATTERY: intl => intl.formatMessage({ id: 'db_names.node_low_battery' }),
    PWS_SAFETY: intl => intl.formatMessage({ id: 'db_names.pws_safety' }),

    ACTIVE: intl => intl.formatMessage({ id: 'active' }),
    INACTIVE: intl => intl.formatMessage({ id: 'inactive' }),
    IDLE: intl => intl.formatMessage({ id: 'idle' }),
    UNRESPONSIVE: intl => intl.formatMessage({ id: 'unresponsive' }),

    // Zone types
    KEEP_IN: intl => intl.formatMessage({ id: 'db_names.keep_in' }),
    KEEP_OUT: intl => intl.formatMessage({ id: 'db_names.keep_out' }),
    INFORMATION: intl => intl.formatMessage({ id: 'db_names.information' }),
    HEIGHT_RESTRICTION: intl => intl.formatMessage({ id: 'db_names.height_restriction' }),
    MAXIMUM_OCCUPANCY: intl => intl.formatMessage({ id: 'db_names.maximum_occupancy' }),
    ONE_WAY: intl => intl.formatMessage({ id: 'db_names.one_way' }),
    STOP_ZONE: intl => intl.formatMessage({ id: 'db_names.stop_zone' }),
    BOUNDARY_IN: intl => intl.formatMessage({ id: 'db_names.boundary_in' }),
    BOUNDARY_OUT: intl => intl.formatMessage({ id: 'db_names.boundary_out' }),
    STOP_NO_ALERT: intl => intl.formatMessage({ id: 'db_names.stop_no_alert' }),
    SLOW_ZONE: intl => intl.formatMessage({ id: 'db_names.slow_zone' }),
    CUSTOM_ZONE: intl => intl.formatMessage({ id: 'db_names.custom_zone' }),
    MUTE_ZONE: intl => intl.formatMessage({ id: 'db_names.mute_zone' }),

    // custom zone variables
    MAX_OCCUPANCY: intl => intl.formatMessage({ id: 'db_names.max_occupancy' }),
    HEIGHT: intl => intl.formatMessage({ id: 'db_names.height' }),
    UNIT: intl => intl.formatMessage({ id: 'db_names.unit' }),
    DIRECTION: intl => intl.formatMessage({ id: 'db_names.direction' }),

    // Node types
    ANCHOR: intl => intl.formatMessage({ id: 'anchor' }),
    MOBILE: intl => intl.formatMessage({ id: 'db_names.mobile' }),
    UNDEFINED: intl => intl.formatMessage({ id: 'db_names.undefined' }),
    BRIDGE: intl => intl.formatMessage({ id: 'db_names.bridge' }),
    NAV: intl => intl.formatMessage({ id: 'db_names.navigation' }),
    ASSET: intl => intl.formatMessage({ id: 'db_names.asset' }),
    NAVIGATION: intl => intl.formatMessage({ id: 'db_names.navigation' }),

    // Trackable category
    VEHICLE: intl => intl.formatMessage({ id: 'db_names.vehicle' }),
    PERSON: intl => intl.formatMessage({ id: 'db_names.person' }),
    UNSPECIFIED: intl => intl.formatMessage({ id: 'db_names.unspecified' }),

    NONE: intl => intl.formatMessage({ id: 'none' }),

    ALARM_KEEP_OUT_ADDITIONAL_INFO_TEXT_FUNC: (intl, name, level) => intl.formatMessage({ id: 'db_names.alarm_keep_out_additional_info_text' }, { name, level }),
    ALARM_KEEP_IN_ADDITIONAL_INFO_TEXT_FUNC: (intl, name, level) => intl.formatMessage({ id: 'db_names.alarm_keep_in_additional_info_text' }, { name, level }),
    
    // Notification
    ZONE_VIOLATION_ALARM: intl => intl.formatMessage({ id: 'db_names.zone_violation' }),
    BUFFER_VIOLATION_ALARM: intl => intl.formatMessage({ id: 'db_names.buffer_violation' }),
    LOW_BATTERY_ALARM: intl => intl.formatMessage({ id: 'db_names.notification_low_battery_alarm' }),
    TRACKABLE_UNRESPONSIVE: intl => intl.formatMessage({ id: 'db_names.trackable_unresponsive' }),

    // Pin values
    OFF: intl => intl.formatMessage({ id: 'pin.off' }),
    SOLID: intl => intl.formatMessage({ id: 'pin.solid' }),
    PULSE: intl => intl.formatMessage({ id: 'pin.pulse' }),
    ON: intl => intl.formatMessage({ id: 'pin.on' }),

    // Unresponsive filter
    '3MIN': intl => intl.formatMessage({ id: 'db_names.range.3min' }),
    '10MIN': intl => intl.formatMessage({ id: 'db_names.range.10min' }),
    '1HR': intl => intl.formatMessage({ id: 'db_names.range.1hr' }),
    '4HRS': intl => intl.formatMessage({ id: 'db_names.range.4hrs' }),
    '12HRS': intl => intl.formatMessage({ id: 'db_names.range.12hrs' }),
    '1DAY': intl => intl.formatMessage({ id: 'db_names.range.1day' }),
    '7DAYS': intl => intl.formatMessage({ id: 'db_names.range.7days' }),
    '30DAYS': intl => intl.formatMessage({ id: 'db_names.range.30days' }),

    // zone_manager statuses
    OUTDATED: intl => intl.formatMessage({ id: 'zone_manager.display.outdated' }),
    IN_PROCESS: intl => intl.formatMessage({ id: 'zone_manager.display.in_process' }),
    COMPLETE: intl => intl.formatMessage({ id: 'zone_manager.display.complete' }),
    UPDATED: intl => intl.formatMessage({ id: 'zone_manager.display.updated' }),
    OOSYNC: intl => intl.formatMessage({ id: 'zone_manager.display.oosync' }),
    LAST_SYNC: intl => intl.formatMessage({ id: 'zone_manager.display.last_sync' }),
};

export const NAVBAR = {
    EXPAND: intl => intl.formatMessage({ id: 'expand_navbar' }),
    COLLAPSE: intl => intl.formatMessage({ id: 'collapse_navbar' }),
};

export const PROJECT = intl => intl.formatMessage({ id: 'project' });

export const LABELS = {
    UNAVAILABLE: {
        LABEL: intl => intl.formatMessage({ id: 'labels.unavailable.label' }),
    },
    CUSTOM_INFO_PLACEHOLDER: intl => intl.formatMessage({ id: 'custom_info' }),
};

export const DATE_FORMATTER = {
    LESS_A_MIN: intl => intl.formatMessage({ id: 'date_formatter.less_min' }),
    LESS_5_MIN: intl => intl.formatMessage({ id: 'date_formatter.less_5_min' }),
    MORE_5_MIN: intl => intl.formatMessage({ id: 'date_formatter.more_5_min' }),
    MORE_30_MIN: intl => intl.formatMessage({ id: 'date_formatter.more_30_min' }),
    MORE_HOURE: intl => intl.formatMessage({ id: 'date_formatter.more_hour' }),
    MORE_6_HOURS: intl => intl.formatMessage({ id: 'date_formatter.more_6_hour' }),
    MORE_DAY: intl => intl.formatMessage({ id: 'date_formatter.more_day' }),
    MORE_WEEK: intl => intl.formatMessage({ id: 'date_formatter.more_week' }),
};

export const ALARM_NOTIFICATIONS = {
    NO_ALARMS: <FormattedMessage id="no_alarms" />,
    EMERGENCY_BUTTON: (intl, trackableName) => intl.formatMessage({ id: 'alarm_notifications.emergency_button' }, { trackableName }),
    ZONE_VIOLATION_EXITED: (intl, trackableName, zoneName) => intl.formatMessage({ id: 'alarm_notifications.zone_violation_exited' }, { trackableName, zoneName }),
    ZONE_VIOLATION_ENTERED: (intl, trackableName, zoneName) => intl.formatMessage({ id: 'alarm_notifications.zone_violation_entered' }, { trackableName, zoneName }),
    DEVICE_ABSENT: (intl, trackableName, zoneName) => intl.formatMessage({ id: 'alarm_notifications.device_absent' }, { trackableName, zoneName }),
    NODE_LOW_BATTERY: (intl, trackableName) => intl.formatMessage({ id: 'alarm_notifications.node_low_battery' }, { trackableName }),
    PWS_SAFETY: (intl, trackableName, contactName) => intl.formatMessage({ id: 'alarm_notifications.pws_safety' }, { trackableName, contactName }),
};

export const AUDIT_DOWNLOAD_MODAL = {
    RANGE_PICKER: {
        FROM: intl => intl.formatMessage({ id: 'audit_download_modal.range_picker.from' }),
        TO: intl => intl.formatMessage({ id: 'audit_download_modal.range_picker.to' }),
    },
    BUTTONS: {
        DOWNLOAD: <FormattedMessage id="audit_download_modal.buttons.download" />,
    },
    HEADER: <FormattedMessage id="audit_download_modal.header" />,
};

export const EDIT_ZONE_MODE = {
    EDIT_ZONE: <FormattedMessage id="edit_zone" />,
    ROTATE: <FormattedMessage id="rotate" />,
    WIDTH: <FormattedMessage id="width" />,
    CLOSE_SHAPE: <FormattedMessage id="close_shape" />,
};

export const LIVE_STATE = {
    LIVE: intl => intl.formatMessage({ id: 'live' }),
    NOT_RESPONDING: intl => intl.formatMessage({ id: 'not_responding' }),
    ALARM: intl => intl.formatMessage({ id: 'alarm' }),
};

export const TRACKABLE_OR_TRACKABLES_SELECTED = number => <FormattedMessage id="trackable_or_trackables_selected" values={{ number }} />;

export const LEAFLET = {
    DRAW: {
        RECTANGLE_TOOLTIP: {
            START: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_rectangle_tooltip_start' }),
        },
        SIMPLESHAPE_TOOLTIP: {
            END: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_simpleshape_tooltip_end' }),
        },
        POLYGON_TOOLTIP: {
            CONT: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_polygon_tooltip_cont' }),
            END: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_polygon_tooltip_end' }),
            START: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_polygon_tooltip_start' }),
        },
        POLYLINE_ERROR: intl => intl.formatMessage({ id: 'leaflet.draw_local_draw_handlers_polyline_error' }),
    },
    EDIT_TOOLTIP: {
        TEXT: intl => intl.formatMessage({ id: 'leaflet.draw_local_edit_handlers_edit_tooltip_text' }),
        SUBTEXT: intl => intl.formatMessage({ id: 'leaflet.draw_local_edit_handlers_edit_tooltip_subtext' }),
    },
};

export const ZONE_CHOOSE_CREATION_MODE = {
    SELECT_TOOL: <FormattedMessage id="zone_choose_creation_mode.select_tool" />,
    DRAW: <FormattedMessage id="zone_choose_creation_mode.draw" />,
    COORDINATES: <FormattedMessage id="zone_choose_creation_mode.coordinates" />,
};

export const ZONE_COORDINATE_ENTER = {
    SELF_INTERSECTION: intl => intl.formatMessage({ id: 'zone_coordinates_enter.self_intersection' }),
    CREATE_ZONE: intl => intl.formatMessage({ id: 'zone_add_modal.title' }),
    ENTER_COORDINATES: intl => intl.formatMessage({ id: 'zone_coordinates_enter.please_enter' }),
};

export const TAB_LABELS = {
    GENERAL: intl => intl.formatMessage({ id: 'general' }),
    ADVANCED: intl => intl.formatMessage({ id: 'advanced' }),
};

export const REPORT_BUTTON = {
    EXPORT_TABLE: <FormattedMessage id="export_table" />,
    EXPORT_CSV: <FormattedMessage id="reports.safety_alarm_table.export_csv" />,
    EXPORT_TITLE: intl => intl.formatMessage({ id: 'download_report' }),
    RUN_REPORT: <FormattedMessage id="reports.safety_filter.run_report" />,
    REFRESH_TABLE: <FormattedMessage id="refresh_table" />,
};

export const NO_PROJECTS_AVAILABLE = <FormattedMessage id="no_projects_available" />;

export const SHIFTS_MODAL = {
    DELETE: {
        DELETE_SELECTED_SHIFTS: <FormattedMessage id="shifts.delete_selected_shifts" />,
        DELETE_SHIFT: name => <FormattedMessage id="shifts.delete_shift" values={{ name }} />,
        NUMBER_OF_SHIFTS_SELECTED: number => <FormattedMessage id="number_of_shifts_selected" values={{ number }} />,
    },
    DETAIL: {
        SHIFT_NAME: <FormattedMessage id="shift_name" />,
        LOCATION_NAME: <FormattedMessage id="location_name" />,
        START_TIME: <FormattedMessage id="start_time" />,
        END_TIME: <FormattedMessage id="end_time" />,
        NOT_SPECIFIED: <FormattedMessage id="not_specified" />,
    },
    EDIT: {
        TITLE_ADD_NEW: <FormattedMessage id="shifts.modal.add_new" />,
        START_END: <FormattedMessage id="field_label.start_end" />,
        SELECT_TIME: intl => intl.formatMessage({ id: 'shifts.modal.select_time' }),
        WARNINGS: {
            NAME_DUPLICATES: <FormattedMessage id="shifts.warnings.name_duplicates" />,
            SHOULD_NOT_OVERLAP: <FormattedMessage id="shifts.warnings.should_not_overlap" />,
            NUMBER_POSITIVE_OR_EMPTY: <FormattedMessage id="validation.positive_or_empty" />,
        },
    },
    EXPECTED_PERSON: <FormattedMessage id="expected_person" />,
    EXPECTED_VEHICLE: <FormattedMessage id="expected_vehicle" />,
    EXPECTED_OTHERS: <FormattedMessage id="expected_others" />,
    NOT_SPECIFIED_TXT: intl => intl.formatMessage({ id: 'not_specified' }),
};

export const WEEKDAYS_SHORT = {
    0: <FormattedMessage id="weekdays_short.su" />,
    1: <FormattedMessage id="weekdays_short.mo" />,
    2: <FormattedMessage id="weekdays_short.tu" />,
    3: <FormattedMessage id="weekdays_short.we" />,
    4: <FormattedMessage id="weekdays_short.th" />,
    5: <FormattedMessage id="weekdays_short.fr" />,
    6: <FormattedMessage id="weekdays_short.sa" />,
};

export const WEEKDAYS_SHORT_TXT = {
    SU: intl => intl.formatMessage({ id: 'weekdays_short.su' }),
    MO: intl => intl.formatMessage({ id: 'weekdays_short.mo' }),
    TU: intl => intl.formatMessage({ id: 'weekdays_short.tu' }),
    WE: intl => intl.formatMessage({ id: 'weekdays_short.we' }),
    TH: intl => intl.formatMessage({ id: 'weekdays_short.th' }),
    FR: intl => intl.formatMessage({ id: 'weekdays_short.fr' }),
    SA: intl => intl.formatMessage({ id: 'weekdays_short.sa' }),
};

export const CHANGE_PASSWORD_POPUP = {
    TITLE: intl => intl.formatMessage({ id: 'change_password_popup.title' }),
    MESSAGE: intl => intl.formatMessage({ id: 'change_password_popup.message' }),
};

export const SELECT_A_TXT_FUNC = (intl, entity) => intl.formatMessage({ id: 'select_a_' }, { entity });
export const SELECT_A_FUNC = entity => (<FormattedMessage
    id="select_a_"
    values={{ entity: (<span className="capitalizedText">{entity}</span>) }}
/>);

export const DISABLED_FIELD_TEXT = {
    PWS_UNAVAILABLE_4_CATEGORY: (intl, cat) => intl.formatMessage({ id: 'disabled_field_tooltip.pws_unavailable_4_category' }, { cat }),
    ANNOUNCER_UNSUPPORTED_4_STATIONARY: intl => intl.formatMessage({ id: 'disabled_field_tooltip.announcer_unsupported_4_stationary' }),
    MONITOR_UNSUPPORTED_4_VEHICLE: intl => intl.formatMessage({ id: 'disabled_field_tooltip.monitor_unsupported_4_vehicle' }),
    STATIONARY_UNSUPPORTED_4_CATEGORY: (intl, cat) => intl.formatMessage({ id: 'disabled_field_tooltip.stationary_unsupported_4_category' }, { cat }),
};

export const INDICATION = {
    HAPTIC: intl => intl.formatMessage({ id: 'indication.haptic' }),
    BUZZER: intl => intl.formatMessage({ id: 'indication.buzzer' }),
};

export const UNITS = {
    SEC: intl => intl.formatMessage({ id: 'units.sec' }),
    METER: intl => intl.formatMessage({ id: 'units.meter' }),
};

export const ZONE_MANAGER = {
    HEADER: <FormattedMessage id="zone_manager.header" />, // 'Status summary',
    DISPLAY: {
        OUTDATED: <FormattedMessage id="zone_manager.display.outdated" />, // 'Outdated',
        IN_PROCESS: <FormattedMessage id="zone_manager.display.in_process" />, // 'In progress',
        COMPLETE: <FormattedMessage id="zone_manager.display.complete" />, // 'Complete',
        UPDATED: <FormattedMessage id="zone_manager.display.updated" />, // 'Updated',
        OOSYNC: <FormattedMessage id="zone_manager.display.oosync" />, // 'Out of sync',
        LAST_SYNC: <FormattedMessage id="zone_manager.display.last_sync" />, // 'Out of sync',
    },
    SYNC_SELECTED: <FormattedMessage id="zone_manager.sync_selected" />, // "Sync selected",
    SYNC_ALL: <FormattedMessage id="zone_manager.sync_all" />, // "Sync all",
    REFRESH_SELECTED: <FormattedMessage id="zone_manager.refresh_selected" />, // "Refresh selected",
};

export const VEHICLE_CERTIFICATION = {
    NAME: <FormattedMessage id="name" />,
    TRACKABLES: <FormattedMessage id="trackables" />,
    CERTIFICATION: <FormattedMessage id="certification" />,
    VEHICLE_MODELS: <FormattedMessage id="vehicle_models" />,
    LICENSED_DRIVERS: <FormattedMessage id="licensed_drivers" />,
    ACTIONS: <FormattedMessage id="actions" />,
    VEHICLES: <FormattedMessage id="vehicles" />,
    DRIVERS: <FormattedMessage id="drivers" />,
    MODEL: <FormattedMessage id="model" />,
    YES: <FormattedMessage id="yes" />,
    NO: <FormattedMessage id="no" />,
    TOTAL_COUNT_FUNC: count => <FormattedMessage id="table_subtitle.total_count" values={{ count }} />,
    MAX_LIMIT: (intl, count) => intl.formatMessage({ id: 'vehicle_class.max_limit' }, { count }),
    EDIT_CERTIFICATION_MODAL_TITLE: <FormattedMessage id="certification_bulk_edit.title" />,
    DELETE_CERTIFICATION_MODAL_TITLE: <FormattedMessage id="certification_delete.title" />,
    EDIT_CERTIFICATION_MODAL_MESSAGE: <FormattedMessage id="certification_bulk_edit.message" />,
    EDIT_CERT_CLASS_MODAL_TITLE: <FormattedMessage id="certification_class_add_new.title" />,
    DELETE_CERT_CLASS_MODAL_TITLE: <FormattedMessage id="certification_class_delete.title" />,
    EDIT_CERT_CLASS_MODAL_FORM_NAME: <FormattedMessage id="certification_class_add_new.form.name" />,
    EDIT_VEHICLE_MODAL_TITLE: <FormattedMessage id="vehicle_bulk_edit.title" />,
    DELETE_VEHICLE_MODAL_TITLE: <FormattedMessage id="vehicle_delete.title" />,
    EDIT_VEHICLE_MODAL_MESSAGE: <FormattedMessage id="vehicle_bulk_edit.message" />,
    BUTTON_SAVE: <FormattedMessage id="save" />,
    BUTTON_OK: <FormattedMessage id="ok" />,
    BUTTON_CANCEL: <FormattedMessage id="cancel" />,
};

export const DURATION_FIELD_DESCRIPTION = {
    FULL_FORMAT: <FormattedMessage id="duration_field.format.full" />,
    FORMAT_1M1S: <FormattedMessage id="duration_field.format.1m1s" />,
};

// TODO: find a proper place for this const in the future
export const NAME_ALREADY_EXISTS = <FormattedMessage id="validation.name_already_exists" />;

export const NOT_AVAILABLE = intl => intl.formatMessage({ id: 'not_available' });

export const COMMON_LABELS = {
    MINS_30: intl => intl.formatMessage({ id: '30_min' }),
    HOUR_1: intl => intl.formatMessage({ id: '1_hour' }),
    HOURS_2: intl => intl.formatMessage({ id: '2_hours' }),
    HOURS_4: intl => intl.formatMessage({ id: '4_hours' }),
    HOURS_8: intl => intl.formatMessage({ id: '8_hours' }),
    HOURS_16: intl => intl.formatMessage({ id: '16_hours' }),
    HOURS_24: intl => intl.formatMessage({ id: '24_hours' }),
    DAY_1: intl => intl.formatMessage({ id: '1_day' }),
    DAYS_7: intl => intl.formatMessage({ id: '7_days' }),
    DAYS_30: intl => intl.formatMessage({ id: '30_days' }),
    DAYS_90: intl => intl.formatMessage({ id: '90_days' }),
    DAYS_180: intl => intl.formatMessage({ id: '180_days' }),
    DAYS_365: intl => intl.formatMessage({ id: '365_days' }),
    USER_SESSION_TIMEOUT: <FormattedMessage id="user_session_timeout" />,
    SESSION_EXPIRED: <FormattedMessage id="session_expired" />,
    SESSION_EXPIRATION_WARN: <FormattedMessage id="session_expiration_warning" />,
    SESSION_EXPIRATION_MSG: <FormattedMessage id="session_expiration_message" />,
    SESSION_EXPIRED_MSG: time => <FormattedMessage id="session_expired_message" values={{ time }} />,
    TIME_REMAINING_MSG: time => <FormattedMessage id="time_remaining_message" values={{ time }} />,
    STAY_LOGGED: <FormattedMessage id="stay_logged_in" />,
    LOGOUT_NOW: <FormattedMessage id="logout_now" />,
    MAC_ADDRESS_FUNC: intl => intl.formatMessage({ id: 'mac_address' }),
    ZONES: <FormattedMessage id="zones" />,
    STATUS: <FormattedMessage id="status" />,
    ACTIVE_FUNC: intl => intl.formatMessage({ id: 'active' }),
    INACTIVE_FUNC: intl => intl.formatMessage({ id: 'inactive' }),
    INACTIVE: <FormattedMessage id="inactive" />,
    CUSTOM_INFO: <FormattedMessage id="custom_info" />,
    TRACKABLES_GROUPS: <FormattedMessage id="trackables_and_groups.title" />,
    APPLY_TO_EXCEPT: <FormattedMessage id="trackables_and_groups.apply_to_except" />,
    APPLY_TO_ONLY: <FormattedMessage id="trackables_and_groups.apply_to_only" />,
    ZONE_BULK_EDIT_AVAILABLE: intl => intl.formatMessage({ id: 'options_available_only' }),
    ENTER_INFO_FUNC: intl => intl.formatMessage({ id: 'enter_your_info' }),
    REQUIRED_SELECT_MULTIPLE_ZONES_FUNC: intl => intl.formatMessage({ id: 'required_select_multiple_zones' }),
    INVALID_TIME_FUNC: intl => intl.formatMessage({ id: 'invalid_time_value' }),
}
