import React from 'react';
import PropTypes from 'prop-types';
import { store } from 'stores/configureStore';


const withReducer = (key, reducer) => (WrappedComponent) => {
    const Extended = (props) => {
        store.injectReducer(key, reducer);
        return (<WrappedComponent {...props} />);
    };
    
    Extended.contextTypes = {
        store: PropTypes.object,
    };
    
    return Extended;
};

export { withReducer };
