import React, { PureComponent } from 'react';
import { connect } from 'react-redux';
import PropTypes from 'prop-types';

import { clearAdminPageSelectedItems } from '../../stores/actions';

const withTab = (WrappedComponent) => {
    class ChildTab extends PureComponent {
        static propTypes = {
            dispatch: PropTypes.func,
        };
        
        static defaultProps = {
            dispatch: () => {},
        };
        
        componentWillUnmount() {
            this.props.dispatch(clearAdminPageSelectedItems());
        }
        
        render() {
            return (
                <WrappedComponent
                    {...this.props}
                />
            );
        }
    }
    return connect()(ChildTab);
};

export default withTab;

