import React from 'react';
import PropTypes from 'prop-types';

const InfoTable = props => (
    <table className="table table-striped">
        <tbody>
            {Object.keys(props.rowInfo).map(key => (
                <tr key={key}>
                    <td style={{ width: props.widthMerge }} />
                    <td style={{ width: props.widthKey }}>
                        <div style={{ float: 'left' }}>{key}</div>
                    </td>
                    <td style={{ width: props.widthValue }}>
                        <div style={{ float: 'left' }}>
                            {props.rowInfo[key]}
                        </div>
                    </td>
                </tr>
            ))}
        </tbody>
    </table>);

InfoTable.defaultProps = {
    rowInfo: {},
    widthMerge: '5%',
    widthKey: '25%',
    widthValue: '70%',
};

InfoTable.propTypes = {
    rowInfo: PropTypes.shape(),
    widthMerge: PropTypes.string,
    widthKey: PropTypes.string,
    widthValue: PropTypes.string,
};

export default InfoTable;
