import React, { useEffect } from 'react';
import PropTypes from 'prop-types';
import PagesLoader from 'components/PagesLoader';
import { loadEntities } from 'stores/actions';
import store from 'stores/LocationStore';


export default function Loading(props) {
    useEffect(() => {
        props.dispatch(loadEntities(props.access));
    }, []);
    const hostName = store.getHostName();

    return (
        <div className="AppLayout-Loading">
            <div className="text-center">
                <img
                    src={`${hostName}/logo/company-logo.png`}
                    className="Loading-Brand"
                    alt=":("
                />
            </div>
            <PagesLoader marginTop="0px" />
        </div>
    );
}


Loading.propTypes = {
    dispatch: PropTypes.func,
    access: PropTypes.shape({}),
};

Loading.defaultProps = {
    dispatch: () => { },
    access: {},
};
