import React, { PureComponent } from 'react';
import PropTypes from 'prop-types';
import { FOOTER } from 'common/ui-labels';
import { getCurrentFormattedVersion } from 'utils/utils';


class CopyRight extends PureComponent {
    static propTypes = {
        isSidebarCollapsed: PropTypes.bool,
    };

    static defaultProps = {
        isSidebarCollapsed: false,
    };

    render() {
        const { isSidebarCollapsed } = this.props;

        return (
            <div className="copyright">
                { !isSidebarCollapsed && <div className="version">
                    {FOOTER.VERSION} { getCurrentFormattedVersion() }
                </div> }
                <div className="powered-by">
                    Powered by <br /> { isSidebarCollapsed ? 'RPP' : 'Redpoint Positioning Corporation' }
                </div>
            </div>
        );
    }
}

export default CopyRight;
