import React, { Component } from 'react';
import Header from './Header';
import TopButtons from './TopButtons';
import CompanyProjectBlock from './CompanyProjectBlock';
import NavigationMenu from './NavigationMenu';
import UserMenu from './UserMenu';
import CollapseSidebarButton from './CollapseSidebarButton';
import CopyRight from './CopyRight';


class NavBar extends Component {
    constructor(props) {
        super(props);
        this.state = { isSidebarCollapsed: false };
    }

    expandSidebar = () => this.setState({ isSidebarCollapsed: false });

    collapseSidebar = () => {
        const { isSidebarCollapsed } = this.state;
        this.setState({ isSidebarCollapsed: !isSidebarCollapsed });
    };

    render() {
        const { isSidebarCollapsed } = this.state;

        return (
            <div className={`RPP-Nav ${isSidebarCollapsed ? ' collapsed' : ''}`}>
                <Header isSidebarCollapsed={isSidebarCollapsed} />

                <TopButtons isSidebarCollapsed={isSidebarCollapsed} />

                <CompanyProjectBlock isSidebarCollapsed={isSidebarCollapsed} />

                <NavigationMenu
                    isSidebarCollapsed={isSidebarCollapsed}
                    expandSidebar={this.expandSidebar}
                />
                
                <UserMenu isSidebarCollapsed={isSidebarCollapsed} />

                <CollapseSidebarButton
                    collapseSidebar={this.collapseSidebar}
                    isSidebarCollapsed={isSidebarCollapsed}
                />

                <CopyRight isSidebarCollapsed={isSidebarCollapsed} />
            </div>
        );
    }
}

export default NavBar;
