import React, { Component } from 'react';
import PropTypes from 'prop-types';


export default class NotificationMessage extends Component {
    static propTypes = {
        message: PropTypes.shape({}),
        show: PropTypes.bool,
    };
    static defaultProps = {
        message: {},
        show: true,
    };
    
    constructor(props) {
        super(props);
        
        this.state = {
            showNotifyButton: true,
        };
    }
    
    render() {
        if (this.state.showNotifyButton && this.props.show) {
            return (
                <div
                    className="Drawing-Notify-Button-Hide"
                    onClick={() => {
                        this.setState({
                            showNotifyButton: false,
                        });
                    }}
                >
                    <div className="Drawing-Notify-Button">
                        <div className="Drawing-Notify-Button-Pulse">
                            {this.props.message}
                        </div>
                    </div>
                </div>
            );
        }
        return null;
    }
}
