import React from 'react';
import PropTypes from 'prop-types';
import LeafletNearMissEventMarkers from './LeafletNearMissEventMarkers';


export default function LeafletNearMiss(props) {
    const { byUid, reportUid } = props.nearMissReport;
    const isNearMissReady = byUid[reportUid] && byUid[reportUid].ready;
    
    if (!isNearMissReady) {
        return null;
    }
    
    return (
        <LeafletNearMissEventMarkers
            events={byUid[reportUid].events || []}
        />
    );
}


LeafletNearMiss.propTypes = {
    nearMissReport: PropTypes.shape({
        byUid: PropTypes.shape(),
        reportUid: PropTypes.string,
    }),
};

LeafletNearMiss.defaultProps = {
    nearMissReport: {
        byUid: {},
        reportUid: null,
    },
};
