import React from 'react';
import { DebounceInput } from 'react-debounce-input';

const RenderDebouncedInput = (i, j, className) => ({
    input, label, dataId, dataCy, type, min, max, step, meta: { touched, error, warning }, disabled, autoFocus, placeholder,
}) => (
    <div>
        <div className={`${className || 'Form-Label'} col-md-${i}`}>
            {label}
        </div>
        <div className={`col-md-${j}`}>
            <DebounceInput
                {...input}
                min={min}
                max={max}
                step={step}
                type={type}
                disabled={disabled}
                data-id={dataId}
                data-cy={dataCy}
                className="input"
                autoFocus={autoFocus}
                placeholder={placeholder}
                debounceTimeout={500}
            />
            {touched && (
                (error && <span className="error">{error}</span>)
                ||
                (warning && <span className="warning"><span>{warning}</span></span>)
            )}
        </div>
    </div>
);

export default RenderDebouncedInput;
