import React from 'react';

import RenderTooltipHelper from 'components/RenderTooltipHelper';

const RenderFieldWithPadding = (i, j, className, paddingLeft) => ({
    input, label, dataId, dataCy, type, min, max, step, meta: { touched, error, warning }, disabled, autoFocus, placeholder,
    tooltip, lowerIndexText,
}) => (
    <div>
        {paddingLeft ? <div className={`${className || 'Form-Label'} col-md-${paddingLeft}`} /> : <div />}
        <div className={`${className || 'Form-Label'} col-md-${i}`}>
            {label}
            {tooltip && <RenderTooltipHelper
                tooltipText={tooltip}
            />}
            {lowerIndexText && <div style={{ display: 'block', fontSize: '10px' }} >{lowerIndexText}</div>}
        </div>
        <div className={`col-md-${j}`}>
            <input
                {...input}
                min={min}
                max={max}
                step={step}
                type={type}
                disabled={disabled}
                data-id={dataId}
                data-cy={dataCy}
                className="input"
                autoFocus={autoFocus}
                placeholder={placeholder}
            />
            {touched && (
                (error && <span className="error">{error}</span>) ||
                (warning && <span className="warning"><span>{warning}</span></span>)
            )}
        </div>
    </div>
);

export { RenderFieldWithPadding };
