import React from 'react';

const RenderInputField = () => ({
    input, dataId, dataCy, type, min, max, step, meta: { touched, error }, disabled, autoFocus,
}) => (
    <div>
        <input
            {...input}
            min={min}
            max={max}
            step={step}
            type={type}
            disabled={disabled}
            data-id={dataId}
            data-cy={dataCy}
            className="input"
            autoFocus={autoFocus}
        />
        {touched && error && <span className="error">{error}</span>}
    </div>
);


export default RenderInputField;
