import React from 'react';
import PropTypes from 'prop-types';

const RenderInputTypeNumber = ({
    input, dataId, dataCy, min, max, step, meta: { error }, readOnly,
}) => (
    <div className="d-inline-block">
        <input
            {...input}
            min={min}
            max={max}
            step={step}
            type="number"
            readOnly={readOnly}
            data-id={dataId}
            data-cy={dataCy}
            className={error ? 'invalid-field-text-color' : ''}
        />
    </div>
);

RenderInputTypeNumber.propTypes = {
    max: PropTypes.string,
    min: PropTypes.string,
    step: PropTypes.string,
    dataId: PropTypes.string,
    dataCy: PropTypes.string,
    disabled: PropTypes.bool,
    readOnly: PropTypes.bool,
    input: PropTypes.shape({
        onChange: PropTypes.func,
        value: PropTypes.string,
    }),
    meta: PropTypes.shape({
        error: PropTypes.string,
    }),
};

RenderInputTypeNumber.defaultProps = {
    max: '0',
    min: '0',
    step: '0',
    dataId: '',
    dataCy: '',
    disabled: false,
    readOnly: false,
    input: {
        onChange: () => {

        },
        value: '',
    },
    meta: {
        error: '',
    },
};

export default RenderInputTypeNumber;
