import React, { Fragment } from 'react';
import InputElement from 'react-input-mask';
import PropTypes from 'prop-types';

const RenderMacField = ({ input: { value, onChange }, meta: { touched, error }, style, dataId, dataCy }) => (
    <Fragment>
        <InputElement
            name="mac"
            className="input"
            style={style}
            mask="**-**-**-**-**-**"
            data-id={dataId}
            data-cy={dataCy}
            value={value}
            onChange={onChange}
        />
        {touched && error && <span className="error">{error}</span>}
    </Fragment>
);

RenderMacField.propTypes = {
    style: PropTypes.shape({}),
    input: PropTypes.shape({
        onChange: PropTypes.func,
        value: PropTypes.string,
    }),
    meta: PropTypes.shape({
        touched: PropTypes.bool,
        error: PropTypes.oneOfType([PropTypes.shape({}), PropTypes.string]),
    }),
    dataId: PropTypes.string,
    dataCy: PropTypes.string,
};

RenderMacField.defaultProps = {
    style: {},
    input: {
        onChange: () => {

        },
        value: '',
    },
    meta: {
        touched: false,
        error: '',
    },
    dataId: '',
    dataCy: '',
};

export default RenderMacField;
