import React, { Fragment } from 'react';
import Slider from '@material-ui/core/Slider';
import PropTypes from 'prop-types';

const RenderSlider = ({ input: { value, onChange }, meta: { touched, error } }) => (
    <Fragment>
        <Slider
            onChange={(event, val) => onChange(val)}
            value={value}
            aria-labelledby="discrete-slider"
            valueLabelDisplay="auto"
            step={0.5}
            min={0.1}
            max={5}
            marks
        />
        {touched && error && <span className="error">{error}</span>}
    </Fragment>
);

RenderSlider.propTypes = {
    input: PropTypes.shape({
        value: PropTypes.oneOfType([PropTypes.shape(), PropTypes.number, PropTypes.string]),
        onChange: PropTypes.func,
        onBlur: PropTypes.func,
    }),
    meta: PropTypes.shape({
        warning: PropTypes.string,
        error: PropTypes.string,
    }),
};

RenderSlider.defaultProps = {
    input: {},
    meta: {
        warning: '',
        error: '',
    },
};

export default RenderSlider;
