import React from 'react';
import PropTypes from 'prop-types';

const RenderTextArea = ({ input, dataId, placeholder, meta: { touched, error, warning } }) => (
    <div>
        <textarea {...input} placeholder={placeholder} className="RPP-Group-advanced-TextArea" data-id={dataId} />
        {touched && ((error && <span className="error">{error}</span>) || (warning && <span>{warning}</span>))}
    </div>
);

RenderTextArea.propTypes = {
    dataId: PropTypes.string,
    placeholder: PropTypes.string,
    input: PropTypes.shape({
        value: PropTypes.oneOfType([PropTypes.shape(), PropTypes.number, PropTypes.string]),
        onChange: PropTypes.func,
        onBlur: PropTypes.func,
    }),
    meta: PropTypes.shape({
        warning: PropTypes.string,
        error: PropTypes.string,
    }),
};

RenderTextArea.defaultProps = {
    dataId: '',
    placeholder: '',
    input: {},
    meta: {
        warning: '',
        error: '',
    },
};

export default RenderTextArea;
