import React from 'react';
import PropTypes from 'prop-types';
import { COMPONENTS } from 'common/ui-labels';


export default function SaveButtons(props) {
    const { close, submit, submitted, disabled, dataId } = props;
    
    return (
        <div className="Form-Buttons">
            <button
                type="button"
                onClick={submit}
                data-id={`${dataId}-button-save`}
                disabled={disabled || submitted}
            >
                <div className={`${submitted ? 'spinner' : ''}`} style={{ position: 'relative' }}>
                    {COMPONENTS.BUTTONS.SAVE}
                </div>
            </button>
            <button
                type="button"
                data-id={`${dataId}-button-cancel`}
                onClick={close}
                disabled={submitted}
            >
                {COMPONENTS.BUTTONS.CANCEL}
            </button>
        </div>
    );
}

SaveButtons.propTypes = {
    submit: PropTypes.func,
    close: PropTypes.func,
    submitted: PropTypes.bool,
    disabled: PropTypes.bool,
    dataId: PropTypes.string,
};

SaveButtons.defaultProps = {
    submit: () => {},
    close: () => {},
    submitted: false,
    disabled: false,
    dataId: '',
};
