import React from 'react';
import PropTypes from 'prop-types';
import { Field } from 'redux-form';
import { ZONE_ADD_CONFIGURATION_MODAL } from 'common/ui-labels';
import RenderBox from '../../RenderBox';


function AdvancedOptionsControl(props) {
    return (
        <div className="Form-Line row">
            <div className="Form-Label col-md-5" style={{ color: 'grey' }}>
                {ZONE_ADD_CONFIGURATION_MODAL.LABEL_ADVANCED_OPTIONS(props.intl)}
            </div>
            <div
                className="col-md-1 Custom-Rotated-Checkbox"
                data-id="trackable-edit-advanced"
                data-cy="zone-edit-advanced"
                data-collapsed={props.show}
            >
                <Field
                    name="advanced_options"
                    id="advanced_options"
                    component={RenderBox}
                    type="checkbox"
                />
            </div>
            <div
                className="col-md-7"
            />
        </div>
    );
}

AdvancedOptionsControl.propTypes = {
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
    show: PropTypes.bool,
};

AdvancedOptionsControl.defaultProps = {
    intl: {
        formatMessage: () => {},
    },
    show: false,
};

export default AdvancedOptionsControl;
