import React from 'react';
import PropTypes from 'prop-types';
import { injectIntl } from 'react-intl';


const CustomZoneInfoOptions = ({ zonePrototype, user_params, zones, intl }) => {
    if (zonePrototype && zonePrototype.variables) {
        return zonePrototype.getModalInfoCustomOptions(user_params, zones, intl).map((variable) => {
            const { label, value } = variable;
            return (
                <div className="row Form-Line">
                    <div className="col-md-5 Form-Label">{label}</div>
                    <div className="col-md-7 Form-Value" data-id="zone-details-sublocations-name">{value}</div>
                </div>
            );
        });
    }
    
    return (
        <section />
    );
};

CustomZoneInfoOptions.propTypes = {
    zones: PropTypes.arrayOf(PropTypes.shape()),
    user_params: PropTypes.shape({}),
    zonePrototype: PropTypes.shape(),
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
};

CustomZoneInfoOptions.defaultProps = {
    zones: [],
    user_params: {},
    zonePrototype: {},
    intl: {
        formatMessage: () => {
        },
    },
};

export default injectIntl(CustomZoneInfoOptions);
