import React from 'react';
import { Field } from 'redux-form';
import PropTypes from 'prop-types'
import RenderBox from 'components/modals/RenderBox';

export default function GeometryOptionsControl(props) {
    return (
        <div className="Form-Line row">
            <div className="Form-Label col-md-5" style={{ color: 'grey' }}>
                Geometry
            </div>
            <div
                className="col-md-1 Custom-Rotated-Checkbox"
                data-id="trackable-edit-geometry"
                data-cy="zone-edit-geometry"
                data-collapsed={props.show}
            >
                <Field
                    name="geometry_options"
                    id="geometry_options"
                    component={RenderBox}
                    type="checkbox"
                />
            </div>
            <div
                className="col-md-7"
            />
        </div>
    );
}

GeometryOptionsControl.propTypes = {
    show: PropTypes.bool,

}

GeometryOptionsControl.defaultProps = {
    show: false,
}
