import React from 'react';
import PropTypes from 'prop-types';
import { AppContext } from './AppContext';
import config from '../config/config';

export function AppProvider({ children }) {
    return (
        <AppContext.Provider value={{ config }}>
            {children}
        </AppContext.Provider>
    );
}

AppProvider.propTypes = {
    children: PropTypes.oneOfType([
        PropTypes.arrayOf(PropTypes.node),
        PropTypes.node,
    ]),
};

AppProvider.defaultProps = {
    children: null,
};
