import { Field, FormSection } from 'redux-form';
import React from 'react';
import PropTypes from 'prop-types';

import { GROUP_EDIT_MODAL, COMPONENTS } from '../../../common';
import { sensorSpecialCasesListQ2 } from '../../../utils';

const SensorInterfaceSection = ({ isAdvanced }) => (
    <FormSection name="sensorSpecialCases">
        <div
            className="Form-Line container-fluid RPP-Group-advanced"
            style={{ display: isAdvanced ? 'block' : 'none' }}
        >
            <h4 className="RPP-Group-advanced-border-title">{COMPONENTS.FIELDS.NODE.ADVANCED_SENSOR_INTEGRATION_PARAMETER}</h4>
            <div className="col-md-12" style={{ marginTop: '15px' }}>
                <div className="col-md-6">
                    <h3>{GROUP_EDIT_MODAL.FORM.SPECIAL_FUNCTIONS}:</h3>
                    <table className="table table-striped" id="RPP-Group-sensor-interface-table">
                        <tbody>
                            {sensorSpecialCasesListQ2.map(key => (
                                <tr key={key}>
                                    <td> {key} </td>
                                    <td>
                                        <Field
                                            name={key}
                                            component="input"
                                            data-cy={`sensor-${key}`}
                                            type="checkbox"
                                        />
                                    </td>
                                </tr>
                            ))}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </FormSection>
);

SensorInterfaceSection.propTypes = {
    isAdvanced: PropTypes.bool,
};

SensorInterfaceSection.defaultProps = {
    isAdvanced: false,
};

export default SensorInterfaceSection;
