import React from 'react';
import AlarmModals from './alarm';
import UserModals from './user';
import ProjectModals from './project';
import CompanyModals from './company';
import CommonModals from './commonModals';
import GroupModals from './group';
import TrackableModals from './trackable';
import AssignModals from './assign';
import NodeModals from './node';
import MessageModals from './message';
import ZoneModals from './zone';
import AuthModals from './auth';
import NotificationModals from './notification';
import SubscribersModals from './subscribers';
import ShiftModals from './shift';

const style = {
    overlay: {
        position: 'fixed',
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        backgroundColor: 'rgba(255, 255, 255, 0.75)',
        zIndex: '1000',
        overflow: 'visible',
    },
    content: {
        width: '500px',
        height: 'auto',
        top: '40%',
        left: '50%',
        right: 'auto',
        bottom: 'auto',
        marginRight: '-50%',
        transform: 'translate(-50%, -50%)',
        boxShadow: '0px 0px 37px 5px rgba(189,183,189,1)',
        overflow: 'visible',
    },
};

export default function Modals() {
    return (
        <div>
            <AlarmModals style={style} />
            <UserModals style={style} />
            <GroupModals style={style} />
            <ProjectModals style={style} />
            <CompanyModals style={style} />
            <CommonModals style={style} />
            <TrackableModals style={style} />
            <AssignModals style={style} />
            <NodeModals style={style} />
            <MessageModals style={style} />
            <ZoneModals style={style} />
            <NotificationModals style={style} />
            <SubscribersModals style={style} />
            <AuthModals style={style} />
            <ShiftModals style={style} />
        </div>
    );
}
