import React from 'react';
import PropTypes from 'prop-types';
import { Field } from 'redux-form';
import { COMPONENTS, TRACKABLE_MODAL } from 'common/ui-labels';
import { filterSelectBoxOptions } from 'utils/utils';
import MultiSelectComponent from 'components/modals/MultiSelectComponent';

export function GroupsForm({ groups_checkbox, intl, groups }) {
    return (
        <section>
            <div className="Form-Line row">
                <div className="Form-Label col-md-4" data-id="trackable-bulk-edit-groups-checkbox-text">
                    {TRACKABLE_MODAL.EDIT.FORM.GROUPS}
                </div>
                <div className="col-md-1" data-id="trackable-bulk-edit-groups-checkbox">
                    <Field
                        name="groups_checkbox"
                        id="groups_checkbox"
                        component="input"
                        type="checkbox"
                        style={{ width: '19px', height: '19px' }}
                    />
                </div>
            </div>

            <div className="Form-Line row" style={{ textAlign: 'center', marginTop: '15px', display: groups_checkbox ? 'block' : 'none' }}>
                <div className="Form-Label col-md-4" />
                <div className="col-md-8" data-id="trackable-bulk-edit-group-list">
                    <Field
                        name="groupList"
                        type="text"
                        label="Objective"
                        options={groups}
                        filterOptions={filterSelectBoxOptions}
                        placeholder={COMPONENTS.SELECT_COMPONENT_PLACEHOLDER(intl)}
                        noResultsText={COMPONENTS.SELECT_COMPONENT_NO_RESULTS_TEXT}
                        component={MultiSelectComponent}
                    />
                </div>
            </div>
        </section>
    );
}

GroupsForm.propTypes = {
    groups_checkbox: PropTypes.bool,
    groups: PropTypes.arrayOf(PropTypes.shape({})),
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
}

GroupsForm.defaultProps = {
    groups_checkbox: false,
    groups: [],
    intl: {
        formatMessage: () => {},
    },
}
