import React from 'react';
import PropTypes from 'prop-types';
import { change, Field } from 'redux-form';
import { NAME_OF_FORMS } from 'common';
import { COMMON_LABELS } from 'common/ui-labels';

export function ActivityForm({ dispatch, status_option, intl }) {
    return (
        <section>
            <div className="Form-Line row" style={{ textAlign: 'center', marginTop: '15px' }}>
                <div className="Form-Label col-md-6" style={{ fontSize: '1.2em' }}>{COMMON_LABELS.STATUS}</div>
                <div className="col-md-6 text-left" data-id="zone-add-configuration-active">
                    <Field
                        name="status_option"
                        component="input"
                        type="checkbox"
                        onChange={ () => {
                            if (status_option) {
                                dispatch(change(NAME_OF_FORMS.ZONE_BULK_EDIT_ADMIN_PAGE, 'activity_schedule_option', false));
                            } else {
                                dispatch(change(NAME_OF_FORMS.ZONE_BULK_EDIT_ADMIN_PAGE, 'status', 'active'));
                                dispatch(change(NAME_OF_FORMS.ZONE_BULK_EDIT_ADMIN_PAGE, 'active24', true));
                            }
                        }}
                    />
                </div>
            </div>
            <div className="Form-Line row" style={{ textAlign: 'center', marginTop: '15px', display: status_option ? 'block' : 'none' }}>
                <div className="Form-Label col-md-6" style={{ fontSize: '1.2em' }} />
                <div className="col-md-6 text-left" data-id="zone-add-configuration-active">
                    <Field
                        className="form-control input-sm"
                        name="status"
                        style={{ fontSize: '14px' }}
                        onChange={(e) => {
                            if (e.target.value === 'inactive') {
                                dispatch(change(NAME_OF_FORMS.ZONE_BULK_EDIT_ADMIN_PAGE, 'activity_schedule_option', false));
                            }
                        }}
                        component="select"
                    >
                        <option value="active">{COMMON_LABELS.ACTIVE_FUNC(intl)}</option>
                        <option value="inactive">{COMMON_LABELS.INACTIVE_FUNC(intl)}</option>
                    </Field>
                </div>
            </div>
        </section>
    )
}

ActivityForm.propTypes = {
    dispatch: PropTypes.func,
    status_option: PropTypes.bool,
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
}

ActivityForm.defaultProps = {
    dispatch: () => {},
    status_option: false,
    intl: {
        formatMessage: PropTypes.func,
    },
}
