import React from 'react';
import PropTypes from 'prop-types';
import VertexOption from './VertexOption';


export default function VerticesList(props) {
    const list = new Array(props.verticesLimit).fill();
    return list.map((element, index) => (
        <VertexOption
            key={index}
            index={index + 1}
            addVertex={props.addVertex}
            removeVertex={props.removeVertex}
            sublocation={props.sublocation}
        />
    ));
}

VerticesList.propTypes = {
    verticesLimit: PropTypes.number,
    addVertex: PropTypes.func,
    removeVertex: PropTypes.func,
    sublocation: PropTypes.shape({}),
};

VerticesList.defaultProps = {
    verticesLimit: 0,
    addVertex: () => {},
    removeVertex: () => {},
    sublocation: {},
};
