import React from 'react';
import PropTypes from 'prop-types';
import { Field } from 'redux-form';

import RenderSelectSeverityField from 'components/modals/RenderSelectSeverityField';
import { COMPONENTS } from 'common/ui-labels';
import { alarmLevelStyle } from 'utils/formatters';


function ActivityOptions(props) {
    const { isKeepInOutZone, activityHandler = () => {} } = props;
    return (
        <div className="Form-Line">
            {isKeepInOutZone && <div className="row">
                <div
                    className="col-md-5 Form-Label-Average"
                    style={{ marginBottom: '5px' }}
                >
                    {COMPONENTS.FIELDS.ZONE.SEVERITY}*:
                </div>
                <div className="col-md-7 Form-Value">
                    <Field
                        className="form-control input-sm "
                        name="zone_alarm_level"
                        dataCy="zone_alarm_level"
                        style={{ fontSize: '14px' }}
                        component={RenderSelectSeverityField}
                    >
                        <option disabled />
                        <option value={1} style={alarmLevelStyle(1)}>1</option>
                        <option value={2} style={alarmLevelStyle(2)}>2</option>
                        <option value={3} style={alarmLevelStyle(3)}>3</option>
                        <option value={4} style={alarmLevelStyle(4)}>4</option>
                    </Field>
                </div>
            </div>}
            <div className="Form-Line">
                <div className="row">
                    <div className="Form-Label-Small col-md-5" style={{ fontSize: '1.1em' }}>
                        {COMPONENTS.FIELDS.COMMON.ACTIVE}
                    </div>
                    <div className="col-md-7 text-left" data-cy="activated-div">
                        <Field
                            name="activated"
                            component="input"
                            type="checkbox"
                            onChange={activityHandler}
                        />
                    </div>
                </div>
            </div>
            <div className="row">
                <div className="col-md-5" />
                <div className="col-md-7">
                    <Field
                        name="geometry"
                        component={() => (<div />)}
                    />
                </div>
            </div>
        </div>
    );
}

ActivityOptions.propTypes = {
    isKeepInOutZone: PropTypes.bool,
    activityHandler: PropTypes.func,
};

ActivityOptions.defaultProps = {
    isKeepInOutZone: true,
    activityHandler: () => {},
};

export default ActivityOptions;

