import React from 'react';
import PropTypes from 'prop-types';
import { Field } from 'redux-form';
import RenderField from 'components/modals/RenderField';

const renderField = RenderField(5, 7, 'Form-Label-Average');


function RotationControl(props) {
    const { geometry, label } = props;
    return (
        <div className="Form-Line">
            <div className="row" style={{ marginBottom: '5px' }}>
                <Field
                    className="Form-Input"
                    name="rotation"
                    dataCy="rotation"
                    disabled={geometry.zoneGeometryInDegrees.length === 0}
                    component={renderField}
                    label={label}
                    type="number"
                />
            </div>
        </div>
    );
}

RotationControl.propTypes = {
    geometry: PropTypes.shape(),
    label: PropTypes.string,
};

RotationControl.defaultProps = {
    geometry: {},
    label: '',
};

export default RotationControl;
