import React from 'react';
import PropTypes from 'prop-types';

import { COMPONENTS } from 'common';

function TableTitle(props) {
    return (
        <section className="Virtual-Table-Title-Big" style={{ width: props.width }}>
            <h3 className="text-center AdminTab-Title">{COMPONENTS.FIELDS.NODE.TAG_MANAGEMENT}</h3>
            <h4
                className="text-center AdminTab-Subtitle"
                data-id="tags-total-count"
            >
                {COMPONENTS.FIELDS.COMMON.TOTAL_COUNT_FUNC(props.totalCount)}
            </h4>
            <hr />
        </section>
    );
}

TableTitle.propTypes = {
    totalCount: PropTypes.number,
    width: PropTypes.number,
};

TableTitle.defaultProps = {
    totalCount: 0,
    width: 0,
};

export default TableTitle;
