import React from 'react';
import PropTypes from 'prop-types';


const TotalCountLabelValue = (props) => {
    const { isColumnDirection, label, value, dividerClass, dataCy } = props;

    return (
        <div className={`total-count-label-value ${isColumnDirection ? 'd-column' : 'd-row'}`}>
            <div className={`total-count-label ${dividerClass}`}>
                <span className="capitalizedText">{label}</span>
            </div>
            <div
                className="total-count-value"
                data-cy={dataCy}
            >
                {value}
            </div>
        </div>
    );
};

TotalCountLabelValue.propTypes = {
    dividerClass: PropTypes.string,
    label: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.object
    ]),
    value: PropTypes.oneOfType([
        PropTypes.string,
        PropTypes.number,
    ]),
    dataCy: PropTypes.string,
    isColumnDirection: PropTypes.bool,
};

TotalCountLabelValue.defaultProps = {
    dividerClass: '',
    label: '',
    value: '',
    dataCy: '',
    isColumnDirection: true,
};

export default TotalCountLabelValue;
