import React, { lazy } from 'react';
import { ROUTES } from 'common/constants';
import addons from '../../js/addons';

const DashboardPageContent = lazy(() => import('../pages/dashboard/DashboardPageContent'));
const ReportsPageContent = lazy(() => import('../pages/reports/ReportsPageContent'));
const AdminPageContent = lazy(() => import('../pages/admin/AdminPageContent'));
const SitePageContent = lazy(() => import('../pages/site/SitePageContent'));
const SystemPageContent = lazy(() => import('../pages/system/SystemPageContent'));
const LoggerPageContent = lazy(() => import('./logger/LoggerPageContent'));

const pages = {
    [ROUTES.DASHBOARD_ROUTE]: () => <DashboardPageContent />,
    [ROUTES.REPORTS_ROUTE]: () => <ReportsPageContent />,
    [ROUTES.ADMIN_ROUTE]: () => <AdminPageContent />,
    [ROUTES.SITE_ROUTE]: () => <SitePageContent />,
    [ROUTES.SYSTEM_ROUTE]: () => <SystemPageContent />,
    [ROUTES.LOGGER_ROUTE]: () => <LoggerPageContent />,
};

export default { ...pages, ...addons.routes };
