import { connect } from 'react-redux';
import withReport from 'components/HOC/withReport';
import { getTimeZoneOfProject } from 'utils/timeUtils';
import Attendance from './Attendance';


const AttendanceReport = withReport(Attendance);

const mapStateToProps = state => (
    {
        error: state.reports.attendanceReport.error,
        status: state.reports.attendanceReport.status,
        reportListLoading: state.reports.attendanceReport.reportListLoading,
        reports: state.reports.attendanceReport.reports || [],
        report_uid: state.reports.attendanceReport.uid,
        options: state.reports.attendanceReport.filter,
        timezone: getTimeZoneOfProject(state.appContext.project),
    }
);

export default connect(mapStateToProps)(AttendanceReport);
