import { connect } from 'react-redux';
import withReport from 'components/HOC/withReport';
import { getTimeZoneOfProject } from 'utils/timeUtils';
import Distance from './Distance';


const DistanceReport = withReport(Distance);

const mapStateToProps = state => (
    {
        error: state.reports.trackableDistanceReport.error,
        status: state.reports.trackableDistanceReport.status,
        reportListLoading: state.reports.trackableDistanceReport.reportListLoading,
        reports: state.reports.trackableDistanceReport.reports || [],
        report_uid: state.reports.trackableDistanceReport.uid,
        options: state.reports.trackableDistanceReport.filter,
        timezone: getTimeZoneOfProject(state.appContext.project),
    }
);

export default connect(mapStateToProps)(DistanceReport);
