import { connect } from 'react-redux';
import withReport from 'components/HOC/withReport';
import { getTimeZoneOfProject } from 'utils/timeUtils';
import Pws from './Pws';


const PwsReport = withReport(Pws);

const mapStateToProps = state => (
    {
        error: state.reports.pwsReport.error,
        status: state.reports.pwsReport.status,
        options: state.reports.pwsReport.filter,
        timezone: getTimeZoneOfProject(state.appContext.project),
    }
);

export default connect(mapStateToProps)(PwsReport);
