import React, { Fragment } from 'react';
import { Router, Route } from 'react-router-dom';
import { history } from 'stores/configureStore';
import { REPORT_PATH } from 'common';
import PwsReport from './PWS';
import AttendanceReport from './Attendance';
import AlarmsReport from './Alarms';
// import DistanceReport from './Distance';
import ZoneActivityReport from './ZoneActivity';


function ReportsPageContent() {
    return (
        <div className="AppLayout-Reports">
            <Router history={history}>
                <Fragment>
                    {/*<Route path={REPORT_PATH.TRAVEL_DISTANCE} component={DistanceReport} />*/}
                    <Route path={REPORT_PATH.ZONE_ACTIVITY} component={ZoneActivityReport} />
                    <Route path={REPORT_PATH.PWS} component={PwsReport} />
                    <Route path={REPORT_PATH.ATTENDANCE} component={AttendanceReport} />
                    <Route path={REPORT_PATH.ALARMS} component={AlarmsReport} />
                </Fragment>
            </Router>
        </div>
    );
}

export default ReportsPageContent;
