import { connect } from 'react-redux';
import withReport from 'components/HOC/withReport';
import { getTimeZoneOfProject } from 'utils/timeUtils';
import ZoneActivity from './ZoneActivity';


const ZoneActivityReport = withReport(ZoneActivity);

const mapStateToProps = state => (
    {
        error: state.reports.zoneActivityReport.error,
        status: state.reports.zoneActivityReport.status,
        reportListLoading: state.reports.zoneActivityReport.reportListLoading,
        reports: state.reports.zoneActivityReport.reports || [],
        report_uid: state.reports.zoneActivityReport.uid,
        options: state.reports.zoneActivityReport.filter,
        timezone: getTimeZoneOfProject(state.appContext.project),
    }
);

export default connect(mapStateToProps)(ZoneActivityReport);
