import { EDIT_ZONE_MODE } from 'common/ui-labels';
import PropTypes from 'prop-types';
import React from 'react';


export default function RotationControl(props) {
    const { rotation, show } = props;

    if (!show) {
        return '';
    }

    return (
        <div className="Rotation-Control row-wrapper">
            <div className="row-label">
                {EDIT_ZONE_MODE.ROTATE}
            </div>
            <div>
                <span className="degree-symbol">°</span>
                <input
                    type="number"
                    value={rotation}
                    min={0}
                    max={360}
                    onChange={(event) => {
                        props.handleZoneRotate(Number(event.target.value));
                    }}
                />
            </div>
        </div>
    );
}

RotationControl.propTypes = {
    rotation: PropTypes.number,
    show: PropTypes.bool,
    handleZoneRotate: PropTypes.func,
};

RotationControl.defaultProps = {
    rotation: 0,
    show: false,
    handleZoneRotate: () => {},
};
