import { EDIT_ZONE_MODE } from 'common/ui-labels';
import PropTypes from 'prop-types';
import React from 'react';


export default function WidthControl(props) {
    const { show, width } = props;

    if (!show) {
        return '';
    }

    return (
        <div className="row-wrapper">
            <div className="row-label">
                {EDIT_ZONE_MODE.WIDTH}
            </div>
            <div>
                <input
                    type="number"
                    value={width}
                    min={0}
                    onChange={(event) => {
                        props.handleZoneWithChange(Number(event.target.value));
                    }}
                />
            </div>
        </div>
    );
}

WidthControl.propTypes = {
    width: PropTypes.number,
    show: PropTypes.bool,
    handleZoneWithChange: PropTypes.func,
};

WidthControl.defaultProps = {
    width: 0,
    show: false,
    handleZoneWithChange: () => {},
};
