import React from 'react';
import PropTypes from 'prop-types';
import SiteViewControl from 'pages/site/SiteViewControl';
import ModeName from './ModeName';
import ReturnModeButton from './ReturnModeButton';

export default function SiteViewHeader(props) {
    const { mode, sublocation_name, intl, isAnalyticsDisabled } = props;
    return (
        <div className="RPP-Site-View-Header">
            <SiteViewControl isAnalyticsDisabled={isAnalyticsDisabled} />
            <ModeName mode={mode} sublocation_name={sublocation_name} />
            <ReturnModeButton mode={mode} intl={intl} />
        </div>
    );
}

SiteViewHeader.propTypes = {
    mode: PropTypes.shape({}),
    sublocation_name: PropTypes.string,
    isAnalyticsDisabled: PropTypes.bool,
    intl: PropTypes.shape({
        formatMessage: PropTypes.func,
    }),
};

SiteViewHeader.defaultProps = {
    mode: {},
    sublocation_name: '',
    isAnalyticsDisabled: false,
    intl: {
        formatMessage: () => {
        },
    },
};
