import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { connect } from 'react-redux';
import { push } from 'connected-react-router';
import { Router, Route } from 'react-router-dom';
import { SYSTEM_TABS_ROUTES, ROUTES } from 'common';
import { history } from 'stores/configureStore';

import SHMServer from './SHMServer';
import SHMWinAnchorsTable from './tables/SHMWinAnchorsTable';


class SystemPageContent extends Component {
    static propTypes = {
        dispatch: PropTypes.func,
        currentPath: PropTypes.string,
    };

    static defaultProps = {
        dispatch: () => {
        },
        currentPath: '',
    };

    componentDidMount() {
        const { currentPath } = this.props;
        this.redirectFromRootToServer(currentPath);
    }

    getSnapshotBeforeUpdate(prevProps, prevState) {
        const { currentPath } = this.props;
        this.redirectFromRootToServer(currentPath);
        return null;
    }

    componentDidUpdate() { }

    redirectFromRootToServer = (path) => {
        if (path === ROUTES.SYSTEM_ROUTE) {
            this.props.dispatch(push(SYSTEM_TABS_ROUTES.SERVER));
        }
    };

    render() {
        return (
            <div className="AppLayout-Admin-Tab">
                <Router history={history}>
                    <Route exact path={SYSTEM_TABS_ROUTES.SERVER} component={SHMServer} />
                    <Route path={SYSTEM_TABS_ROUTES.ANCHORS} component={SHMWinAnchorsTable} />
                </Router>
            </div>
        );
    }
}

const mapStateToProps = state => ({
    currentPath: state.router.location.pathname,
});

export default connect(mapStateToProps)(SystemPageContent);
