import React from 'react';
import PropTypes from 'prop-types';

import { SYSTEM_PAGE, COMPONENTS } from 'common';

function TableTitle(props) {
    return (
        <section className="Virtual-Table-Title-Big" style={{ width: props.width }}>
            <h3 className="text-center AdminTab-Title">{SYSTEM_PAGE.ANCHORS}</h3>
            <h4 className="text-center AdminTab-Subtitle">
                {COMPONENTS.FIELDS.COMMON.COUNT}: {props.totalCount}
            </h4>
            <hr />
        </section>
    );
}

TableTitle.propTypes = {
    totalCount: PropTypes.number,
    width: PropTypes.number,
};

TableTitle.defaultProps = {
    totalCount: 0,
    width: 0,
};

export default TableTitle;
