import { MODAL_ACTIONS } from 'common/constants';

// StatusNotificationPopup
/**
 * open self-closed modal with customised text
 * @param params
 * @returns {{type: null, params: *}}
 */
export const openStatusNotificationPopup = params => ({
    type: MODAL_ACTIONS.MODAL_OPEN_STATUS_NOTIFICATION_POPUP,
    params,
});

/**
 * close self-closed modal
 * @returns {{type: null}}
 */
export const closeStatusNotificationPopup = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_STATUS_NOTIFICATION_POPUP,
});

export const openAuditDownloadModal = () => ({
    type: MODAL_ACTIONS.MODAL_OPEN_AUDIT_DOWNLOAD,
});

export const closeAuditDownloadModal = () => ({
    type: MODAL_ACTIONS.MODAL_CLOSE_AUDIT_DOWNLOAD,
});

export const openErrorModal = params => (dispatch) => {
    dispatch({
        type: MODAL_ACTIONS.MODAL_OPEN_GENERAL_ERROR,
        params,
    });
};

export const closeErrorModal = () => (dispatch) => {
    dispatch({
        type: MODAL_ACTIONS.MODAL_CLOSE_GENERAL_ERROR,
    });
};

export const openCommonMessageModal = params => (dispatch) => {
    dispatch({
        type: MODAL_ACTIONS.MODAL_OPEN_COMMON_MESSAGE,
        params,
    });
};

export const closeCommonMessageModal = () => (dispatch) => {
    dispatch({
        type: MODAL_ACTIONS.MODAL_CLOSE_COMMON_MESSAGE,
    });
};
