export default class Company {
    constructor(company) {
        this.uid = company.uid;
        this.name = company.name || '';
        this.projects = company.projects || [];
        this.user_params = company.user_params || {};
        this.users = company.users || [];
    }
    
    getProperties() {
        return { ...this };
    }
    
    getFormattedCompany() {
        const formattedCompany = { ...this };
        
        formattedCompany.color = this.user_params.color;
        formattedCompany.phone = this.user_params.phone;
        formattedCompany.website = this.user_params.website;
        formattedCompany.address = this.user_params.address;
        formattedCompany.tag_allocation = this.user_params.tag_allocation;
        
        return formattedCompany;
    }
}
