import LeafletPoint from './LeafletPoint';

export default class LeafletLine {
    constructor(p1, p2) {
        // line points
        this.p1 = new LeafletPoint(p1.lng, p1.lat);
        this.p2 = new LeafletPoint(p2.lng, p2.lat);
    }

    getProperties() {
        return { ...this };
    }

    deltaBetweenLineLengthAndPointSegments(p0) {
        const { p1, p2 } = this;

        const p1p0_p2p0 = LeafletLine.lineDistance(p1, p0) + LeafletLine.lineDistance(p2, p0);
        const p1p2 = LeafletLine.lineDistance(p1, p2); // line length

        return Math.abs(p1p2 - p1p0_p2p0);
    }

    static lineDistance(p1, p2) {
        return Math.hypot(p2.lng - p1.lng, p2.lat - p1.lat);
    }
}
