import Shift from 'stores/classes/Shift';


export default class Location {
    constructor(location) {
        this.city = location.city;
        this.country = location.country;
        this.company_uid = location.company_uid;
        this.created_at = location.created_at;
        this.description = location.description;
        this.elevation = location.elevation;
        this.latitude = location.latitude;
        this.longitude = location.longitude;
        this.name = location.name;
        this.orientation = location.orientation;
        this.project_uid = location.project_uid;
        this.shift = location.shift ? location.shift.map(shift => new Shift(shift).formattedForClient(location)) : [];
        this.state = location.state;
        this.street_address = location.street_address;
        this.street_address2 = location.street_address2;
        this.uid = location.uid;
        this.updated_at = location.updated_at;
        this.user_params = location.user_params || {};
        this.zip = location.zip;
        this.zip4 = location.zip4;
    }
    
    getProperties() {
        return { ...this };
    }
    
    isLocationUidEqualTo(uid) {
        if ((typeof this.uid === 'string') && (typeof uid === 'string')) {
            return this.uid === uid;
        }
        return undefined;
    }
    
    static getAllLocations(state) {
        return state.entities.locations;
    }
}
