import { separatePhoneNumber } from 'utils/simpleUtils';


export default class Subscriber {
    constructor(subscriber) {
        this.addresses = subscriber.addresses;
        this.created_at = subscriber.created_at;
        this.id = subscriber.id;
        this.name = subscriber.name;
        this.notifications = subscriber.notifications;
        this.project_uid = subscriber.project_uid;
        this.removed_at = subscriber.removed_at;
        this.uid = subscriber.uid;
        this.updated_at = subscriber.updated_at;
    }
    
    getProperties() {
        return { ...this };
    }
    
    formattedSubscriber(notifications) {
        const props = this.getProperties();
        props.phone = this.addresses.phone;
        if (props.phone) {
            const { phoneCode, phoneNumber } = separatePhoneNumber(props.phone);
            props.phoneCode = phoneCode;
            props.phoneNumber = phoneNumber;
        }
        props.email = this.addresses.email;
        props.notificationsList = this.notifications.map((uid) => {
            const notification = notifications.find(x => x.uid === uid);
            if (notification) {
                return notification.name;
            }
            return undefined;
        }).filter(x => x).join(', ');
        return props;
    }
    
    static getAllSubscribers(state) {
        return state.entities.subscribers;
    }
}
