import { NOTIFY_ACTIONS } from 'worker';
import { ACTIONS } from 'common/constants';
import { getNotifyParams } from 'utils/storeUtils';

const initialState = {
    hostName: '',
    project: null,
    company: null,
};

const appContext = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.RELOAD_CONTEXT:
            return {
                ...state,
                project: action.params.project || initialState.project,
            };
        case ACTIONS.HELPER_LINK_SET:
            return {
                ...state,
                helperLink: action.params,
            };
        case ACTIONS.SITE_MONITOR_LINK_SET:
            return {
                ...state,
                monitorLink: action.params,
            };
        case ACTIONS.APP_CONTEXT_SET:
            return {
                ...state,
                ...action.params,
            };
        case NOTIFY_ACTIONS.PROJECT_UPDATED:
        case ACTIONS.PROJECTS_UPDATE: {
            const params = getNotifyParams(action);
            const newState = { ...state };
            params.forEach((param) => {
                if (newState.project && newState.project.uid === param.uid) {
                    newState.project = { ...param, ...param.user_params };
                }
            });
            return newState;
        }
        case ACTIONS.APP_CONTEXT_CLEAR:
            return {
                ...initialState,
            };
        default:
            return state;
    }
};

export default appContext;
