import { ACTIONS } from 'common/constants';

const initialState = {
    status: null,
    message: '',
    selectedItems: [],
};

const messages = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.MESSAGE_ERROR:
            return {
                ...state,
                status: action.params.status,
            };
        case ACTIONS.MESSAGE_SENT:
            return {
                ...state,
                status: action.params.status,
                message: '',
            };
        case ACTIONS.MESSAGE_SAVE:
            return {
                ...state,
                message: action.params.message,
            };
        case ACTIONS.MESSAGE_SELECT_ITEMS:
            return {
                ...state,
                selectedItems: action.params.selectedItems,
            };
        case ACTIONS.MESSAGE_CLEAR:
            return {
                ...state,
                message: '',
            };
        default:
            return state;
    }
};

export default messages;
