import { ACTIONS } from 'common/constants';

/**
 * @type {Array<TrackableTemplates>}
 */
const initialState = [];

const trackableTemplates = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.TRACKABLE_TEMPLATES_SET: {
            return [...action.params];
        }
        default:
            return state;
    }
};

export default trackableTemplates;

/**
 * @typedef TrackableTemplateVariable
 * @property {String} htmlType - [input|select|..]
 * @property {String} label - value that shows on UI, must not be localized
 * @property {String} name - key name in trackable.user_params in trackable object
 * @property {String} required - on true throw UI error on create/edit modal
 * @property {String} type - input type [text|checkbox|..]
 * @property {Number} minLength
 * @property {Number} maxLength
 */

/**
 * @typedef TrackableTemplates
 * @property {String} category - trackable category [VEHICLE|UNSPECIFIED|PERSON|ASSET],
 * @property {String} created_at - ISO 8601 time ['2023-11-07 12:00:00'],
 * @property {String} updated_at - ISO 8601 time ['2023-11-07 12:00:00'],
 * @property {String} removed_at - ISO 8601 time ['2023-11-07 12:00:00'],
 * @property {Array<TrackableTemplateVariable>} variables - array of template variables
 */
