import { ACTIONS } from 'common/constants';

const initialState = [];

const usersAccessControl = (state = initialState, action) => {
    switch (action.type) {
        case ACTIONS.USERS_ACCESS_CONTROL_SET: {
            return [ ...action.params ];
        }
        case ACTIONS.USERS_ACCESS_CONTROL_CLEAR:
            return [ ...initialState ];
        case ACTIONS.USERS_ACCESS_CONTROL_UPDATE: {
            const userAccessControl = action.params;
            return state.map(uac => {
                if (userAccessControl.role === uac.role) {
                    return userAccessControl;
                }
                return uac;
            });
        }
        default:
            return state;
    }
};

export default usersAccessControl;
