import { combineReducers } from 'redux';
import { reducer as formReducer } from 'redux-form';
import { ACTIONS } from 'common/constants';
import { connectRouter } from 'connected-react-router';

import user from './user';
import modals from './modals';
import appContext from './appContext';
import entities from './entities';
import reports from './reports';
import adminPage from './adminPage';
import loggerPage from './loggerPage';
import siteView from './siteView';
import siteViewZoneEditCoordinates from './siteViewZoneEditCoordinates';
import rightSideBar from './rightSideBar';
import siteViewFilter from './siteViewFilter';
import worker from './worker';
import playback from './playback';
import spaghetti from './spaghetti';
import nearMissReport from './nearMissEvents';
import heatmap from './heatmap';
import dashboard from './dashboard';
import SHM from './SHM';


const reducers = (history, addonsReducers) => {
    const appReducer = combineReducers({
        form: formReducer,
        router: connectRouter(history),
        
        user,
        modals,
        appContext,
        entities,
        adminPage,
        loggerPage,
        siteView,
        rightSideBar,
        siteViewFilter,
        siteViewZoneEditCoordinates,
        
        worker,
        heatmap,
        playback,
        spaghetti,
        nearMissReport,
        dashboard,
        reports,
        SHM,
        
        ...addonsReducers,
    });
    
    return (state, action) => {
        if (action.type === ACTIONS.CLEAR_STORE) {
            state = undefined;
        }
        return appReducer(state, action);
    };
};

export default reducers;
