import { ACTIONS, MODAL_ACTIONS } from 'common/constants';
import { WS_ACTIONS } from 'worker/common/constants';


const initialState = {
    open: false,
    message: '',
    title: '',
    onCloseRedirect: false,
};

const generalError = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_GENERAL_ERROR:
            return {
                ...state,
                open: true,
                message: action.params.message,
                title: action.params.title,
                onCloseRedirect: action.params.onCloseRedirect,
            };
        case WS_ACTIONS.PLAYBACK_ERROR: {
            return {
                ...state,
                open: true,
                message: action.params.message,
                title: action.params.title,
                onCloseRedirect: false,
            };
        }
        case ACTIONS.SET_ATTENDANCE_REPORT_ERROR: {
            return {
                ...state,
                open: true,
                message: action.params.message,
                title: action.params.title,
                onCloseRedirect: false,
            };
        }
        case MODAL_ACTIONS.MODAL_CLOSE_GENERAL_ERROR:
            return {
                ...initialState,
            };
        default:
            return state;
    }
};

export default generalError;
