import { MODAL_ACTIONS } from '../../../../common/constants';

const initialState = {
    isCustomInterval: false,
    sentTrackablesRequest: false,
    isRecent: false,
};

const siteAnalyticsModal = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.SITE_ANALYTICS_MODAL_UPDATE_STATE: {
            const { isModalOpened } = action.params;
            return {
                ...state,
                isModalOpened,
                ...action.params,
            };
        }
        case MODAL_ACTIONS.SITE_ANALYTICS_TRACKABLES_LOADING: {
            return {
                ...state,
                sentTrackablesRequest: true,
            };
        }
        case MODAL_ACTIONS.AVAILABLE_TRACKABLES: {
            return {
                ...state,
                ...action.params,
                selectedTrackables: action.params.trackables,
                sentTrackablesRequest: false,
            };
        }
        case MODAL_ACTIONS.SITE_ANALYTICS_MODAL_CHANGE_SELECTED_TRACKABLES: {
            return {
                ...state,
                selectedTrackables: action.selectedTrackables,
            };
        }
        case MODAL_ACTIONS.SITE_ANALYTICS_MODAL_CLOSE: {
            return {
                ...initialState,
            };
        }
        default:
            return state;
    }
};

export default siteAnalyticsModal;
