import { MODAL_ACTIONS } from 'common/constants';

const initialState = {
    editedTrackables: [],
    open: false,
    submitted: false,
    checkboxes: {},
};

const trackableBulkEdit = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_BULK_TRACKABLE_EDIT:
            return {
                ...state,
                open: true,
                editedTrackables: [...action.params],
            };
        case MODAL_ACTIONS.MODAL_BULK_TRACKABLE_EDIT_SUBMITTED:
            return {
                ...state,
                submitted: action.params,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_BULK_TRACKABLE_EDIT:
            return {
                ...initialState,
                open: false,
            };
        default:
            return state;
    }
};

export default trackableBulkEdit;
