import { MODAL_ACTIONS, TRACKABLE_TYPE, DEFAULT_VALUES, TRACKABLE_CATEGORY } from 'common/constants';

const initialState = {
    name: '',
    default_height: DEFAULT_VALUES.trackable_default_height,
    pos_report_frequency: DEFAULT_VALUES.trackable_pos_report_frequency,
    type: TRACKABLE_TYPE.MOBILE,
    category: TRACKABLE_CATEGORY.PERSON,
    attached_zone: false,
    radius: DEFAULT_VALUES.trackable_buffer_radius,
    edit: false,
    editingTrackObject: {},
    showOptions: false,
    showMap: false,
    open: false,
};

const trackableEdit = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_TRACKABLE_EDIT:
            return {
                ...state,
                open: true,
                checkboxes: undefined,
                params: action.params,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_TRACKABLE_EDIT:
            return {
                ...initialState,
                checkboxes: undefined,
                open: false,
            };
        case MODAL_ACTIONS.TRACKABLE_CHECKBOX_CLICK:
            return {
                ...state,
                checkboxes: action.params,
            };
        case MODAL_ACTIONS.TRACKABLE_STATIONARY_TAG_SHOW_MAP:
            return {
                ...state,
                showMap: !state.showMap,
            };
        case MODAL_ACTIONS.MODAL_EDIT_TRACKABLE_SAVE_STATIONARY_POSITION: {
            const stationaryPosition = Object.assign(
                {},
                state.stationaryPosition,
                action.params.stationaryPosition,
            );
            return {
                ...state,
                stationaryPosition,
            };
        }
        default:
            return state;
    }
};

export default trackableEdit;
