import { MODAL_ACTIONS } from '../../../../common/constants';

const initialState = {
    isOpen: false,
    polygon_create: false,
    direction_create: false,
};

const zoneChooseGeometry = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_ZONE_CHOOSE_GEOMETRY:
            if (action.params && action.params.zone_type_name) {
                return {
                    ...state,
                    isOpen: true,
                    zone_type_name: action.params.zone_type_name,
                };
            }
            return {
                ...state,
                isOpen: true,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_ZONE_CHOOSE_GEOMETRY:
            return {
                ...state,
                ...initialState,
            };
        case MODAL_ACTIONS.MODAL_ZONE_POLYGON_START_CREATE:
            return {
                ...state,
                polygon_create: true,
            };
        case MODAL_ACTIONS.MODAL_ZONE_DIRECTION_START_CREATE:
            return {
                ...state,
                direction_create: true,
            };
        case MODAL_ACTIONS.MODAL_ZONE_DIRECTION_STOP_CREATE:
            return {
                ...state,
                direction_create: false,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_ZONE_CREATE_ADMIN_PAGE:
        case MODAL_ACTIONS.MODAL_ZONE_POLYGON_STOP_CREATE:
            return {
                ...state,
                polygon_create: false,
            };
        case MODAL_ACTIONS.MODAL_CLEAR_ZONE_CHOOSE_GEOMETRY:
            return {
                ...initialState,
            };
        default:
            return state;
    }
};

export default zoneChooseGeometry;
