import { MODAL_ACTIONS } from '../../../../common/constants';

const initialState = {
    open: false,
    floorplan: null,
    params: {
        uid: '',
        apply_to: null,
        location_uid: '',
        zone_type_name: '',
        sublocation_uid: '',
        zone_exceptions: [],
        zone_type_id: 0,
        zone_exceptions_groups: [],
        user_params: {},
    },
};

const zoneEditAdminPage = (state = initialState, action) => {
    switch (action.type) {
        case MODAL_ACTIONS.MODAL_OPEN_ZONE_EDIT_ADMIN_PAGE:
            return {
                ...state,
                open: true,
                params: action.params,
            };
        case MODAL_ACTIONS.MODAL_SELECT_FLOORPLAN_ZONE_EDIT_ADMIN_PAGE:
            return {
                ...state,
                floorplan: action.params,
            };
        case MODAL_ACTIONS.MODAL_UNSELECT_FLOORPLAN_ZONE_EDIT_ADMIN_PAGE:
            return {
                ...state,
                floorplan: null,
            };
        case MODAL_ACTIONS.MODAL_CLOSE_ZONE_EDIT_ADMIN_PAGE:
            return {
                ...initialState,
            };
        default:
            return state;
    }
};

export default zoneEditAdminPage;
