import { WS_ACTIONS } from 'worker';

const initialState = {
    worker: null,
    isWebSocketOn: false,
    
    isRealTimeOn: false,
};

const worker = (state = initialState, action) => {
    switch (action.type) {
        case WS_ACTIONS.WORKER_RUN:
            return {
                ...state,
                ...action.params, // (worker)
            };
        case WS_ACTIONS.WORKER_STOP:
            return {
                ...initialState,
            };
        case WS_ACTIONS.WORKER_WEB_SOCKET_TURN_ON:
            return {
                ...state,
                isWebSocketOn: true,
                isRealTimeOn: true, // by default turns it on with turning on webSocket
            };
        case WS_ACTIONS.WORKER_WEB_SOCKET_TURN_OFF:
            return {
                ...state,
                isWebSocketOn: false,
                isRealTimeOn: false,
            };
        case WS_ACTIONS.CHANGE_WORKER_PARAMS:
            return {
                ...state,
                ...action.params,
            };
        default:
            return state;
    }
};

export default worker;
