import { fork, takeEvery, call, put } from 'redux-saga/effects';

import { SAGA_ACTIONS } from 'common/constants';
import { closeGroupDetachModal } from 'stores/actions/modalActions/groupModalActions';
import { updateTrackableGroup } from 'stores/sagas/group/groupDeleteSaga';
import errorHandler from 'stores/sagas/commonSaga';


export function* detachGroup(action) {
    try {
        if (action.params.modalProps.row.uid) {
            yield call(updateTrackableGroup, action.params.modalProps.row, action.params.selectedGroup);
        } else {
            for (let i = 0; i < action.params.modalProps.row.length; i += 1) {
                yield call(updateTrackableGroup, action.params.modalProps.row[i], action.params.selectedGroup);
            }
        }
        yield put(closeGroupDetachModal());
    } catch (err) {
        yield call(errorHandler, err);
    }
}

function* watchDetachGroup() {
    yield takeEvery(SAGA_ACTIONS.SAGA_GROUPS_DETACH, detachGroup);
}

export default function* groupDetachSaga() {
    return yield fork(watchDetachGroup);
}
