import isEqual from 'lodash/isEqual';

function download(filename, text) {
    const element = document.createElement('a');
    element.setAttribute('href', `data:text/plain;charset=utf-8,${encodeURIComponent(text)}`);
    element.setAttribute('download', filename);
    
    element.style.display = 'none';
    document.body.appendChild(element);
    
    element.click();
    
    document.body.removeChild(element);
}

function parse(value) {
    try {
        return JSON.parse(value);
    } catch (e) {
        return value;
    }
}

let array = [];

export default async function handleKeyDown(event) {
    if (event.shiftKey && event.code === 'KeyD') {
        array = [event.code];
    }
    
    if ((event.shiftKey && event.code === 'KeyE')
        || (event.shiftKey && event.code === 'KeyB')
        || (event.shiftKey && event.code === 'KeyU')
        || (event.shiftKey && event.code === 'KeyG')
    ) {
        array.push(event.code);
    }
    if (isEqual(array, ['KeyD', 'KeyE', 'KeyB', 'KeyU', 'KeyG'])) {
        array = [];
        const r = {
            localStorage: {},
            sessionStorage: {},
        };
        const localStorageKeys = Object.getOwnPropertyNames(localStorage);
        const sessionStorageKeys = Object.getOwnPropertyNames(sessionStorage);
        localStorageKeys.forEach((key) => {
            r.localStorage[key] = parse(localStorage.getItem(key));
        });
        sessionStorageKeys.forEach((key) => {
            r.sessionStorage[key] = parse(sessionStorage.getItem(key));
        });
        // const messageProcessorMaps = await api.getMessageProcessorState();
        // if (_Has(messageProcessorMaps, 'data.messageProcessorMaps')) {
        //     r.messageProcessorMaps = messageProcessorMaps.data.messageProcessorMaps;
        // }
        download('debug.json', JSON.stringify(r));
    }
}
