import { USER_ROLES } from 'common';

function getRole(user) {
    if (user.isSystemUser || user.isSuperAdmin) {
        return USER_ROLES.SYSTEM_ADMIN;
    } else if (user.isCompanyAdmin) {
        return USER_ROLES.COMPANY_ADMIN;
    } else if (user.role) {
        return user.role;
    }
    return '';
}

/**
 * @function
 * @param {Object} data
 * @return {Object}
 * */
export function authDataAdapter(data) {
    return {
        ...data,
        role: getRole(data)
    };
}

/**
 * @function
 * @param {Object} data
 * @return {Object}
 * */
export function companyAccessAdapter(data) {
    return {
        ...data,
        role: getRole(data)
    };
}
