/**
 * @function
 * @param {Array<{ user_role: String, session_timeout: Number, account_expiration_timeout: Number, company_uid: String }>} uac
 * @return {Object}
 * */
export function userAccessControlResAdapter(uac) {
    return uac.map((item) => ({
        role: item.user_role,
        sessionTimeout: item.session_timeout || 0,
        accountExpirationTimeout: item.account_expiration_timeout || 0,
        companyUid: item.company_uid,
    }));
}

/**
 * @function
 * @param {Object} data
 * @property {String} data.role
 * @property {Number} data.userSessionTimeout
 * @property {Number} data.accountExpirationTimeout
 * @property {String} data.companyUid
 * @return {Object}
 * */
export function userAccessControlReqAdapter(data) {
    return {
        access_control: [
            {
                user_role: data.role,
                session_timeout: Number(data.sessionTimeout) || null,
                account_expiration_timeout: Number(data.accountExpirationTimeout) || null,
                company_uid: data.companyUid,
            }
        ]
    }
}
