import axios from 'axios';

export function getGroups() {
    return axios.get('/api/v2/groups/').then(({ data }) => data.groups || data);
}

export function replaceTrackableGroups(trackable, groupUids, noTrackableObjectUpdateNotify = false) {
    return axios.put(`/api/v2/trackable_objects/${trackable.uid}/groups?no_notify=${noTrackableObjectUpdateNotify}`, groupUids);
}

export function createGroup(params) {
    return axios.post('/api/v2/groups', params).then(({ data }) => data);
}

export function updateGroup(params) {
    return axios.put(`/api/v2/groups/${params.uid}`, params).then(({ data }) => data);
}

export function deleteGroup(uid) {
    return axios.delete(`/api/v2/groups/${uid}`);
}
