import axios from 'axios';

export function getProjects() {
    return axios.get('/api/v2/projects/').then(res => res.data.projects);
}

export function createProject(project) {
    return axios.post('/api/v2/projects/', project).then(res => res.data.project || res.data);
}

export function updateProject(project, uid) {
    return axios.put(`/api/v2/projects/${uid}`, project).then(res => res.data.project || res.data);
}

export function deleteProject(uid) {
    return axios.delete(`/api/v2/projects/${uid}`).then(res => res.data);
}
