import axios from 'axios';

export function getSubscribers() {
    return axios.get('/api/v2/subscribers/').then(({ data }) => data.subscribers || data);
}

export function getSystemNotificationSubscribers() {
    return axios.get('/api/v2/system_notifications/').then(({ data }) => data.systemNotificationSubscriber || data);
}

export function updateSystemNotificationSubscribers(user_uid, notification) {
    return axios.put('/api/v2/system_notifications/', {
        user_uid,
        notifications: [notification],
    }).then(({ data }) => data.systemNotificationSubscriber || data);
}

/**
 *
 * @param params {Object}
 * @param params.uid {?string}
 * @param params.name {string}
 * @param params.addresses {Object}
 * @param params.addresses.email {string}
 * @param params.addresses.phone {string}
 * @param params.notifications {Array<string>}
 */
export function createSubscriber(params) {
    return axios.post('/api/v2/subscribers/', params).then(res => res.data);
}

export function updateSubscriber(params) {
    const { uid } = params;
    return axios.put(`/api/v2/subscribers/${uid}`, params).then(res => res.data);
}

export function deleteSubscriber(params) {
    return axios.delete(`/api/v2/subscribers/${params.uid}`).then(res => res.data);
}
