import axios from 'axios';

export function getZones() {
    return axios.get('api/v2/zones/').then(({ data }) => {
        data.zones = data.zones.map(zone => zone);
        return data.zones || data;
    });
}

export function getCustomZonesPrototypes() {
    return axios.get('api/v2/custom_zones_prototypes/').then(({ data }) => {
        data.custom_zones_prototypes = data.custom_zones_prototypes.map(zone => zone);
        return data.custom_zones_prototypes || data;
    });
}

export function getZonesIncludeRemoved(params) {
    const from = params.playFrom;
    const to = params.playTo;
    return axios.get(`api/v2/zones/?include_removed=true&from=${from}&to=${to}`).then(({ data }) => {
        data.zones = data.zones.map(zone => zone);
        return data.zones || data;
    });
}

export function createZone(zone) {
    return axios.post('api/v2/zones', zone).then(({ data }) => data.zone || data);
}

export function updateZone(uid, zone) {
    return axios.put(`api/v2/zones/${uid}`, zone).then(({ data }) => data.zone || data);
}

export function deleteZone(uid) {
    return axios.delete(`api/v2/zones/${uid}`);
}
