import { WORKER_METHODS } from 'worker/common/constants';
import SpaghettiError from '../../js/stores/classes/SpaghettiError';


export default class SpaghettiNotifyMethods {
    notifyClientAboutError = (error) => {
        self.postMessage({
            type: WORKER_METHODS.SPAGHETTI_ERROR,
            params: error,
        });
    };
    
    sendDataToClient = (plist) => {
        if (!this.spaghetti[plist.spaghettiId]) {
            this.notifyClientAboutError(new SpaghettiError());
        } else {
            self.postMessage({
                type: WORKER_METHODS.SPAGHETTI_POSITIONS,
                params: plist,
            });
        }
    };
    
    sendSpaghettiParamsToClient = (spaghettiId, options) => {
        self.postMessage({
            type: WORKER_METHODS.SET_SPAGHETTI_ID,
            params: { spaghettiId, options },
        });
    };
}
