import { getDistanceBetweenPointsInMm } from 'worker/utils';
import Position from '../../../js/stores/classes/Position';


export function distanceBetween(lastPosition, currentPosition) {
    return getDistanceBetweenPointsInMm(lastPosition, currentPosition);
}

export function formatRawPos(pos) {
    return { x: Number(pos.x), y: Number(pos.y), ts: Number(pos.ts) };
}

export function formatPosition(pos, sublocation) {
    const position = new Position(pos, sublocation);
    return {
        lng: position.lng,
        lat: position.lat,
        distance: pos.distance,
        deltaDistance: pos.deltaDistance,
        ts: pos.ts,
    };
}

export function formatIdlePosition(pos, sublocation) {
    const position = new Position(pos, sublocation);
    return {
        lng: position.lng,
        lat: position.lat,
        idle: pos.idle,
        ts: pos.ts,
    };
}
